theory HeaplessStrongestPostcondition
  imports HeaplessProgramCommands
begin

lemma sp_seq_aux:
  "{s''. \<exists>s\<in>p. (s, s'')\<in>\<lbrakk>Seq C\<^sub>1 C\<^sub>2\<rbrakk>} = {s''. \<exists>s'\<in>{s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>C\<^sub>1\<rbrakk>}. (s', s'')\<in>\<lbrakk>C\<^sub>2\<rbrakk>}"
proof(-)
  have "{s''. \<exists>s\<in>p. (s, s'')\<in>\<lbrakk>Seq C\<^sub>1 C\<^sub>2\<rbrakk>} = {s''. \<exists>s\<in>p. \<exists>s'. (s, s')\<in>\<lbrakk>C\<^sub>1\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<^sub>2\<rbrakk>}" using dsem_seq by blast
  then show ?thesis by blast
qed

lemma sp_if_aux:
  "{s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>C\<^sub>1\<rbrakk>} \<union> {s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>C\<^sub>2\<rbrakk>} = {s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>If C\<^sub>1 C\<^sub>2\<rbrakk>}"
  using dsem_if by blast

lemma sp_while_aux:
  "{s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>Skip\<rbrakk>} \<union> {s''. \<exists>s'\<in>{s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>While C\<rbrakk>}. (s', s'')\<in>\<lbrakk>C\<rbrakk>} = {s'| s s'. s\<in>p \<and> (s, s')\<in>\<lbrakk>While C\<rbrakk>}" (is "?X \<union> ?Y = ?Z")
proof(-)
  have "?Y = {s''| s s' s''. s\<in>p \<and> (s, s')\<in>\<lbrakk>While C\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<rbrakk>}" by blast
  moreover have "{s''| s s' s''. s\<in>p \<and> (s, s')\<in>\<lbrakk>While C\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<rbrakk>} = {s''| s s' s''. \<exists>n. s\<in>p \<and> (s, s')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<rbrakk>}" by (metis (mono_tags, lifting) dsem_char while_iff_union_iter)
  ultimately have "?Y = {s''| s s' s''. \<exists>n. s\<in>p \<and> (s, s')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<rbrakk>}" by argo
  moreover have "\<And>s s' s'' n. (s, s')\<in>\<lbrakk>iter C n\<rbrakk> \<Longrightarrow> (s', s'')\<in>\<lbrakk>C\<rbrakk> \<Longrightarrow> (s, s'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk>" using dsem_char iter_combine by blast
  moreover have "\<And>s s' s'' n. (s, s'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk> \<Longrightarrow> \<exists>s'. (s, s')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (s', s'')\<in>\<lbrakk>C\<rbrakk>" by (simp add: iter_breakdown dsem_char)
  ultimately have "?Y = {s''| s s'' n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk>}" by (smt (verit, ccfv_threshold) Collect_cong)
  moreover have "?X = {s''| s s'' n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C 0\<rbrakk>}" by auto
  ultimately have "?X \<union> ?Y = {s''| s s'' n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C 0\<rbrakk>\<union>\<lbrakk>iter C (Suc n)\<rbrakk>}" by auto
  then have "?X \<union> ?Y = {s''| s s''. \<exists>n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C 0\<rbrakk>\<union>\<lbrakk>iter C (Suc n)\<rbrakk>}" by auto
  moreover have "?Z = {s''| s s'' n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C n\<rbrakk>}" using dsem_char while_iff_union_iter by meson
  then have "?Z = {s''| s s''. \<exists>n. s\<in>p \<and> (s, s'')\<in>\<lbrakk>iter C n\<rbrakk>}" by simp
  moreover have "\<And>s s''. (\<exists>n. (s, s'')\<in>\<lbrakk>iter C n\<rbrakk>) \<longleftrightarrow> (\<exists>n'. (s, s'')\<in>\<lbrakk>iter C 0\<rbrakk> \<or> (s, s'')\<in>\<lbrakk>iter C (Suc n')\<rbrakk>)" by (metis old.nat.exhaust)
  ultimately show ?thesis by force 
qed

definition sp :: "('var, 'val) state set \<Rightarrow> ('var, 'val) cmd \<Rightarrow> ('var, 'val) state set" where
  "sp p C = {s'. \<exists>s\<in>p. (s, s')\<in>\<lbrakk>C\<rbrakk>}"

lemma "sp (p\<union>p') C = sp p C \<union> sp p' C" unfolding sp_def by blast

lemma sp_skip: "sp p Skip = p" 
  unfolding sp_def dsem_skip by force

lemma sp_assign: "sp p (Assign x e) = {s(x:=e s)| s. s\<in>p}"
  unfolding sp_def dsem_assign by blast

lemma sp_havoc: "sp p (Havoc x) = {s(x:=n)| s n. s\<in>p}"
  unfolding sp_def dsem_havoc by blast

lemma sp_assume: "sp p (Assume b) = p\<inter>b"
  unfolding sp_def dsem_assume by force

lemma sp_seq: "sp p (Seq C\<^sub>1 C\<^sub>2) = sp (sp p C\<^sub>1) C\<^sub>2"
  unfolding sp_def sp_seq_aux by blast

lemma sp_if: "sp p (If C\<^sub>1 C\<^sub>2) = sp p C\<^sub>1 \<union> sp p C\<^sub>2"
  unfolding sp_def sp_if_aux by blast

lemma sp_while: "sp p (While C) = p \<union> sp (sp p (While C)) C"
  using sp_def sp_while_aux sp_skip by metis

lemma sp_while_2:
  "sp p (While C) = (\<Union>n. sp p (iter C n))"
  unfolding sp_def using dsem_while[of C] by (smt (verit, del_insts) Collect_cong UNION_eq mem_Collect_eq)

lemma sp_properties:
  "sp p Skip = p"
  "sp p (Assign x e) = {s(x:=e s)| s. s\<in>p}"
  "sp p (Havoc x) = {s(x:=n)| s n. s\<in>p}"
  "sp p (Assume b) = p\<inter>b"
  "sp p (Seq C\<^sub>1 C\<^sub>2) = sp (sp p C\<^sub>1) C\<^sub>2"
  "sp p (If C\<^sub>1 C\<^sub>2) = sp p C\<^sub>1 \<union> sp p C\<^sub>2"
  "sp p (While C) = p \<union> sp (sp p (While C)) C"
  "sp p (While C) = (\<Union>n. sp p (iter C n))"
  unfolding sp_skip apply simp
  unfolding sp_assign apply simp
  unfolding sp_havoc apply simp
  unfolding sp_assume apply simp
  unfolding sp_seq apply simp
  unfolding sp_if apply simp
  using sp_while apply auto[1]
  using sp_while_2 by auto

lemma sp_iter:
  "sp p (iter C (Suc n)) = sp (sp p (iter C n)) C"
  "sp p (iter C (Suc n)) = sp (sp p C) (iter C n)"
  unfolding sp_def apply (metis add_Seq_to_iterR sp_seq_aux) by (simp add: sp_seq_aux)

(*definition HL_triple :: "('var, 'val) state set \<Rightarrow> ('var, 'val) cmd \<Rightarrow> ('var, 'val) state set \<Rightarrow> bool" ("\<Turnstile> {_} _ {_}" [0,0,0] 81) where
  "\<Turnstile> {p} C {q} \<longleftrightarrow> (\<forall>s\<in>p. \<forall>s'. ((s,s')\<in>\<lbrakk>C\<rbrakk> \<longrightarrow> s'\<in>q))"

lemma HL_triple_sp: "\<Turnstile> {p} C {sp p C}"
  unfolding HL_triple_def sp_def by blast

lemma sp_indeed_strongest:
  "\<Turnstile> {p} C {q} \<longleftrightarrow> sp p C\<subseteq>q"
  unfolding HL_triple_def sp_def by blast*)

(*definition wlp :: "('var, 'val) state set \<Rightarrow> ('var, 'val) cmd \<Rightarrow> ('var, 'val) state set" where
  "wlp q C = {s. \<forall>s'. (s, s')\<in>\<lbrakk>C\<rbrakk> \<longrightarrow> s'\<in>q}"

lemma "\<Turnstile> {p} C {q} \<longleftrightarrow> p\<subseteq>wlp q C"
  unfolding HL_triple_def wlp_def by blast

lemma "p\<subseteq>wlp q C \<longleftrightarrow> sp p C\<subseteq>q"
  unfolding sp_def wlp_def by blast*)

lemma sp_frame:
  assumes "\<And>s x n. s\<in>f \<Longrightarrow> x\<in>md C \<Longrightarrow> s(x:=n)\<in>f"
    shows "sp (p\<inter>f) C = (sp p C)\<inter>f"
  using assms
proof(induction C arbitrary: p)
  case (Assign x e)
  have "{s(x:=e s)| s. s\<in>p}\<inter>f \<subseteq> {s(x:=e s)| s. s\<in>p\<inter>f}"
  proof
    fix s'
    assume asm: "s'\<in>{s(x:=e s)| s. s\<in>p}\<inter>f"
    then obtain s where s_def: "s\<in>p" "s'=s(x:=e s)" by blast
    then have "\<exists>n. s=s'(x:=n)" by fastforce
    then have "s\<in>f" using asm Assign.prems by fastforce
    then show "s'\<in>{s(x:=e s)| s. s\<in>p\<inter>f}" using s_def by fast
  qed
  then show ?case using Assign.prems unfolding sp_assign by fastforce
next
  case (Seq C\<^sub>1 C\<^sub>2)
  then show ?case unfolding sp_seq by simp
next
  case (If C\<^sub>1 C\<^sub>2)
  then show ?case unfolding sp_if by auto
next
  case Skip
  then show ?case unfolding sp_skip by blast
next
  case (Havoc x)
  have "{s(x:=n)| s n. s\<in>p}\<inter>f \<subseteq> {s(x:=n)| s n. s\<in>p\<inter>f}"
  proof
    fix s'
    assume asm: "s'\<in>{s(x:=n)| s n. s\<in>p}\<inter>f"
    then obtain s n where s_def: "s\<in>p" "s'=s(x:=n)" by blast
    then have "\<exists>n. s=s'(x:=n)" by fastforce
    then have "s\<in>f" using asm Havoc.prems by fastforce
    then show "s'\<in>{s(x:=n)| s n. s\<in>p\<inter>f}" using s_def by fast
  qed
  then show ?case using Havoc.prems unfolding sp_havoc by fastforce
next
  case (Assume x)
  then show ?case by (simp add: inf_commute inf_left_commute sp_assume)
next
  case (While C)
  have "\<And>n. sp (p \<inter> f) (iter C n) = sp p (iter C n) \<inter> f"
  proof(-)
    fix n
    show "sp (p \<inter> f) (iter C n) = sp p (iter C n) \<inter> f"
    proof(induction n)
      case 0
      then show ?case by (simp add: sp_skip)
    next
      case (Suc n)
      moreover have "\<And>p. sp (p \<inter> f) C = sp p C \<inter> f" using While.IH While.prems by auto
      ultimately show ?case unfolding iter.simps(2) sp_seq by (metis sp_iter sp_iter)
    qed
  qed
  then have "\<And>n. {s'. \<exists>s\<in>p \<inter> f. (s, s') \<in> \<lbrakk>iter C n\<rbrakk>} = {s'. \<exists>s\<in>p. (s, s') \<in> \<lbrakk>iter C n\<rbrakk>} \<inter> f" unfolding sp_def by presburger
  then have "{s'. \<exists>s\<in>p \<inter> f. (s, s') \<in> (\<Union>n. \<lbrakk>iter C n\<rbrakk>)} = {s'. \<exists>s\<in>p. (s, s') \<in> (\<Union>n. \<lbrakk>iter C n\<rbrakk>)} \<inter> f" by blast
  then show ?case unfolding sp_def by (simp add: dsem_while)
qed

end