theory HyperStarDet
  imports Star
begin

definition join :: "hassertion \<Rightarrow> hassertion \<Rightarrow> hassertion" (infix "\<otimes>" 52) where
 "P \<otimes> Q = {S\<^sub>P\<union>S\<^sub>Q| S\<^sub>P S\<^sub>Q. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q}"

definition join_indexed :: "'c set \<Rightarrow> ('c \<Rightarrow> hassertion) \<Rightarrow> hassertion" ("\<Otimes>\<^sub>_ _" [51,51] 81) where
 "\<Otimes>\<^sub>I Ps = {(\<Union>i\<in>I. f i)| f. \<forall>i\<in>I. f i\<in>Ps i}"

lemma join_unit: "P\<otimes>{{}}=P" unfolding join_def by auto

lemma join_comm: "P\<otimes>Q=Q\<otimes>P" unfolding join_def by blast

lemma join_assoc: "P\<otimes>(Q\<otimes>R)=(P\<otimes>Q)\<otimes>R"
proof(-)
  have "P\<otimes>(Q\<otimes>R) = {S\<^sub>P\<union>S\<^sub>Q\<^sub>R |S\<^sub>P S\<^sub>Q\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<^sub>R\<in>{S\<^sub>Q\<union>S\<^sub>R |S\<^sub>Q S\<^sub>R. S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}}" unfolding join_def by blast
  moreover have "... = {S\<^sub>P\<union>S\<^sub>Q\<^sub>R |S\<^sub>P S\<^sub>Q\<^sub>R S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<^sub>R=S\<^sub>Q\<union>S\<^sub>R \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by force
  moreover have "... = {S\<^sub>P\<union>(S\<^sub>Q\<union>S\<^sub>R) |S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by blast
  moreover have "... = {(S\<^sub>P\<union>S\<^sub>Q)\<union>S\<^sub>R |S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by auto
  moreover have "... = {S\<^sub>P\<^sub>Q\<union>S\<^sub>R |S\<^sub>P\<^sub>Q S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q \<and> S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by force
  moreover have "... = {S\<^sub>P\<^sub>Q\<union>S\<^sub>R |S\<^sub>P\<^sub>Q S\<^sub>R. S\<^sub>P\<^sub>Q\<in>{S\<^sub>P\<union>S\<^sub>Q |S\<^sub>P S\<^sub>Q. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q} \<and> S\<^sub>R\<in>R}" by auto
  moreover have "... = (P\<otimes>Q)\<otimes>R" unfolding join_def by blast
  ultimately show ?thesis by argo
qed

definition Pure :: "hassertion \<Rightarrow> bool" where
  "Pure P \<equiv> \<forall>S\<in>P. \<forall>S'. (\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S') \<and> (\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S) \<longrightarrow> S'\<in>P"

definition Intu :: "hassertion \<Rightarrow> bool" where
  "Intu P \<equiv> \<forall>S\<in>P. \<forall>S'. (\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S') \<and> (\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S) \<longrightarrow> S'\<in>P"

lemma PureI:
  assumes "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S \<Longrightarrow> S'\<in>P"
    shows "Pure P"
  using assms unfolding Pure_def by blast

lemma IntuI:
  assumes "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P"
    shows "Intu P"
  using assms unfolding Intu_def by blast

lemma Pure_implies_Intu:
  assumes "Pure P"
  shows "Intu P"
proof(rule IntuI)
  fix S S'
  assume "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S"
  then have "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S" by auto
  then show "S'\<in>P" using assms unfolding Pure_def by blast
qed

definition left_lives :: "assertion \<Rightarrow> assertion \<Rightarrow> assertion \<Rightarrow> bool"  where
 "left_lives S S\<^sub>1 S\<^sub>2 \<equiv> \<forall>\<sigma>\<^sub>1\<in>S\<^sub>1. \<exists>\<sigma>\<^sub>2\<in>S\<^sub>2. \<exists>\<sigma>\<in>S. hAdd \<sigma> \<sigma>\<^sub>1 \<sigma>\<^sub>2"

definition right_lives :: "assertion \<Rightarrow> assertion \<Rightarrow> assertion \<Rightarrow> bool"  where
 "right_lives S S\<^sub>1 S\<^sub>2 \<longleftrightarrow> left_lives S S\<^sub>2 S\<^sub>1"

definition hstar :: "hassertion \<Rightarrow> hassertion \<Rightarrow> hassertion" (infix "\<star>" 52) where
 "P \<star> Q = {S| S S\<^sub>P S\<^sub>Q. S=S\<^sub>P\<^emph>S\<^sub>Q \<and> S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> left_lives S S\<^sub>P S\<^sub>Q \<and> right_lives S S\<^sub>P S\<^sub>Q}"

lemma left_livesI:
  assumes "\<And>s h\<^sub>1. (s, h\<^sub>1)\<in>S\<^sub>1 \<Longrightarrow> \<exists>h h\<^sub>2. (s, h)\<in>S \<and> (s, h\<^sub>2)\<in>S\<^sub>2 \<and> hAdd (s, h) (s, h\<^sub>1) (s, h\<^sub>2)"
    shows "left_lives S S\<^sub>1 S\<^sub>2"
  using assms unfolding left_lives_def by fast

lemma left_lives_mono: "left_lives S S\<^sub>1' S\<^sub>2 \<Longrightarrow> S\<subseteq>S' \<Longrightarrow> S\<^sub>1\<subseteq>S\<^sub>1' \<Longrightarrow> S\<^sub>2\<subseteq>S\<^sub>2' \<Longrightarrow> left_lives S' S\<^sub>1 S\<^sub>2'" unfolding left_lives_def by blast

lemma right_lives_equiv: "right_lives S S\<^sub>1 S\<^sub>2 \<longleftrightarrow> (\<forall>\<sigma>\<^sub>2\<in>S\<^sub>2. \<exists>\<sigma>\<^sub>1\<in>S\<^sub>1. \<exists>\<sigma>\<in>S. hAdd \<sigma> \<sigma>\<^sub>1 \<sigma>\<^sub>2)"
  unfolding right_lives_def left_lives_def using hAdd_comm by auto

lemma right_livesI:
  assumes "\<And>s h\<^sub>2. (s, h\<^sub>2)\<in>S\<^sub>2 \<Longrightarrow> \<exists>h h\<^sub>1. (s, h)\<in>S \<and> (s, h\<^sub>1)\<in>S\<^sub>1 \<and> hAdd (s, h) (s, h\<^sub>1) (s, h\<^sub>2)"
    shows "right_lives S S\<^sub>1 S\<^sub>2"
  using assms unfolding right_lives_equiv by fast

lemma right_lives_mono: "right_lives S S\<^sub>1 S\<^sub>2' \<Longrightarrow> S\<subseteq>S' \<Longrightarrow> S\<^sub>1\<subseteq>S\<^sub>1' \<Longrightarrow> S\<^sub>2\<subseteq>S\<^sub>2' \<Longrightarrow> right_lives S' S\<^sub>1' S\<^sub>2" unfolding right_lives_equiv by blast

lemma hstarI:
  assumes "S=S\<^sub>P\<^emph>S\<^sub>Q"
      and "S\<^sub>P\<in>P"
      and "S\<^sub>Q\<in>Q"
      and "left_lives S S\<^sub>P S\<^sub>Q"
      and "right_lives S S\<^sub>P S\<^sub>Q"
    shows "S\<in>P\<star>Q"
  using assms hstar_def by auto

(*Property 1*)
lemma hstar_unit:
  "P\<star>{S. S\<subseteq>{(s, fmap_empty)| s. True}}=P" (is "P\<star>?U=P")
proof
  show "P\<star>?U\<subseteq>P"
  proof
    fix S
    assume "S\<in>P\<star>?U"
    then obtain S\<^sub>P S\<^sub>U where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>U" "S\<^sub>P\<in>P" "S\<^sub>U\<in>?U" "left_lives S S\<^sub>P S\<^sub>U" "right_lives S S\<^sub>P S\<^sub>U" unfolding hstar_def by blast
    have "S=S\<^sub>P" 
    proof
      show "S\<subseteq>S\<^sub>P" by (metis (no_types, lifting) \<open>S \<subseteq> S\<^sub>P \<^emph> S\<^sub>U\<close> \<open>S\<^sub>U \<in> {S. S \<subseteq> {(s, fmap_empty) |s. True}}\<close> mem_Collect_eq order_refl order_trans star_mono star_unit)
      show "S\<^sub>P\<subseteq>S"
      proof(-)
        have "\<And>s h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P \<Longrightarrow> (s, h\<^sub>P)\<in>S"
        proof(-)
          fix s h\<^sub>P
          assume "(s, h\<^sub>P)\<in>S\<^sub>P"
          then obtain \<sigma> \<sigma>\<^sub>U where "\<sigma>\<in>S" "\<sigma>\<^sub>U\<in>S\<^sub>U" "hAdd \<sigma> (s, h\<^sub>P) \<sigma>\<^sub>U" using \<open>left_lives S S\<^sub>P S\<^sub>U\<close> unfolding left_lives_def by auto
          then obtain h h\<^sub>U where "\<sigma>=(s, h)" "\<sigma>\<^sub>U=(s, h\<^sub>U)" "(s, h)\<in>S" "(s, h\<^sub>U)\<in>S\<^sub>U" "h=h\<^sub>P++\<^sub>fh\<^sub>U" "h\<^sub>P\<bottom>h\<^sub>U" unfolding hAdd_def by (metis fst_conv prod.exhaust_sel snd_conv)
          then have "h=h\<^sub>P" using \<open>S\<^sub>U\<in>?U\<close> fmap_add_empty by blast
          then show "(s, h\<^sub>P)\<in>S" using \<open>(s, h)\<in>S\<close> by auto
        qed
        then show ?thesis by force
      qed
    qed
    then show "S\<in>P" using \<open>S\<^sub>P\<in>P\<close> by fastforce
  qed
  show "P\<subseteq>P\<star>?U"
  proof
    fix S
    assume "S\<in>P"
    obtain S\<^sub>U where S\<^sub>U_def: "S\<^sub>U = ({(s, fmap_empty)| s h. (s, h)\<in>S} :: assertion)" "S\<^sub>U\<in>?U" by auto
    moreover have "S\<subseteq>S\<^emph>S\<^sub>U"
    proof(-)
      have "\<And>s h. (s, h)\<in>S \<Longrightarrow> (s, h)\<in>S\<^emph>S\<^sub>U"
      proof(-)
        fix s h
        assume asm: "(s, h)\<in>S"
        then have "(s, fmap_empty)\<in>S\<^sub>U" unfolding S\<^sub>U_def by blast
        moreover have "hAdd (s, h) (s, h) (s, fmap_empty)" unfolding hAdd_def compat_def by simp
        ultimately show "(s, h)\<in>S\<^emph>S\<^sub>U" using asm \<open>(s, fmap_empty)\<in>S\<^sub>U\<close> unfolding star_def using hAdd_prop by blast
      qed
      then show ?thesis by auto
    qed
    moreover have "S\<^emph>S\<^sub>U\<subseteq>S" unfolding star_def using calculation(1) by auto
    moreover have "left_lives S S S\<^sub>U" unfolding left_lives_def S\<^sub>U_def hAdd_def compat_def apply simp by (metis prod.collapse)
    moreover have "right_lives S S S\<^sub>U" unfolding right_lives_equiv S\<^sub>U_def hAdd_def compat_def apply simp by (metis fstI)
    ultimately show "S\<in>P\<star>?U" using \<open>S\<in>P\<close> unfolding hstar_def by fast
  qed
qed

(*Property 2*)
lemma hstar_comm: "P\<star>Q=Q\<star>P"
  unfolding hstar_def using right_lives_def star_comm apply simp by blast

(*Property 3 - fails*)
lemma hstar_via_triples:
  "P\<star>Q = {S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>) \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
proof
  show "P\<star>Q \<subseteq> {S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>) \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
  proof
    fix S
    assume "S\<in>P\<star>Q"
    then obtain S\<^sub>P S\<^sub>Q where S\<^sub>PS\<^sub>Q_def: "S=S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" using hstar_def by auto
    obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>S\<^sub>P \<and> \<sigma>\<^sub>Q\<in>S\<^sub>Q \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q}" by auto
    then have "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" by blast
    moreover have "fst`\<tau>=S"
    proof
      show "fst`\<tau>\<subseteq>S" using \<tau>_def by fastforce
      show "S\<subseteq>fst`\<tau>"
      proof
        fix \<sigma>
        assume asm: "\<sigma>\<in>S"
        moreover have "\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma>\<^sub>Q\<in>S\<^sub>Q. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(1-3) star_via_hAdd by fastforce
        ultimately obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q where \<sigma>\<^sub>P\<sigma>\<^sub>Q_def: "\<sigma>\<^sub>P\<in>S\<^sub>P" "\<sigma>\<^sub>Q\<in>S\<^sub>Q" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" by blast
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<in>fst`\<tau>" by force
      qed
    qed
    moreover have "fst`snd`\<tau>=S\<^sub>P"
    proof
      show "fst`snd`\<tau>\<subseteq>S\<^sub>P" using \<tau>_def by fastforce
      show "S\<^sub>P\<subseteq>fst`snd`\<tau>"
      proof
        fix \<sigma>\<^sub>P
        assume asm: "\<sigma>\<^sub>P\<in>S\<^sub>P"
        then obtain \<sigma> \<sigma>\<^sub>Q where \<sigma>\<sigma>\<^sub>Q_def: "\<sigma>\<in>S" "\<sigma>\<^sub>Q\<in>S\<^sub>Q" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(2-4) left_lives_def by auto
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>" by force
      qed
    qed
    then have "fst`snd`\<tau>\<in>P" using S\<^sub>PS\<^sub>Q_def(2) by blast
    moreover have "snd`snd`\<tau>=S\<^sub>Q"
    proof
      show "snd`snd`\<tau>\<subseteq>S\<^sub>Q" using \<tau>_def by fastforce
      show "S\<^sub>Q\<subseteq>snd`snd`\<tau>"
      proof
        fix \<sigma>\<^sub>Q
        assume asm: "\<sigma>\<^sub>Q\<in>S\<^sub>Q"
        then obtain \<sigma> \<sigma>\<^sub>P where \<sigma>\<sigma>\<^sub>P_def: "\<sigma>\<in>S" "\<sigma>\<^sub>P\<in>S\<^sub>P" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(2,3,5) right_lives_equiv by auto
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<^sub>Q\<in>snd`snd`\<tau>" by force
      qed
    qed
    then have "snd`snd`\<tau>\<in>Q" using S\<^sub>PS\<^sub>Q_def(3) by blast
    moreover have "fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" using S\<^sub>PS\<^sub>Q_def(1) \<open>fst`snd`\<tau>=S\<^sub>P\<close> \<open>snd`snd`\<tau>=S\<^sub>Q\<close> \<tau>_def calculation(2) star_via_hAdd by auto
    ultimately show "S\<in>{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>) \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}" by blast
  qed
  show "{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>) \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q} \<subseteq> P\<star>Q"
  proof
    fix S
    assume "S\<in>{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>) \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
    then obtain \<tau> where \<tau>_def: "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" "fst`\<tau>=S" "fst`snd`\<tau>\<in>P" "snd`snd`\<tau>\<in>Q" by blast
    then obtain S\<^sub>P S\<^sub>Q where S\<^sub>PS\<^sub>Q_def: "S=S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P=fst`snd`\<tau>" "S\<^sub>Q=snd`snd`\<tau>" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" by blast
    moreover have "left_lives S S\<^sub>P S\<^sub>Q" using \<tau>_def S\<^sub>PS\<^sub>Q_def left_lives_def by (smt (verit) case_prod_beta image_iff)
    moreover have "right_lives S S\<^sub>P S\<^sub>Q" using \<tau>_def S\<^sub>PS\<^sub>Q_def right_lives_equiv by (smt (verit) case_prod_beta image_iff)
    ultimately show "S\<in>P\<star>Q" unfolding hstar_def by blast
  qed
qed

(*Property 4*)
lemma hstar_mono: "P\<subseteq>P' \<Longrightarrow> Q\<subseteq>Q' \<Longrightarrow> P\<star>Q\<subseteq>P'\<star>Q'"
  unfolding hstar_def by blast

(*Property 5*)
lemma hstar_distr_over_union: "(P\<union>P')\<star>Q = (P\<star>Q) \<union> (P'\<star>Q)"
  unfolding hstar_def by auto

(*Property 6*)
lemma hstar_distr_over_indexed_union: "(\<Union>P\<in>X. P)\<star>Q = (\<Union>P\<in>X. P\<star>Q)"
proof
  show "(\<Union>P\<in>X. P)\<star>Q \<subseteq> (\<Union>P\<in>X. P\<star>Q)" using hstar_def by auto
  show "(\<Union>P\<in>X. P)\<star>Q \<supseteq> (\<Union>P\<in>X. P\<star>Q)" using hstar_mono by (metis (no_types, lifting) SUP_le_iff subsetI)
qed

(*Property 7*)
lemma hstar_distr_over_join:
  assumes "\<And>S S'. S\<in>F \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>F"
    shows "(P\<otimes>Q)\<star>F \<subseteq> (P\<star>F)\<otimes>(Q\<star>F)"
proof
  fix S
  assume "S\<in>(P\<otimes>Q)\<star>F"
  then obtain S\<^sub>P\<^sub>Q S\<^sub>F where "S=S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F" "S\<^sub>P\<^sub>Q\<in>P\<otimes>Q" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P\<^sub>Q S\<^sub>F" unfolding hstar_def by blast
  then obtain S\<^sub>P S\<^sub>Q where "S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" unfolding join_def by blast
  obtain \<tau>\<^sub>P\<^sub>F where \<tau>\<^sub>P\<^sub>F_def: "\<tau>\<^sub>P\<^sub>F = {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>S\<^sub>P \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F}" by blast
  moreover have "left_lives S S\<^sub>P S\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>left_lives S S\<^sub>P\<^sub>Q S\<^sub>F\<close> left_lives_def by auto
  then have "\<forall>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using \<open>S\<^sub>F\<in>F\<close> unfolding left_lives_def by blast
  have "fst`snd`\<tau>\<^sub>P\<^sub>F=S\<^sub>P"
  proof
    show "fst`snd`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<^sub>P" unfolding \<tau>\<^sub>P\<^sub>F_def by fastforce
    show "S\<^sub>P\<subseteq>fst`snd`\<tau>\<^sub>P\<^sub>F"
    proof
      fix \<sigma>\<^sub>P
      assume "\<sigma>\<^sub>P\<in>S\<^sub>P"
      then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>F" using \<open>\<forall>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> \<tau>\<^sub>P\<^sub>F_def by fast
      then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>\<^sub>P\<^sub>F" by force
    qed
  qed
  have "fst`\<tau>\<^sub>P\<^sub>F\<subseteq>S" "snd`snd`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<^sub>F" using \<tau>\<^sub>P\<^sub>F_def by auto
  then have "snd`snd`\<tau>\<^sub>P\<^sub>F\<in>F" using \<open>S\<^sub>F \<in> F\<close> assms by presburger
  moreover have "left_lives (fst`\<tau>\<^sub>P\<^sub>F) (fst`snd`\<tau>\<^sub>P\<^sub>F) (snd`snd`\<tau>\<^sub>P\<^sub>F)" using left_lives_def \<tau>\<^sub>P\<^sub>F_def apply simp by fast
  moreover have "right_lives (fst`\<tau>\<^sub>P\<^sub>F) (fst`snd`\<tau>\<^sub>P\<^sub>F) (snd`snd`\<tau>\<^sub>P\<^sub>F)" using right_lives_equiv \<tau>\<^sub>P\<^sub>F_def apply simp by fast
  moreover have "fst`\<tau>\<^sub>P\<^sub>F=(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)"
  proof
    show "fst`\<tau>\<^sub>P\<^sub>F\<subseteq>(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)" unfolding star_via_hAdd \<tau>\<^sub>P\<^sub>F_def by fastforce
    show "(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)\<subseteq>fst`\<tau>\<^sub>P\<^sub>F"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)"
      then obtain s h where "\<sigma>=(s, h)" "(s, h)\<in>(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)" by (metis prod.collapse)
      then obtain h\<^sub>P h\<^sub>F where "(s, h\<^sub>P)\<in>fst`snd`\<tau>\<^sub>P\<^sub>F" "(s, h\<^sub>F)\<in>snd`snd`\<tau>\<^sub>P\<^sub>F" "h=h\<^sub>P++\<^sub>fh\<^sub>F" "h\<^sub>P\<bottom>h\<^sub>F" unfolding star_def by blast
      then have "(s, h\<^sub>P)\<in>S\<^sub>P" "(s, h\<^sub>F)\<in>S\<^sub>F" unfolding \<tau>\<^sub>P\<^sub>F_def by auto
      moreover have "hAdd (s, h) (s, h\<^sub>P) (s, h\<^sub>F)" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>F\<close> \<open>h\<^sub>P\<bottom>h\<^sub>F\<close> unfolding hAdd_def by simp
      ultimately have "((s, h), (s, h\<^sub>P), (s, h\<^sub>F))\<in>\<tau>\<^sub>P\<^sub>F" unfolding \<tau>\<^sub>P\<^sub>F_def using \<open>S = S\<^sub>P\<^sub>Q \<^emph> S\<^sub>F\<close> \<open>S\<^sub>P\<^sub>Q = S\<^sub>P \<union> S\<^sub>Q\<close> star_via_hAdd by auto
      then show "\<sigma>\<in>fst`\<tau>\<^sub>P\<^sub>F" using \<open>\<sigma>=(s, h)\<close> by force
    qed
  qed
  ultimately have "fst`\<tau>\<^sub>P\<^sub>F\<in>P\<star>F" using hstarI \<open>S\<^sub>P\<in>P\<close> \<open>fst`snd`\<tau>\<^sub>P\<^sub>F=S\<^sub>P\<close> by simp

  obtain \<tau>\<^sub>Q\<^sub>F where \<tau>\<^sub>Q\<^sub>F_def: "\<tau>\<^sub>Q\<^sub>F = {(\<sigma>, \<sigma>\<^sub>Q, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>Q\<in>S\<^sub>Q \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F}" by blast
  moreover have "left_lives S S\<^sub>Q S\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>left_lives S S\<^sub>P\<^sub>Q S\<^sub>F\<close> left_lives_def by auto
  then have "\<forall>\<sigma>\<^sub>Q\<in>S\<^sub>Q. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F" unfolding left_lives_def by blast
  have "fst`snd`\<tau>\<^sub>Q\<^sub>F=S\<^sub>Q"
  proof
    show "fst`snd`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<^sub>Q" unfolding \<tau>\<^sub>Q\<^sub>F_def by fastforce
    show "S\<^sub>Q\<subseteq>fst`snd`\<tau>\<^sub>Q\<^sub>F"
    proof
      fix \<sigma>\<^sub>Q
      assume "\<sigma>\<^sub>Q\<in>S\<^sub>Q"
      then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>Q\<^sub>F" using \<open>\<forall>\<sigma>\<^sub>Q\<in>S\<^sub>Q. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F\<close> \<tau>\<^sub>Q\<^sub>F_def by fast
      then show "\<sigma>\<^sub>Q\<in>fst`snd`\<tau>\<^sub>Q\<^sub>F" by force
    qed
  qed
  have "fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>S" "snd`snd`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<^sub>F" using \<tau>\<^sub>Q\<^sub>F_def by auto
  then have "snd`snd`\<tau>\<^sub>Q\<^sub>F\<in>F" using \<open>S\<^sub>F \<in> F\<close> assms by presburger
  moreover have "left_lives (fst`\<tau>\<^sub>Q\<^sub>F) (fst`snd`\<tau>\<^sub>Q\<^sub>F) (snd`snd`\<tau>\<^sub>Q\<^sub>F)" using left_lives_def \<tau>\<^sub>Q\<^sub>F_def apply simp by fast
  moreover have "right_lives (fst`\<tau>\<^sub>Q\<^sub>F) (fst`snd`\<tau>\<^sub>Q\<^sub>F) (snd`snd`\<tau>\<^sub>Q\<^sub>F)" using right_lives_equiv \<tau>\<^sub>Q\<^sub>F_def apply simp by fast
  moreover have "fst`\<tau>\<^sub>Q\<^sub>F=(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)"
  proof
    show "fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)" unfolding star_via_hAdd \<tau>\<^sub>Q\<^sub>F_def by fastforce
    show "(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)\<subseteq>fst`\<tau>\<^sub>Q\<^sub>F"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)"
      then obtain s h where "\<sigma>=(s, h)" "(s, h)\<in>(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)" by (metis prod.collapse)
      then obtain h\<^sub>Q h\<^sub>F where "(s, h\<^sub>Q)\<in>fst`snd`\<tau>\<^sub>Q\<^sub>F" "(s, h\<^sub>F)\<in>snd`snd`\<tau>\<^sub>Q\<^sub>F" "h=h\<^sub>Q++\<^sub>fh\<^sub>F" "h\<^sub>Q\<bottom>h\<^sub>F" unfolding star_def by blast
      then have "(s, h\<^sub>Q)\<in>S\<^sub>Q" "(s, h\<^sub>F)\<in>S\<^sub>F" unfolding \<tau>\<^sub>Q\<^sub>F_def by auto
      moreover have "hAdd (s, h) (s, h\<^sub>Q) (s, h\<^sub>F)" using \<open>h=h\<^sub>Q++\<^sub>fh\<^sub>F\<close> \<open>h\<^sub>Q\<bottom>h\<^sub>F\<close> unfolding hAdd_def by simp
      ultimately have "((s, h), (s, h\<^sub>Q), (s, h\<^sub>F))\<in>\<tau>\<^sub>Q\<^sub>F" unfolding \<tau>\<^sub>Q\<^sub>F_def using \<open>S = S\<^sub>P\<^sub>Q \<^emph> S\<^sub>F\<close> \<open>S\<^sub>P\<^sub>Q = S\<^sub>P \<union> S\<^sub>Q\<close> star_via_hAdd by auto
      then show "\<sigma>\<in>fst`\<tau>\<^sub>Q\<^sub>F" using \<open>\<sigma>=(s, h)\<close> by force
    qed
  qed
  ultimately have "fst`\<tau>\<^sub>Q\<^sub>F\<in>Q\<star>F" using hstarI \<open>S\<^sub>Q\<in>Q\<close> \<open>fst`snd`\<tau>\<^sub>Q\<^sub>F=S\<^sub>Q\<close> by simp

  moreover have "(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)=S" 
  proof
    show "(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)\<subseteq>S" using \<open>fst`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<close> \<open>fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<close> by auto
    show "S\<subseteq>(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then have "\<sigma>\<in>S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F" using \<open>S=S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F\<close> by fast
      then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<^sub>Q\<in>S\<^sub>P\<^sub>Q" "\<sigma>\<^sub>F\<in>S\<^sub>F" "hAdd \<sigma> \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F" unfolding star_via_hAdd by blast
      then have "(\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>F \<or> (\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>Q\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>\<sigma>\<in>S\<close> \<tau>\<^sub>P\<^sub>F_def \<tau>\<^sub>Q\<^sub>F_def by blast
      then show "\<sigma>\<in>(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)" by force
    qed
  qed
  ultimately show "S\<in>(P\<star>F)\<otimes>(Q\<star>F)" using join_def \<open>fst`\<tau>\<^sub>P\<^sub>F\<in>P\<star>F\<close> by blast
qed

(*lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<supseteq>S \<Longrightarrow> S'\<in>Q"
    shows "(P\<union>Q)\<otimes>(P'\<union>Q) \<subseteq> (P\<otimes>P')\<union>Q"
(*using assms unfolding join_def by fastforce*)
proof
  fix S\<^sub>i\<^sub>n
  assume "S\<^sub>i\<^sub>n\<in>(P\<union>Q)\<otimes>(P'\<union>Q)"
  then obtain S S' where SS'_def: "S\<^sub>i\<^sub>n=S\<union>S'" "S\<in>P\<union>Q" "S'\<in>P'\<union>Q" unfolding join_def by blast
  moreover have "S\<in>P \<Longrightarrow> S'\<in>P' \<Longrightarrow> S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" using \<open>S\<^sub>i\<^sub>n=S\<union>S'\<close> unfolding join_def by blast
  moreover have "S\<notin>P \<or> S'\<notin>P' \<Longrightarrow> S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" using \<open>S\<^sub>i\<^sub>n=S\<union>S'\<close> assms SS'_def(2,3) by blast
  ultimately show "S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" by blast
qed

lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<in>Q \<Longrightarrow> S\<union>S'\<in>Q"
    shows "(P\<inter>Q)\<otimes>(P'\<inter>Q) \<subseteq> (P\<otimes>P')\<inter>Q"
proof
  fix S\<^sub>i\<^sub>n
  assume "S\<^sub>i\<^sub>n\<in>(P\<inter>Q)\<otimes>(P'\<inter>Q)"
  then obtain S S' where SS'_def: "S\<^sub>i\<^sub>n=S\<union>S'" "S\<in>P\<inter>Q" "S'\<in>P'\<inter>Q" unfolding join_def by blast
  then show "S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<inter>Q" using assms(1) unfolding join_def by blast
qed

lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>Q"
    shows "(P\<otimes>P')\<inter>Q \<subseteq> (P\<inter>Q)\<otimes>(P'\<inter>Q)"
  using assms unfolding join_def by blast*)

(*Property 8*)
lemma hstar_distr_over_indexed_join:
  assumes "\<And>S S'. S\<in>F \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>F"
    shows "(\<Otimes>\<^sub>I Ps)\<star>F \<subseteq> \<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)"
proof
  fix S
  assume "S\<in>(\<Otimes>\<^sub>I Ps)\<star>F"
  then obtain S\<^sub>P\<^sub>s S\<^sub>F where "S=S\<^sub>P\<^sub>s\<^emph>S\<^sub>F" "S\<^sub>P\<^sub>s\<in>\<Otimes>\<^sub>I Ps" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P\<^sub>s S\<^sub>F" unfolding hstar_def by blast
  then obtain g where g_def: "S\<^sub>P\<^sub>s=(\<Union>i\<in>I. g i)" "\<forall>i\<in>I. g i\<in>Ps i" unfolding join_indexed_def by blast
  obtain \<tau>\<^sub>P\<^sub>s where \<tau>\<^sub>P\<^sub>s_def: "\<tau>\<^sub>P\<^sub>s = (\<lambda>i. {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>g i \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F})" by blast
  moreover have "\<And>i. i\<in>I \<Longrightarrow> left_lives S (g i) S\<^sub>F" using \<open>left_lives S S\<^sub>P\<^sub>s S\<^sub>F\<close> g_def(1) left_lives_mono by blast
  then have "\<And>i. i\<in>I \<Longrightarrow> \<forall>\<sigma>\<^sub>P\<in>(g i). \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using \<open>S\<^sub>F\<in>F\<close> unfolding left_lives_def by blast
  have "\<And>i. i\<in>I \<Longrightarrow> fst`snd`(\<tau>\<^sub>P\<^sub>s i)=(g i)"
  proof
    fix i
    assume "i\<in>I"
    show "fst`snd`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>g i" unfolding \<tau>\<^sub>P\<^sub>s_def by fastforce
    moreover show "g i\<subseteq>fst`snd`(\<tau>\<^sub>P\<^sub>s i)"
    proof
      fix \<sigma>\<^sub>P
      assume "\<sigma>\<^sub>P\<in>g i"
      then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>s i" using \<open>\<And>i. i\<in>I \<Longrightarrow> \<forall>\<sigma>\<^sub>P\<in>g i. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> \<open>i\<in>I\<close> unfolding \<tau>\<^sub>P\<^sub>s_def by (smt (verit, best) mem_Collect_eq)
      then show "\<sigma>\<^sub>P\<in>fst`snd`(\<tau>\<^sub>P\<^sub>s i)" by force
    qed
  qed
  have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S" "\<And>i. i\<in>I \<Longrightarrow> snd`snd`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S\<^sub>F" using \<tau>\<^sub>P\<^sub>s_def by auto
  then have "\<And>i. i\<in>I \<Longrightarrow> snd`snd`(\<tau>\<^sub>P\<^sub>s i)\<in>F" using \<open>S\<^sub>F\<in>F\<close> assms by meson
  moreover have "\<And>i. i\<in>I \<Longrightarrow> left_lives (fst`(\<tau>\<^sub>P\<^sub>s i)) (fst`snd`(\<tau>\<^sub>P\<^sub>s i)) (snd`snd`(\<tau>\<^sub>P\<^sub>s i))" using left_lives_def \<tau>\<^sub>P\<^sub>s_def apply simp by fast
  moreover have "\<And>i. i\<in>I \<Longrightarrow> right_lives (fst`(\<tau>\<^sub>P\<^sub>s i)) (fst`snd`(\<tau>\<^sub>P\<^sub>s i)) (snd`snd`(\<tau>\<^sub>P\<^sub>s i))" using right_lives_equiv \<tau>\<^sub>P\<^sub>s_def apply simp by fast
  moreover have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)=(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))"
  proof(-)
    fix i
    assume "i\<in>I"
    show "fst`(\<tau>\<^sub>P\<^sub>s i)=(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))"
    proof
      show "fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))" unfolding star_via_hAdd \<tau>\<^sub>P\<^sub>s_def by fastforce
      show "(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))\<subseteq>fst`(\<tau>\<^sub>P\<^sub>s i)"
      proof
        fix \<sigma>
        assume "\<sigma>\<in>(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))"
        then obtain s h where "\<sigma>=(s, h)" "(s, h)\<in>(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))" by (metis prod.collapse)
        then obtain h\<^sub>P h\<^sub>F where "(s, h\<^sub>P)\<in>fst`snd`(\<tau>\<^sub>P\<^sub>s i)" "(s, h\<^sub>F)\<in>snd`snd`(\<tau>\<^sub>P\<^sub>s i)" "h=h\<^sub>P++\<^sub>fh\<^sub>F" "h\<^sub>P\<bottom>h\<^sub>F" unfolding star_def by blast
        then have "(s, h\<^sub>P)\<in>g i" "(s, h\<^sub>F)\<in>S\<^sub>F" unfolding \<tau>\<^sub>P\<^sub>s_def by auto
        moreover have "hAdd (s, h) (s, h\<^sub>P) (s, h\<^sub>F)" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>F\<close> \<open>h\<^sub>P\<bottom>h\<^sub>F\<close> unfolding hAdd_def by simp
        ultimately have "((s, h), (s, h\<^sub>P), (s, h\<^sub>F))\<in>\<tau>\<^sub>P\<^sub>s i" unfolding \<tau>\<^sub>P\<^sub>s_def using \<open>S=S\<^sub>P\<^sub>s\<^emph>S\<^sub>F\<close> \<open>S\<^sub>P\<^sub>s=(\<Union>i\<in>I. g i)\<close> star_via_hAdd \<open>i\<in>I\<close> by auto
        then show "\<sigma>\<in>fst`\<tau>\<^sub>P\<^sub>s i" using \<open>\<sigma>=(s, h)\<close> by force
      qed
    qed
  qed
  ultimately have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<in>Ps i\<star>F" using g_def(2) \<open>\<And>i. i\<in>I \<Longrightarrow> fst`snd`\<tau>\<^sub>P\<^sub>s i=g i\<close> hstarI[where ?Q=F] by simp

  moreover have "(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))=S" 
  proof
    show "(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))\<subseteq>S" using \<open>\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S\<close> by blast
    show "S\<subseteq>(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then have "\<sigma>\<in>S\<^sub>P\<^sub>s\<^emph>S\<^sub>F" using \<open>S=S\<^sub>P\<^sub>s\<^emph>S\<^sub>F\<close> by fast
      then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<^sub>Q\<in>S\<^sub>P\<^sub>s" "\<sigma>\<^sub>F\<in>S\<^sub>F" "hAdd \<sigma> \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F" unfolding star_via_hAdd by blast
      then have "\<exists>i\<in>I. (\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>(\<tau>\<^sub>P\<^sub>s i)" using g_def(1) \<open>\<sigma>\<in>S\<close> \<tau>\<^sub>P\<^sub>s_def by blast
      then show "\<sigma>\<in>(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))" by force
    qed
  qed

  ultimately show "S\<in>\<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)" unfolding join_indexed_def by blast
qed

(*Property 9*)
lemma hstar_sub_inter:
  assumes "Intu P"
      and "Intu Q"
    shows "P\<star>Q \<subseteq> P\<inter>Q"
proof
  fix S
  assume "S\<in>P\<star>Q"
  then obtain S\<^sub>P S\<^sub>Q where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" unfolding hstar_def by fast
  then have "\<forall>(s, h)\<in>S\<^sub>P. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" unfolding left_lives_def compat_def hAdd_def using fmap_add_comm by fastforce
  then have "\<forall>(s, h)\<in>S\<^sub>P. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S" using fmap_le_implies_smaller by fast
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>P" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def using fmap_add_comm by force
  then have "\<forall>(s, h')\<in>S. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S\<^sub>P" using fmap_le_implies_smaller by fast
  ultimately have "S\<in>P" using assms(1) \<open>S\<^sub>P\<in>P\<close> unfolding Intu_def by blast
  have "\<forall>(s, h)\<in>S\<^sub>Q. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" using \<open>right_lives S S\<^sub>P S\<^sub>Q\<close> unfolding right_lives_equiv compat_def hAdd_def by fastforce
  then have "\<forall>(s, h)\<in>S\<^sub>Q. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S" using fmap_le_implies_smaller by fast
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>Q" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def by force
  then have "\<forall>(s, h')\<in>S. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S\<^sub>Q" using fmap_le_implies_smaller by fast
  ultimately have "S\<in>Q" using assms(2) \<open>S\<^sub>Q\<in>Q\<close> Intu_def by blast
  then show "S\<in>P\<inter>Q" using \<open>S\<in>P\<close> by blast
qed

lemma hstar_sup_inter:
  assumes "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
   shows "P\<inter>Q \<subseteq> P\<star>Q"
proof
  fix S
  assume "S\<in>P\<inter>Q"
  then have "S\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S}=S" "S\<in>P" "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" unfolding star_def compat_def using assms by auto
  moreover have "left_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding left_lives_def compat_def hAdd_def by force
  moreover have "right_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding right_lives_equiv compat_def hAdd_def by force
  ultimately show "S\<in>P\<star>Q" unfolding hstar_def by blast
qed

lemma hstar_coincides_inter:
  assumes "Intu P"
      and "Pure Q"
    shows "P\<star>Q = P\<inter>Q"
proof
  have "Intu Q" using assms(2) Pure_implies_Intu by force
  then show "P\<star>Q \<subseteq> P\<inter>Q" using assms(1) hstar_sub_inter by presburger
  have "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
  proof(-)
    have 0: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Pure_def by blast
    fix S
    assume "S\<in>Q"
    then show "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" using "0"[of S "{(s, fmap_empty)| s h. (s, h)\<in>S}"] by blast
  qed
  then show "P\<inter>Q \<subseteq> P\<star>Q" using hstar_sup_inter by blast
qed

(*Property 10 - ???*)
(*lemma hstar_preserves_Intu:
  assumes "Intu P"
      and "Intu Q"
    shows "Intu (P\<star>Q)"
proof(rule IntuI)
  have a1: "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P" using assms(1) unfolding Intu_def by blast
  have a2: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Intu_def by blast
  
  fix S S'
  assume asm: "S\<in>P\<star>Q" "\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S"
  then obtain \<tau> where \<tau>_def: "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=S" "fst`\<tau>=(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" "fst`snd`\<tau>\<in>P" "snd`snd`\<tau>\<in>Q" unfolding hstar_via_triples by blast
  then have samestore: "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau> \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" unfolding hAdd_def by fastforce

  obtain \<tau>' where \<tau>'_def: "\<tau>' = {((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))| s h h\<^sub>P h\<^sub>Q h'. (s, h')\<in>S' \<and> h\<sqsubseteq>h' \<and> ((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>}" by blast
(*then have \<tau>'_alt: "\<tau>' = {((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))| s h h\<^sub>P h\<^sub>Q h'. (s, h')\<in>S' \<and> h\<sqsubseteq>h' \<and> (s, h)\<in>S \<and> (s, h\<^sub>P)\<in>S\<^sub>P \<and> (s, h\<^sub>Q)\<in>S\<^sub>Q \<and> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<and> h\<^sub>P\<bottom>h\<^sub>Q}" unfolding \<tau>_def by simp*)
  then have samestore': "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau>' \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" by blast
  have coord2: "\<And>h h\<^sub>P h\<^sub>Q h'. h\<sqsubseteq>h' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>P\<bottom>h\<^sub>Q \<Longrightarrow> h\<^sub>P\<sqsubseteq>(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" unfolding compat_def larger_def by (smt (verit, best) IntI disjoint_eq_subset_Compl dual_order.trans emptyE fmap_add_comm fmap_add_dom_app_simps(3) fmap_dom_restrict fmap_le_iff_fmap_add_commute fmap_le_implies_dom_le fmap_restrict_in inf_idem inf_mono subset_Compl_singleton)
  have coord3:"\<And>h h\<^sub>P h\<^sub>Q h'. h\<sqsubseteq>h' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>Q\<sqsubseteq>(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" unfolding larger_def by auto

  have "fst`\<tau>' = S'"
  proof
    show "fst`\<tau>' \<subseteq> S'" unfolding \<tau>'_def by force
    have "\<And>s h'. (s, h')\<in>S' \<Longrightarrow> (s, h')\<in>fst`\<tau>'"
    proof(-)
      fix s h'
      assume asm': "(s, h')\<in>S'"
      then obtain h where "h\<sqsubseteq>h'" "(s, h)\<in>S" using asm(3) by fast
      then obtain h\<^sub>P h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using \<open>fst`\<tau> = S\<close> samestore by fastforce
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>h\<sqsubseteq>h'\<close> asm' unfolding \<tau>'_def by blast
      then show "(s, h')\<in>fst`\<tau>'" by force
    qed
    then show "S' \<subseteq> fst`\<tau>'" by fast
  qed
  moreover have "fst`snd`\<tau>'\<in>P"
  proof(-)
    have "\<And>s h\<^sub>P. (s, h\<^sub>P)\<in>fst`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>P'. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>P
      assume "(s, h\<^sub>P)\<in>fst`snd`\<tau>"
      then obtain h h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<sqsubseteq>h'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close>  \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q))\<in>fst`snd`\<tau>'" by (metis fst_conv rev_image_eqI snd_conv)
      moreover have "h\<^sub>P\<sqsubseteq>(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<sqsubseteq>h'\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> coord2 by blast
      ultimately show "\<exists>h\<^sub>P'. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>P. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>P\<sqsubseteq>h\<^sub>P'" using \<tau>_def coord2 hAdd_prop by fastforce
      then show "\<exists>h\<^sub>P. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis fst_conv image_eqI snd_conv)
    qed
    ultimately show "fst`snd`\<tau>'\<in>P" using \<tau>_def(4) a1[of "fst`snd`\<tau>" "fst`snd`\<tau>'"] by fast
  qed
  moreover have "snd`snd`\<tau>'\<in>Q"
  proof(-)
    have "\<And>s h\<^sub>Q. (s, h\<^sub>Q)\<in>snd`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>Q'. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>Q
      assume "(s, h\<^sub>Q)\<in>snd`snd`\<tau>"
      then obtain h h\<^sub>P where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<sqsubseteq>h'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close> \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(fmap_dom h\<^sub>Q))\<in>snd`snd`\<tau>'" by force
      moreover have "h\<^sub>Q\<sqsubseteq>(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<sqsubseteq>h'\<close> coord3 by blast
      ultimately show "\<exists>h\<^sub>Q'. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>Q. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>Q\<sqsubseteq>h\<^sub>Q'" using \<tau>_def coord3 hAdd_def by fastforce
      then show "\<exists>h\<^sub>Q. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis image_eqI snd_conv)
    qed
    ultimately show "snd`snd`\<tau>'\<in>Q" using \<tau>_def(5) a2[of "snd`snd`\<tau>" "snd`snd`\<tau>'"] by fast
  qed
  moreover have "fst`\<tau>'=(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
  proof
    show "fst`\<tau>'\<subseteq>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
    proof(-)
      have "\<And>s h'. (s, h')\<in>fst`\<tau>' \<Longrightarrow> (s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
      proof(-)
        fix s h'
        assume "(s, h')\<in>fst`\<tau>'"
        then obtain h\<^sub>P' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
        then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
        then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
        moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
        moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
        ultimately show "(s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')" unfolding star_def by blast
      qed
      then show ?thesis by fast
    qed
    show "(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')\<subseteq>fst`\<tau>'"
    proof(-)
      have "\<And>s h'. (s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>') \<Longrightarrow> (s, h')\<in>fst`\<tau>'"
      proof(-)
        fix s h'
        assume "(s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
        then obtain h\<^sub>P' h\<^sub>Q' where "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" unfolding star_def by blast















  qed
  moreover have "left_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding left_lives_def hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  moreover have "right_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding right_lives_equiv hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  ultimately show "S'\<in>P\<star>Q" unfolding hstar_def by blast
qed*)

(*Property 11*)
lemma hstar_preserves_Pure:
  assumes "Pure P"
      and "Pure Q"
    shows "Pure (P\<star>Q)"
proof(rule PureI)
  fix S S' :: "((nat \<Rightarrow> nat) \<times> (nat \<rightharpoonup>\<^sub>f nat + unit)) set"
  assume asm: "S\<in>P\<star>Q" "\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S"
  then obtain S\<^sub>P S\<^sub>Q where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" unfolding hstar_def by blast
  then have "\<forall>(s, h\<^sub>P)\<in>S\<^sub>P. \<exists>h. (s, h)\<in>S" unfolding left_lives_def hAdd_def by fastforce
  then have "\<forall>(s, h\<^sub>P)\<in>S\<^sub>P. \<exists>h. (s, h)\<in>S'" using asm(2) by fast
  moreover have "\<forall>(s, h)\<in>S. \<exists>h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def by blast
  then have "\<forall>(s, h)\<in>S'. \<exists>h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P" using asm(3) by fast
  ultimately have "S'\<in>P" using assms(1) \<open>S\<^sub>P\<in>P\<close> unfolding Pure_def by blast

  have "\<forall>(s, h\<^sub>Q)\<in>S\<^sub>Q. \<exists>h. (s, h)\<in>S" using \<open>right_lives S S\<^sub>P S\<^sub>Q\<close> unfolding right_lives_equiv hAdd_def by fastforce
  then have "\<forall>(s, h\<^sub>Q)\<in>S\<^sub>Q. \<exists>h. (s, h)\<in>S'" using asm(2) by fast
  moreover have "\<forall>(s, h)\<in>S. \<exists>h\<^sub>Q. (s, h\<^sub>Q)\<in>S\<^sub>Q" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def by blast
  then have "\<forall>(s, h)\<in>S'. \<exists>h\<^sub>Q. (s, h\<^sub>Q)\<in>S\<^sub>Q" using asm(3) by fast
  ultimately have "S'\<in>Q" using assms(2) \<open>S\<^sub>Q\<in>Q\<close> unfolding Pure_def by blast
  moreover have "\<forall>(s, h)\<in>S'. \<exists>h'. (s, h')\<in>{(s, fmap_empty)| s h. (s, h)\<in>S'}" by fast
  moreover have "\<forall>(s, h')\<in>{(s, fmap_empty)| s h. (s, h)\<in>S'}. \<exists>h. (s, h)\<in>S'" by blast
  ultimately have "{(s, fmap_empty)| s h. (s, h)\<in>S'}\<in>Q" using assms(2) unfolding Pure_def by blast

  moreover have "S'\<subseteq>S'\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding star_def hAdd_def compat_def by auto
  moreover have "S'\<supseteq>S'\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding star_def hAdd_def compat_def by auto
  moreover have "left_lives S' S' {(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding left_lives_def hAdd_def compat_def by force
  moreover have "right_lives S' S' {(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding right_lives_equiv hAdd_def compat_def by force
  ultimately show "S'\<in>P\<star>Q" using \<open>S'\<in>P\<close> unfolding hstar_def by blast
qed

(*Property 13*)
lemma hstar_expresses_SL_star:
  "{S. S\<subseteq>p}\<star>{S. S\<subseteq>q}\<subseteq>{S. S\<subseteq>(p\<^emph>q)}" unfolding hstar_def star_def by blast 

(*Property 14*)
lemma hstar_expresses_SSIL_star:
  "{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}\<subseteq>{S. S\<inter>(p\<^emph>q)\<noteq>{}}"
proof
  fix S
  assume "S\<in>{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}"
  then obtain S\<^sub>p S\<^sub>q where "S\<subseteq>S\<^sub>p\<^emph>S\<^sub>q" "S\<^sub>p\<in>{S. S\<inter>p\<noteq>{}}" "S\<^sub>q\<in>{S. S\<subseteq>q}" "left_lives S S\<^sub>p S\<^sub>q" "right_lives S S\<^sub>p S\<^sub>q" unfolding hstar_def by force
  then obtain s h\<^sub>p where "(s, h\<^sub>p)\<in>S\<^sub>p" "(s, h\<^sub>p)\<in>p" by fast
  then obtain h h\<^sub>q where "(s, h)\<in>S" "(s, h\<^sub>q)\<in>S\<^sub>q" "h=h\<^sub>p++\<^sub>fh\<^sub>q" "h\<^sub>p\<bottom>h\<^sub>q" using \<open>left_lives S S\<^sub>p S\<^sub>q\<close> unfolding left_lives_def hAdd_def by auto
  then have "(s, h\<^sub>q)\<in>q" using \<open>S\<^sub>q\<in>{S. S\<subseteq>q}\<close> by blast
  then have "(s, h)\<in>p\<^emph>q" unfolding star_def using \<open>(s, h\<^sub>p)\<in>p\<close> \<open>h=h\<^sub>p++\<^sub>fh\<^sub>q\<close> \<open>h\<^sub>p\<bottom>h\<^sub>q\<close> by blast
  then show "S\<in>{S. S\<inter>(p\<^emph>q)\<noteq>{}}" using \<open>(s, h)\<in>S\<close> by blast
qed

(*Property 15*)
(*lemma hstar_expresses_OSL_star:
  "{S. S\<subseteq>(p\<^emph>q) \<and> S\<inter>(p\<^emph>q)\<noteq>{}}\<subseteq>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}"  (is "?A \<subseteq> ?B")
proof
  fix S
  assume "S\<in>?A"
  then have "\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" using star_via_hAdd by auto
  moreover obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)| \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<in>S \<and> \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q}" by blast
  ultimately have "(fst`\<tau>)\<subseteq>(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" unfolding star_via_hAdd by fastforce
  moreover have "(fst`\<tau>)\<supseteq>(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" unfolding star_via_hAdd \<tau>_def sorry
  moreover have "(snd`snd`\<tau>)\<in>{S. S\<subseteq>q}" using \<tau>_def by auto
  moreover have "left_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def left_lives_def by fastforce
  moreover have "right_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def right_lives_equiv by fastforce
  moreover have "S=(fst`\<tau>)"
  proof
    show "(fst`\<tau>)\<subseteq>S" using \<tau>_def by fastforce
    show "S\<subseteq>(fst`\<tau>)"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then obtain \<sigma>\<^sub>p \<sigma>\<^sub>q where "\<sigma>\<^sub>p\<in>p" "\<sigma>\<^sub>q\<in>q" "hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" using \<open>\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q\<close> by fast
      then have "(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)\<in>\<tau>" using \<tau>_def \<open>\<sigma>\<in>S\<close> by blast
      then show "\<sigma>\<in>fst`\<tau>" by force
    qed
  qed
  moreover have "(fst`snd`\<tau>)\<noteq>{}" using \<open>S=fst`\<tau>\<close> \<open>S\<in>{S. S\<subseteq>p\<^emph>q \<and> S\<inter>(p\<^emph>q)\<noteq>{}}\<close> by auto
  then have "(fst`snd`\<tau>)\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}" using \<tau>_def by fastforce
  ultimately show "S\<in>?B" sledgehammer
qed

(*Property 16*)
lemma join_OSL_encs: "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}={S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}"
proof
  show "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}\<subseteq>{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}" unfolding join_def by auto
  show "{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<subseteq>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}"
  proof
    fix S
    assume asm: "S\<in>{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}"
    then obtain S\<^sub>p S\<^sub>q where "S\<^sub>p=S\<inter>p" "S\<^sub>q=S\<inter>q" by presburger
    then have "S\<^sub>p\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}" "S\<^sub>q\<in>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}" "S=S\<^sub>p\<union>S\<^sub>q" using asm by auto
    then show "S\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}" unfolding join_def by blast
  qed
qed

lemma hstar_expresses_OSL_star_2:
  "{S. S\<subseteq>(p\<union>q) \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f}={S. S\<subseteq>((p\<union>q)\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}"
proof(-)
  have "{S. S\<subseteq>(p\<union>q) \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f}=({S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}})\<star>{S. S\<subseteq>f}" using join_OSL_encs by auto
  moreover have "... = ({S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>f})\<otimes>({S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f})" using hstar_distr_over_join_powerset by simp
  moreover have "... = {S. S\<subseteq>(p\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{}}\<otimes>{S. S\<subseteq>(q\<^emph>f) \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using hstar_expresses_OSL_star by presburger
  moreover have "... = {S. S\<subseteq>((p\<^emph>f)\<union>(q\<^emph>f)) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using join_OSL_encs by auto
  moreover have "... = {S. S\<subseteq>((p\<union>q)\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using star_distr_over_union by blast
  ultimately show ?thesis by argo
qed

(*Property 17*)
lemma partition_star:
  assumes "v\<^sub>1\<noteq>v\<^sub>2"
  shows "S\<^sub>A\<^emph>S\<^sub>B=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>2})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" 
proof(-)
  have "S\<^sub>A\<^emph>S\<^sub>B=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})"
  proof
    show "({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})\<subseteq>S\<^sub>A\<^emph>S\<^sub>B" unfolding star_def by blast
    show "S\<^sub>A\<^emph>S\<^sub>B\<subseteq>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S\<^sub>A\<^emph>S\<^sub>B"
      then obtain \<sigma>\<^sub>A \<sigma>\<^sub>B where "\<sigma>\<^sub>A\<in>S\<^sub>A" "\<sigma>\<^sub>B\<in>S\<^sub>B" "hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B" unfolding star_via_hAdd by blast
      then have "fst \<sigma>\<^sub>A = fst \<sigma>\<^sub>B" unfolding hAdd_def by fastforce
      then have "(\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1}) \<or> (\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})" using \<open>\<sigma>\<^sub>A\<in>S\<^sub>A\<close> \<open>\<sigma>\<^sub>B\<in>S\<^sub>B\<close> by auto
      then show "\<sigma>\<in>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})" unfolding star_via_hAdd using \<open>hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B\<close> by blast
    qed
  qed
  moreover have "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}=({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})"
  proof
    show "({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}) \<subseteq> {\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}" unfolding star_def by blast
    show "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1} \<subseteq> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}"
      then obtain \<sigma>\<^sub>A \<sigma>\<^sub>B where "\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}" "\<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}" "hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B" unfolding star_via_hAdd by blast
      then have "fst \<sigma>\<^sub>A = fst \<sigma>\<^sub>B" "fst \<sigma> = fst \<sigma>\<^sub>A" "fst \<sigma> = fst \<sigma>\<^sub>B" unfolding hAdd_def hAdd_def by auto
      then have "(\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t=v\<^sub>2} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t=v\<^sub>2}) \<or> (\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" using \<open>\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<close> \<open>\<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}\<close> by auto
      then show "\<sigma>\<in>({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})" unfolding star_via_hAdd using \<open>hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B\<close> by blast
    qed
  qed
  then have "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>2})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" by (smt (verit) Collect_cong assms mem_Collect_eq)
  ultimately show ?thesis by blast
qed

lemma hstar_expresses_RSL_star:
  "{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a}\<star>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>b}\<subseteq>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a\<^emph>\<^sub>rb}" (is "?X\<star>?Y \<subseteq> ?Z")
proof
  fix S
  assume "S\<in>?X\<star>?Y"
  then obtain S\<^sub>a S\<^sub>b where S\<^sub>aS\<^sub>b_def: "S\<subseteq>S\<^sub>a\<^emph>S\<^sub>b" "S\<^sub>a\<in>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a}" "S\<^sub>b\<in>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>b}" "left_lives S S\<^sub>a S\<^sub>b" "right_lives S S\<^sub>a S\<^sub>b" unfolding hstar_def by auto
  then obtain S\<^sub>a\<^sub>1 S\<^sub>a\<^sub>2 S\<^sub>a\<^sub>o S\<^sub>b\<^sub>1 S\<^sub>b\<^sub>2 S\<^sub>b\<^sub>o where "S\<^sub>a\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>a. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>a\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>a. fst \<sigma>\<^sub>2 t = 2}" "S\<^sub>a\<^sub>1\<times>S\<^sub>a\<^sub>2\<subseteq>a"
                                         "S\<^sub>b\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>b\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}" "S\<^sub>b\<^sub>1\<times>S\<^sub>b\<^sub>2\<subseteq>b"
                                         "S\<^sub>a\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>a. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}" "S\<^sub>b\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>b. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}" by force
  moreover have "S\<^sub>a\<^emph>S\<^sub>b = ({\<sigma>\<in>S\<^sub>a. fst \<sigma> t=1}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t=1})\<union>({\<sigma>\<in>S\<^sub>a. fst \<sigma> t=2}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t=2})\<union>({\<sigma>\<in>S\<^sub>a. fst \<sigma> t\<noteq>1 \<and> fst \<sigma> t\<noteq>2}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t\<noteq>1 \<and> fst \<sigma> t\<noteq>2})" using partition_star by simp
  ultimately have splt: "S\<^sub>a\<^emph>S\<^sub>b = (S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1) \<union> (S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2) \<union> (S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o)" by fast
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. fst \<sigma> t = 1" unfolding \<open>S\<^sub>a\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>a. fst \<sigma>\<^sub>1 t = 1}\<close> \<open>S\<^sub>b\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}\<close> star_def by fastforce
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. fst \<sigma> t = 2" unfolding \<open>S\<^sub>a\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>a. fst \<sigma>\<^sub>2 t = 2}\<close> \<open>S\<^sub>b\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}\<close> star_def by fastforce
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o. fst \<sigma> t \<noteq>1 \<and> fst \<sigma> t \<noteq> 2" unfolding \<open>S\<^sub>a\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>a. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}\<close> \<open>S\<^sub>b\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>b. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}\<close> star_def by fastforce

  have 0: "(\<forall>\<sigma>\<^sub>1\<in>S\<^sub>a\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>a\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>a) \<and> (\<forall>\<sigma>\<^sub>1\<in>S\<^sub>b\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>b\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>b)" using \<open>S\<^sub>a\<^sub>1\<times>S\<^sub>a\<^sub>2\<subseteq>a\<close> \<open>S\<^sub>b\<^sub>1\<times>S\<^sub>b\<^sub>2\<subseteq>b\<close> by auto
  have 1: "\<forall>\<sigma>\<^sub>1\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>(a\<^emph>\<^sub>rb)" using "0" unfolding rstar_def star_via_hAdd by fast
  then have "(S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1)\<times>(S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2)\<subseteq>a\<^emph>\<^sub>rb" by fastforce     

  obtain S\<^sub>1 S\<^sub>2 where S\<^sub>1S\<^sub>2_def: "S\<^sub>1={\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>2={\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}" by auto
  moreover have "S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1 = {\<sigma>\<^sub>1\<in>S\<^sub>a\<^emph>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2 = {\<sigma>\<^sub>2\<in>S\<^sub>a\<^emph>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}" using splt \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. fst \<sigma> t = 1\<close> \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. fst \<sigma> t = 2\<close> \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o. fst \<sigma> t \<noteq>1 \<and> fst \<sigma> t \<noteq> 2\<close> by auto
  ultimately have "S\<^sub>1\<subseteq>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1" "S\<^sub>2\<subseteq>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2" using S\<^sub>aS\<^sub>b_def(1) by auto 
  then have "S\<^sub>1\<times>S\<^sub>2\<subseteq>a\<^emph>\<^sub>rb" using \<open>(S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1)\<times>(S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2)\<subseteq>a\<^emph>\<^sub>rb\<close> by auto
  then show "S\<in>?Z" using S\<^sub>1S\<^sub>2_def(1,2) by auto
qed*)

end