theory StrongestPostcondition
  imports ProgramCommands
begin

lemma sp_seq_aux:
  "{\<sigma>''. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>'')\<in>\<lbrakk>Seq C\<^sub>1 C\<^sub>2\<rbrakk>} = {\<sigma>''. \<exists>\<sigma>'\<in>{\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>C\<^sub>1\<rbrakk>}. (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<^sub>2\<rbrakk>}"
proof(-)
  have "{\<sigma>''. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>'')\<in>\<lbrakk>Seq C\<^sub>1 C\<^sub>2\<rbrakk>} = {\<sigma>''. \<exists>\<sigma>\<in>p. \<exists>\<sigma>'. (\<sigma>, \<sigma>')\<in>\<lbrakk>C\<^sub>1\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<^sub>2\<rbrakk>}" using dsem_seq by blast
  then show ?thesis by blast
qed

lemma sp_if_aux:
  "{\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>C\<^sub>1\<rbrakk>} \<union> {\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>C\<^sub>2\<rbrakk>} = {\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>If C\<^sub>1 C\<^sub>2\<rbrakk>}"
  using dsem_if by blast

lemma sp_while_aux:
  "{\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>Skip\<rbrakk>} \<union> {\<sigma>''. \<exists>\<sigma>'\<in>{\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>While C\<rbrakk>}. (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>} = {\<sigma>'| \<sigma> \<sigma>'. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>')\<in>\<lbrakk>While C\<rbrakk>}" (is "?X \<union> ?Y = ?Z")
proof(-)
  have "?Y = {\<sigma>''| \<sigma> \<sigma>' \<sigma>''. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>')\<in>\<lbrakk>While C\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>}" by blast
  moreover have "{\<sigma>''| \<sigma> \<sigma>' \<sigma>''. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>')\<in>\<lbrakk>While C\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>} = {\<sigma>''| \<sigma> \<sigma>' \<sigma>''. \<exists>n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>}" by (metis (mono_tags, lifting) dsem_char while_iff_union_iter)
  ultimately have "?Y = {\<sigma>''| \<sigma> \<sigma>' \<sigma>''. \<exists>n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>}" by argo
  moreover have "\<And>\<sigma> \<sigma>' \<sigma>'' n. (\<sigma>, \<sigma>')\<in>\<lbrakk>iter C n\<rbrakk> \<Longrightarrow> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk> \<Longrightarrow> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk>" using iter_combine dsem_char by blast
  moreover have "\<And>\<sigma> \<sigma>' \<sigma>'' n. (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk> \<Longrightarrow> \<exists>\<sigma>'. (\<sigma>, \<sigma>')\<in>\<lbrakk>iter C n\<rbrakk> \<and> (\<sigma>', \<sigma>'')\<in>\<lbrakk>C\<rbrakk>" by (meson iter_breakdown dsem_char)
  ultimately have "?Y = {\<sigma>''| \<sigma> \<sigma>'' n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C (Suc n)\<rbrakk>}" by (smt (verit, ccfv_threshold) Collect_cong)
  moreover have "?X = {\<sigma>''| \<sigma> \<sigma>'' n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C 0\<rbrakk>}" by auto
  ultimately have "?X \<union> ?Y = {\<sigma>''| \<sigma> \<sigma>'' n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C 0\<rbrakk>\<union>\<lbrakk>iter C (Suc n)\<rbrakk>}" by auto
  then have "?X \<union> ?Y = {\<sigma>''| \<sigma> \<sigma>''. \<exists>n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C 0\<rbrakk>\<union>\<lbrakk>iter C (Suc n)\<rbrakk>}" by auto
  moreover have "?Z = {\<sigma>''| \<sigma> \<sigma>'' n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C n\<rbrakk>}" using dsem_char while_iff_union_iter by meson
  then have "?Z = {\<sigma>''| \<sigma> \<sigma>''. \<exists>n. \<sigma>\<in>p \<and> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C n\<rbrakk>}" by simp
  moreover have "\<And>\<sigma> \<sigma>''. (\<exists>n. (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C n\<rbrakk>) \<longleftrightarrow> (\<exists>n'. (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C 0\<rbrakk> \<or> (\<sigma>, \<sigma>'')\<in>\<lbrakk>iter C (Suc n')\<rbrakk>)" by (metis old.nat.exhaust)
  ultimately show ?thesis by auto
qed

definition sp :: "'var state set \<Rightarrow> 'var cmd \<Rightarrow> 'var state set" where
  "sp p C = {\<sigma>'. \<exists>\<sigma>\<in>p. (\<sigma>, \<sigma>')\<in>\<lbrakk>C\<rbrakk>}"

lemma "sp (p\<union>p') C = sp p C \<union> sp p' C" unfolding sp_def by blast

lemma sp_skip: "sp p Skip = p" 
  unfolding sp_def dsem_skip by force

lemma sp_assign: "sp p (Assign x e) = {(s(x:=e s), h)| s h. (s, h)\<in>p}"
  unfolding sp_def dsem_assign by blast

lemma sp_havoc: "sp p (Havoc x) = {(s(x:=n), h)| s h n. (s, h)\<in>p}"
  unfolding sp_def dsem_havoc by blast

lemma sp_assume: "sp p (Assume b) = {(s, h)| s h. (s, h)\<in>p \<and> s\<in>b}"
  unfolding sp_def dsem_assume by force

lemma sp_seq: "sp p (Seq C\<^sub>1 C\<^sub>2) = sp (sp p C\<^sub>1) C\<^sub>2"
  unfolding sp_def sp_seq_aux by blast

lemma sp_if: "sp p (If C\<^sub>1 C\<^sub>2) = sp p C\<^sub>1 \<union> sp p C\<^sub>2"
  unfolding sp_def sp_if_aux by blast

lemma sp_while: "sp p (While C) = p \<union> sp (sp p (While C)) C"
  using sp_def sp_while_aux sp_skip by metis

lemma sp_alloc: "sp p (Alloc x) = {(s(x:=l), fmap_update h l (hOcc n))| s h l n. (s, h)\<in>p \<and> (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0}"
  unfolding sp_def dsem_alloc by blast

lemma sp_write: "sp p (Write x e) = {(s, fmap_update h (s x) (hOcc (e s)))| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  unfolding sp_def dsem_write by blast

lemma sp_read: "sp p (Read y x) = {(s(y:=n), h)| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  unfolding sp_def dsem_read by blast

lemma sp_free: "sp p (Free x) = {(s, fmap_update h (s x) hFrd)| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  unfolding sp_def dsem_free by blast

theorem sp_properties:
  "sp p Skip = p" 
  "sp p (Assign x e) = {(s(x:=e s), h)| s h. (s, h)\<in>p}"
  "sp p (Havoc x) = {(s(x:=n), h)| s h n. (s, h)\<in>p}"
  "sp p (Assume b) = {(s, h)| s h. (s, h)\<in>p \<and> s\<in>b}"
  "sp p (Seq C\<^sub>1 C\<^sub>2) = sp (sp p C\<^sub>1) C\<^sub>2"
  "sp p (If C\<^sub>1 C\<^sub>2) = sp p C\<^sub>1 \<union> sp p C\<^sub>2"
  "sp p (While C) = p \<union> sp (sp p (While C)) C"
  "sp p (Alloc x) = {(s(x:=l), fmap_update h l (hOcc n))| s h l n. (s, h)\<in>p \<and> (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0}"
  "sp p (Write x e) = {(s, fmap_update h (s x) (hOcc (e s)))| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  "sp p (Read y x) = {(s(y:=n), h)| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  "sp p (Free x) = {(s, fmap_update h (s x) hFrd)| s h n. (s, h)\<in>p \<and> fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  unfolding sp_skip sp_assign sp_havoc sp_assume sp_seq sp_if sp_alloc sp_write sp_read sp_free using sp_while by auto

lemma sp_iter:
  "sp p (iter C (Suc n)) = sp (sp p (iter C n)) C"
  "sp p (iter C (Suc n)) = sp (sp p C) (iter C n)"
  unfolding sp_def apply (metis add_Seq_to_iterR sp_seq_aux) by (simp add: sp_seq_aux)

lemma sp_while_general:
  "sp p (While C) = (\<Union>n. sp p (iter C n))"
  unfolding sp_def using dsem_while[of C] by (smt (verit, del_insts) Collect_cong UNION_eq mem_Collect_eq)

lemma provides_seq_right:
  assumes "provides p (Seq C\<^sub>1 C\<^sub>2)"
    shows "provides (sp p C\<^sub>1) C\<^sub>2"
proof(rule ccontr)
  assume "\<not> provides (sp p C\<^sub>1) C\<^sub>2"
  then obtain \<sigma>' c'' where "\<sigma>'\<in>sp p C\<^sub>1" "(C\<^sub>2, \<sigma>')\<rightarrow>*c''" "aborts c''" unfolding provides_def by blast
  then obtain \<sigma> where "\<sigma>\<in>p" "(\<sigma>, \<sigma>')\<in>\<lbrakk>C\<^sub>1\<rbrakk>" unfolding sp_def by auto
  then have "(C\<^sub>1, \<sigma>)\<rightarrow>*(Skip, \<sigma>')" unfolding dsem_def by fast
  then have "(Seq C\<^sub>1 C\<^sub>2, \<sigma>)\<rightarrow>*c''" using \<open>(C\<^sub>2, \<sigma>')\<rightarrow>*c''\<close> by (meson RedSeq1 RedTran rtred_trans seq_trcl)
  then show "False" using \<open>\<sigma>\<in>p\<close> \<open>aborts c''\<close> assms unfolding provides_def by blast
qed

lemma provides_while_specific:
  assumes "provides p (While C)"
  shows "provides (sp p (iter C n)) C"
proof(rule ccontr)
  assume "\<not> provides (sp p (iter C n)) C"
  then obtain \<sigma> C' \<sigma>' where "\<sigma>\<in>sp p (iter C n)" "(C, \<sigma>)\<rightarrow>*(C', \<sigma>')" "aborts (C', \<sigma>')" unfolding provides_def by fast
  then have "aborts (Seq C' (While C), \<sigma>')" by (simp add: aborts.intros(4))
  moreover have "(While C, \<sigma>)\<rightarrow>*(Seq C (While C), \<sigma>)" by (metis RedRefl iter.simps(2) every_iter_is_while_seq)
  then have "(While C, \<sigma>)\<rightarrow>*(Seq C' (While C), \<sigma>')" using \<open>(C, \<sigma>)\<rightarrow>*(C', \<sigma>')\<close> rtred_trans seq_trcl by blast
  moreover obtain \<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t where "\<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t\<in>p" "(\<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t, \<sigma>)\<in>\<lbrakk>iter C n\<rbrakk>" using \<open>\<sigma>\<in>sp p (iter C n)\<close> unfolding sp_def by blast
  then have "(\<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t, \<sigma>)\<in>\<lbrakk>While C\<rbrakk>" using dsem_char while_iff_union_iter by blast
  then have "(While C, \<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t)\<rightarrow>*(Skip, \<sigma>)" by (simp add: dsem_char)
  then have "(While C, \<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t)\<rightarrow>*(While C, \<sigma>)" using while_self_loop by meson
  ultimately show "False" using \<open>\<sigma>\<^sub>i\<^sub>n\<^sub>i\<^sub>t \<in> p\<close> rtred_trans assms unfolding provides_def by blast
qed

lemma red_preserves_non_md:
  assumes "(C, \<sigma>) \<rightarrow> (C', \<sigma>')"
      and "t\<notin>md C"
      and "(fst \<sigma>) t = n"
    shows "(fst \<sigma>') t = n"
  using assms apply(induction "(C, \<sigma>)" "(C', \<sigma>')" arbitrary: C \<sigma> C' \<sigma>' rule: red.induct) by auto

lemma red_step_doesnt_introduce_new_md: 
  assumes "(C, \<sigma>) \<rightarrow> (C', \<sigma>')"
      and "t\<notin>md C"
    shows "t\<notin>md C'"
  using assms apply(induction "(C, \<sigma>)" "(C', \<sigma>')" arbitrary: C \<sigma> C' \<sigma>' rule: red.induct) by auto

lemma rtred_preserves_non_md:
  assumes "(C, \<sigma>) \<rightarrow>* (C'', \<sigma>'')"
      and "t\<notin>md C"
      and "(fst \<sigma>) t = n"
    shows "(fst \<sigma>'') t = n"
  using assms
proof(induction "(C, \<sigma>)" "(C'', \<sigma>'')" arbitrary: C \<sigma> C'' \<sigma>'' rule: rtred.induct)
  case (RedRefl)
  then show ?case by fastforce
next
  case (RedTran c')
  moreover obtain C' \<sigma>' where "c'=(C', \<sigma>')" by (meson prod.exhaust_sel)
  moreover have "(fst \<sigma>') t = n" using red_preserves_non_md by (metis calculation(1) calculation(4) calculation(5) calculation(6))
  moreover have "t\<notin>md C'" using red_step_doesnt_introduce_new_md by (metis calculation(1) calculation(4) calculation(6))
  ultimately show ?case by blast
qed


lemma "{(s(x:=l), fmap_update h l (hOcc n))| s h l n. (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0} = {(s, h)| s h n. s x\<noteq>0 \<and> fmap_lookup h (s x)=hOcc n}" (*alloc axiom post*)
proof
  show "{(s(x:=l), fmap_update h l (hOcc n))| s h l n. (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0} \<subseteq> {(s, h)| s h n. s x\<noteq>0 \<and> fmap_lookup h (s x)=hOcc n}" by force
  show "{(s, h)| s h n. s x\<noteq>0 \<and> fmap_lookup h (s x)=hOcc n} \<subseteq> {(s(x:=l), fmap_update h l (hOcc n))| s h l n. (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0}"
  proof
    fix \<sigma>
    assume "\<sigma>\<in>{((s::'a\<Rightarrow>'c), h)| s h n. s x\<noteq>0 \<and> fmap_lookup h (s x)=hOcc n}"
    then obtain s h n where "s x\<noteq>0" "fmap_lookup h (s x)=hOcc n" "\<sigma>=(s,h)" by blast
    moreover obtain h' where "h'=fmap_update h (s x) hUkw" by fast
    ultimately show "\<sigma>\<in>{(s(x:=l), fmap_update h l (hOcc n))| s h l n. (fmap_lookup h l=hUkw \<or> fmap_lookup h l=hFrd) \<and> l\<noteq>0}" apply simp by (smt (verit) Rep_fmap_inject \<open>h'=fmap_update h (s x) hUkw\<close> fmap_update_simp fun_upd_eqD fun_upd_triv fun_upd_upd)
  qed
qed
lemma "{(s, fmap_update h (s x) (hOcc (e s)))| s h. \<exists>n. fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0} = {(s, h)| s h. fmap_lookup h (s x)=hOcc (e s) \<and> s x\<noteq>0}" by (metis (no_types, lifting) fmap_upd_Some_unfold fmap_upd_triv) (*write axiom post*)
lemma "{(s, fmap_update h (s x) hFrd)| s h. \<exists>n. fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0} = {(s, h)| s h. fmap_lookup h (s x)=hFrd \<and> s x\<noteq>0}" (*free axiom post*)
proof
  show "{(s, fmap_update h (s x) hFrd)| s h. \<exists>n. fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0} \<subseteq> {(s, h)| s h. fmap_lookup h (s x)=hFrd \<and> s x\<noteq>0}" by force
  show "{(s, h)| s h. fmap_lookup h (s x)=hFrd \<and> s x\<noteq>0} \<subseteq> {(s, fmap_update h (s x) hFrd)| s h. \<exists>n. fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  proof(-)
    have "\<And>l h. fmap_lookup h l=hFrd \<Longrightarrow> \<exists>h\<^sub>0 n. h=fmap_update h\<^sub>0 l hFrd \<and> fmap_lookup h\<^sub>0 l=hOcc n" by (metis Rep_fmap_inject fmap_lookup_simp fmap_update_simp fun_upd_same fun_upd_triv fun_upd_upd)
    then show ?thesis by fast
  qed
qed

(*definition wlp :: "'var state set \<Rightarrow> 'var cmd \<Rightarrow> 'var state set" where
  "wlp q C = {s. \<forall>s'. (s, s')\<in>\<lbrakk>C\<rbrakk> \<longrightarrow> s'\<in>q}"

lemma "p\<subseteq>wlp q C \<longleftrightarrow> sp p C\<subseteq>q"
  unfolding sp_def wlp_def by blast*)

(*lemma dsem_preserves_non_md:
  assumes "t\<notin>md C"
    shows "dsem C {\<sigma>\<in>X. (fst \<sigma>) t = n} = {\<sigma>\<in>(dsem C X). (fst \<sigma>) t = n}"
  using assms rtred_preserves_non_md by (smt (verit, ccfv_SIG) Collect_cong mem_Collect_eq dsem_def)

lemma dsem_preserves_non_md_singleton:
  assumes "t\<notin>md C"
      and "fst \<sigma> t = n"
    shows "\<forall>\<sigma>'\<in>dsem C {\<sigma>}. fst \<sigma>' t = n"
  using assms dsem_preserves_non_md[of t C "{\<sigma>}" n] by (smt (verit, del_insts) Un_empty_right Un_insert_right insertI1 insert_absorb mem_Collect_eq dsem_union)

lemma dsem_preserves_non_md_element:
  assumes "t\<notin>md C"
      and "\<And>\<sigma>. \<sigma>\<in>S \<Longrightarrow> fst \<sigma> t \<noteq> n"
      and "\<sigma>'\<in>dsem C S"
    shows "fst \<sigma>' t \<noteq> n"
proof(rule ccontr)
  assume "\<not>fst \<sigma>' t \<noteq> ns
  then have "fst \<sigma>' t = n" by auto
  then obtain \<sigma> where "\<sigma>\<in>S" "(C, \<sigma>) \<rightarrow>* (Skip, \<sigma>')" using assms(3) in_dsem by blast
  then have "\<sigma>'\<in>dsem C {\<sigma>}" using in_dsem by blast
  then show "False" by (metis \<open>\<sigma> \<in> S\<close> \<open>fst \<sigma>' t = n\<close> assms(1) assms(2) dsem_preserves_non_md_singleton)
qed*)

end