theory HyperStar
  imports Star
begin

definition join :: "hassertion \<Rightarrow> hassertion \<Rightarrow> hassertion" (infix "\<otimes>" 52) where
 "P \<otimes> Q = {S\<^sub>P\<union>S\<^sub>Q| S\<^sub>P S\<^sub>Q. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q}"

definition join_indexed :: "'c set \<Rightarrow> ('c \<Rightarrow> hassertion) \<Rightarrow> hassertion" ("\<Otimes>\<^sub>_ _" [51,51] 81) where
 "\<Otimes>\<^sub>I Ps = {(\<Union>i\<in>I. f i)| f. \<forall>i\<in>I. f i\<in>Ps i}"

lemma join_unit: "P\<otimes>{{}}=P" unfolding join_def by auto

lemma join_comm: "P\<otimes>Q=Q\<otimes>P" unfolding join_def by blast

lemma join_assoc: "P\<otimes>(Q\<otimes>R)=(P\<otimes>Q)\<otimes>R"
proof(-)
  have "P\<otimes>(Q\<otimes>R) = {S\<^sub>P\<union>S\<^sub>Q\<^sub>R |S\<^sub>P S\<^sub>Q\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<^sub>R\<in>{S\<^sub>Q\<union>S\<^sub>R |S\<^sub>Q S\<^sub>R. S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}}" unfolding join_def by blast
  moreover have "... = {S\<^sub>P\<union>S\<^sub>Q\<^sub>R |S\<^sub>P S\<^sub>Q\<^sub>R S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<^sub>R=S\<^sub>Q\<union>S\<^sub>R \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by force
  moreover have "... = {S\<^sub>P\<union>(S\<^sub>Q\<union>S\<^sub>R) |S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by blast
  moreover have "... = {(S\<^sub>P\<union>S\<^sub>Q)\<union>S\<^sub>R |S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by auto
  moreover have "... = {S\<^sub>P\<^sub>Q\<union>S\<^sub>R |S\<^sub>P\<^sub>Q S\<^sub>P S\<^sub>Q S\<^sub>R. S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q \<and> S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> S\<^sub>R\<in>R}" by force
  moreover have "... = {S\<^sub>P\<^sub>Q\<union>S\<^sub>R |S\<^sub>P\<^sub>Q S\<^sub>R. S\<^sub>P\<^sub>Q\<in>{S\<^sub>P\<union>S\<^sub>Q |S\<^sub>P S\<^sub>Q. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q} \<and> S\<^sub>R\<in>R}" by auto
  moreover have "... = (P\<otimes>Q)\<otimes>R" unfolding join_def by blast
  ultimately show ?thesis by argo
qed

lemma join_mono:
  assumes "p\<subseteq>p'"
      and "q\<subseteq>q'"
  shows "p\<otimes>q\<subseteq>p'\<otimes>q'"
  using assms unfolding join_def by blast

definition Pure :: "hassertion \<Rightarrow> bool" where
  "Pure P \<equiv> \<forall>S\<in>P. \<forall>S'. (\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S') \<and> (\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S) \<longrightarrow> S'\<in>P"

definition Intu :: "hassertion \<Rightarrow> bool" where
  "Intu P \<equiv> \<forall>S\<in>P. \<forall>S'. (\<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S') \<and> (\<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S) \<longrightarrow> S'\<in>P"

definition Intu' :: "hassertion \<Rightarrow> bool" where
  "Intu' P \<equiv> \<forall>S\<in>P. \<forall>S'. (\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S') \<and> (\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S) \<longrightarrow> S'\<in>P"

lemma PureI:
  assumes "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S \<Longrightarrow> S'\<in>P"
    shows "Pure P"
  using assms unfolding Pure_def by blast

lemma IntuI:
  assumes "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P"
    shows "Intu P"
  using assms unfolding Intu_def by blast

lemma Intu'I:
  assumes "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P"
    shows "Intu' P"
  using assms unfolding Intu'_def by blast

lemma Pure_implies_Intu:
  assumes "Pure P"
  shows "Intu P"
proof(rule IntuI)
  fix S S'
  assume "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S"
  then have "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S" by auto
  then show "S'\<in>P" using assms unfolding Pure_def by blast
qed

lemma Pure_implies_Intu':
  assumes "Pure P"
  shows "Intu' P"
proof(rule Intu'I)
  fix S S'
  assume "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S"
  then have "S\<in>P" "\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S" by auto
  then show "S'\<in>P" using assms unfolding Pure_def by blast
qed

definition left_lives :: "assertion \<Rightarrow> assertion \<Rightarrow> assertion \<Rightarrow> bool"  where
 "left_lives S S\<^sub>1 S\<^sub>2 \<equiv> \<forall>\<sigma>\<^sub>1\<in>S\<^sub>1. \<exists>\<sigma>\<^sub>2\<in>S\<^sub>2. \<exists>\<sigma>\<in>S. hAdd \<sigma> \<sigma>\<^sub>1 \<sigma>\<^sub>2"

definition right_lives :: "assertion \<Rightarrow> assertion \<Rightarrow> assertion \<Rightarrow> bool"  where
 "right_lives S S\<^sub>1 S\<^sub>2 \<longleftrightarrow> left_lives S S\<^sub>2 S\<^sub>1"

definition hstar :: "hassertion \<Rightarrow> hassertion \<Rightarrow> hassertion" (infix "\<star>" 52) where
 "P \<star> Q = {S| S S\<^sub>P S\<^sub>Q. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q \<and> S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q \<and> left_lives S S\<^sub>P S\<^sub>Q \<and> right_lives S S\<^sub>P S\<^sub>Q}"

lemma left_livesI:
  assumes "\<And>s h\<^sub>1. (s, h\<^sub>1)\<in>S\<^sub>1 \<Longrightarrow> \<exists>h h\<^sub>2. (s, h)\<in>S \<and> (s, h\<^sub>2)\<in>S\<^sub>2 \<and> hAdd (s, h) (s, h\<^sub>1) (s, h\<^sub>2)"
    shows "left_lives S S\<^sub>1 S\<^sub>2"
  using assms unfolding left_lives_def by fast

lemma left_lives_mono: "left_lives S S\<^sub>1' S\<^sub>2 \<Longrightarrow> S\<subseteq>S' \<Longrightarrow> S\<^sub>1\<subseteq>S\<^sub>1' \<Longrightarrow> S\<^sub>2\<subseteq>S\<^sub>2' \<Longrightarrow> left_lives S' S\<^sub>1 S\<^sub>2'" unfolding left_lives_def by blast

lemma right_lives_equiv: "right_lives S S\<^sub>1 S\<^sub>2 \<longleftrightarrow> (\<forall>\<sigma>\<^sub>2\<in>S\<^sub>2. \<exists>\<sigma>\<^sub>1\<in>S\<^sub>1. \<exists>\<sigma>\<in>S. hAdd \<sigma> \<sigma>\<^sub>1 \<sigma>\<^sub>2)"
  unfolding right_lives_def left_lives_def using hAdd_comm by auto

lemma right_livesI:
  assumes "\<And>s h\<^sub>2. (s, h\<^sub>2)\<in>S\<^sub>2 \<Longrightarrow> \<exists>h h\<^sub>1. (s, h)\<in>S \<and> (s, h\<^sub>1)\<in>S\<^sub>1 \<and> hAdd (s, h) (s, h\<^sub>1) (s, h\<^sub>2)"
    shows "right_lives S S\<^sub>1 S\<^sub>2"
  using assms unfolding right_lives_equiv by fast

lemma right_lives_mono: "right_lives S S\<^sub>1 S\<^sub>2' \<Longrightarrow> S\<subseteq>S' \<Longrightarrow> S\<^sub>1\<subseteq>S\<^sub>1' \<Longrightarrow> S\<^sub>2\<subseteq>S\<^sub>2' \<Longrightarrow> right_lives S' S\<^sub>1' S\<^sub>2" unfolding right_lives_equiv by blast

lemma hstarI:
  assumes "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q"
      and "S\<^sub>P\<in>P"
      and "S\<^sub>Q\<in>Q"
      and "left_lives S S\<^sub>P S\<^sub>Q"
      and "right_lives S S\<^sub>P S\<^sub>Q"
    shows "S\<in>P\<star>Q"
  using assms hstar_def by auto

lemma hstar_char_powerset:
  "S\<in>P\<star>{S. S\<subseteq>f} \<longleftrightarrow> (\<exists>S\<^sub>P. S\<subseteq>S\<^sub>P\<^emph>f \<and> S\<^sub>P\<in>P \<and> left_lives S S\<^sub>P f)" (is "?A \<longleftrightarrow> ?B")
proof(-)
  have 0: "S\<in>P\<star>{S. S\<subseteq>f} \<longleftrightarrow> (\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>{S. S\<subseteq>f} \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F)" unfolding hstar_def by simp
  moreover have "\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>{S. S\<subseteq>f} \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F \<Longrightarrow> ?B" by (smt (verit) dual_order.trans left_lives_mono mem_Collect_eq star_comm star_mono verit_comp_simplify1(2))
  moreover have "?B \<Longrightarrow> \<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>{S. S\<subseteq>f} \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F"
  proof(-)
    assume "?B"
    then obtain S\<^sub>P where S\<^sub>P_def: "S\<subseteq>S\<^sub>P\<^emph>f" "S\<^sub>P\<in>P" "left_lives S S\<^sub>P f" by blast
    obtain S\<^sub>F where S\<^sub>F_def: "S\<^sub>F = {\<sigma>\<^sub>F\<in>f. \<exists>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>P\<in>S\<^sub>P. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F}" by simp
    then have "S\<^sub>F\<in>{S. S\<subseteq>f}" by blast
    moreover have "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F" 
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then obtain \<sigma>\<^sub>P \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<in>S\<^sub>P" "\<sigma>\<^sub>F\<in>f" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using S\<^sub>P_def(1) unfolding star_via_hAdd by blast
      then have "\<sigma>\<^sub>F\<in>S\<^sub>F" unfolding S\<^sub>F_def using \<open>\<sigma>\<in>S\<close> by blast
      then show "\<sigma>\<in>S\<^sub>P\<^emph>S\<^sub>F" unfolding star_via_hAdd using \<open>\<sigma>\<^sub>P\<in>S\<^sub>P\<close> \<open>hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> by blast
    qed
    moreover have "left_lives S S\<^sub>P S\<^sub>F" unfolding S\<^sub>F_def using \<open>left_lives S S\<^sub>P f\<close> unfolding left_lives_def by fast
    moreover have "right_lives S S\<^sub>P S\<^sub>F" using S\<^sub>F_def unfolding right_lives_equiv by auto
    ultimately show "\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>{S. S\<subseteq>f} \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F" using S\<^sub>P_def(2) by blast
  qed
  ultimately show ?thesis by argo
qed
  
lemma hstar_char_downwards_closed:
  assumes "\<And>S\<^sub>F S\<^sub>F'. S\<^sub>F\<in>F \<Longrightarrow> S\<^sub>F'\<subseteq>S\<^sub>F \<Longrightarrow> S\<^sub>F'\<in>F"
  shows "S\<in>P\<star>F \<longleftrightarrow> (\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>F \<and> left_lives S S\<^sub>P S\<^sub>F)" (is "?A \<longleftrightarrow> ?B")
proof(-)
  have 0: "S\<in>P\<star>F \<longleftrightarrow> (\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>F \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F)" unfolding hstar_def by simp
  moreover have "\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>F \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F \<Longrightarrow> ?B" by (smt (verit, ccfv_SIG) dual_order.trans left_lives_mono mem_Collect_eq order_refl star_mono)
  moreover have "?B \<Longrightarrow> \<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>F \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F"
  proof(-)
    assume "?B"
    then obtain S\<^sub>P S\<^sub>F where S\<^sub>PS\<^sub>F_def: "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F" "S\<^sub>P\<in>P" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P S\<^sub>F" by blast
    obtain S\<^sub>F' where S\<^sub>F'_def: "S\<^sub>F' = {\<sigma>\<^sub>F\<in>S\<^sub>F. \<exists>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>P\<in>S\<^sub>P. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F}" by simp
    then have "S\<^sub>F'\<in>F" using S\<^sub>PS\<^sub>F_def(3) assms(1) by auto
    moreover have "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F'" 
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then obtain \<sigma>\<^sub>P \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<in>S\<^sub>P" "\<sigma>\<^sub>F\<in>S\<^sub>F" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using S\<^sub>PS\<^sub>F_def(1) unfolding star_via_hAdd by blast
      then have "\<sigma>\<^sub>F\<in>S\<^sub>F" unfolding S\<^sub>F'_def using \<open>\<sigma>\<in>S\<close> by blast
      then show "\<sigma>\<in>S\<^sub>P\<^emph>S\<^sub>F'" unfolding star_via_hAdd using \<open>\<sigma>\<^sub>P\<in>S\<^sub>P\<close> \<open>hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> S\<^sub>F'_def \<open>\<sigma> \<in> S\<close> by blast
    qed
    moreover have "left_lives S S\<^sub>P S\<^sub>F'" unfolding S\<^sub>F'_def using \<open>left_lives S S\<^sub>P S\<^sub>F\<close> unfolding left_lives_def by fast
    moreover have "right_lives S S\<^sub>P S\<^sub>F'" using S\<^sub>F'_def unfolding right_lives_equiv by auto
    ultimately show "\<exists>S\<^sub>P S\<^sub>F. S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>P \<and> S\<^sub>F\<in>F \<and> left_lives S S\<^sub>P S\<^sub>F \<and> right_lives S S\<^sub>P S\<^sub>F" using S\<^sub>PS\<^sub>F_def(2) by blast
  qed
  ultimately show ?thesis by argo
qed

(*Property 1*)
lemma hstar_unit:
  "P\<star>{S. S\<subseteq>{(s, fmap_empty)| s. True}}=P" (is "P\<star>?U=P")
proof
  show "P\<star>?U\<subseteq>P"
  proof
    fix S
    assume "S\<in>P\<star>?U"
    then obtain S\<^sub>P S\<^sub>U where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>U" "S\<^sub>P\<in>P" "S\<^sub>U\<in>?U" "left_lives S S\<^sub>P S\<^sub>U" "right_lives S S\<^sub>P S\<^sub>U" unfolding hstar_def by blast
    have "S=S\<^sub>P" 
    proof
      show "S\<subseteq>S\<^sub>P" by (metis (no_types, lifting) \<open>S \<subseteq> S\<^sub>P \<^emph> S\<^sub>U\<close> \<open>S\<^sub>U \<in> {S. S \<subseteq> {(s, fmap_empty) |s. True}}\<close> mem_Collect_eq order_refl order_trans star_mono star_unit)
      show "S\<^sub>P\<subseteq>S"
      proof(-)
        have "\<And>s h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P \<Longrightarrow> (s, h\<^sub>P)\<in>S"
        proof(-)
          fix s h\<^sub>P
          assume "(s, h\<^sub>P)\<in>S\<^sub>P"
          then obtain \<sigma> \<sigma>\<^sub>U where "\<sigma>\<in>S" "\<sigma>\<^sub>U\<in>S\<^sub>U" "hAdd \<sigma> (s, h\<^sub>P) \<sigma>\<^sub>U" using \<open>left_lives S S\<^sub>P S\<^sub>U\<close> unfolding left_lives_def by auto
          then obtain h h\<^sub>U where "\<sigma>=(s, h)" "\<sigma>\<^sub>U=(s, h\<^sub>U)" "(s, h)\<in>S" "(s, h\<^sub>U)\<in>S\<^sub>U" "h=h\<^sub>P++\<^sub>fh\<^sub>U" "h\<^sub>P\<bottom>h\<^sub>U" unfolding hAdd_def by (metis fst_conv prod.exhaust_sel snd_conv)
          then have "h=h\<^sub>P" using \<open>S\<^sub>U\<in>?U\<close> fmap_add_empty by blast
          then show "(s, h\<^sub>P)\<in>S" using \<open>(s, h)\<in>S\<close> by auto
        qed
        then show ?thesis by force
      qed
    qed
    then show "S\<in>P" using \<open>S\<^sub>P\<in>P\<close> by fastforce
  qed
  show "P\<subseteq>P\<star>?U"
  proof
    fix S
    assume "S\<in>P"
    obtain S\<^sub>U where S\<^sub>U_def: "S\<^sub>U = ({(s, fmap_empty)| s h. (s, h)\<in>S} :: assertion)" "S\<^sub>U\<in>?U" by auto
    moreover have "S\<subseteq>S\<^emph>S\<^sub>U"
    proof(-)
      have "\<And>s h. (s, h)\<in>S \<Longrightarrow> (s, h)\<in>S\<^emph>S\<^sub>U"
      proof(-)
        fix s h
        assume asm: "(s, h)\<in>S"
        then have "(s, fmap_empty)\<in>S\<^sub>U" unfolding S\<^sub>U_def by blast
        moreover have "hAdd (s, h) (s, h) (s, fmap_empty)" unfolding hAdd_def compat_def by simp
        ultimately show "(s, h)\<in>S\<^emph>S\<^sub>U" using asm \<open>(s, fmap_empty)\<in>S\<^sub>U\<close> unfolding star_def using hAdd_prop by blast
      qed
      then show ?thesis by auto
    qed
    moreover have "left_lives S S S\<^sub>U" unfolding left_lives_def S\<^sub>U_def hAdd_def compat_def apply simp by (metis prod.collapse)
    moreover have "right_lives S S S\<^sub>U" unfolding right_lives_equiv S\<^sub>U_def hAdd_def compat_def apply simp by (metis fstI)
    ultimately show "S\<in>P\<star>?U" using \<open>S\<in>P\<close> unfolding hstar_def by auto
  qed
qed

(*Property 2*)
lemma hstar_comm: "P\<star>Q=Q\<star>P"
  unfolding hstar_def using right_lives_def star_comm apply simp by blast

(*Property 3*)
lemma hstar_via_triples:
  "P\<star>Q = {S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
proof
  show "P\<star>Q \<subseteq> {S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
  proof
    fix S
    assume "S\<in>P\<star>Q"
    then obtain S\<^sub>P S\<^sub>Q where S\<^sub>PS\<^sub>Q_def: "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" using hstar_def by auto
    obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>S\<^sub>P \<and> \<sigma>\<^sub>Q\<in>S\<^sub>Q \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q}" by auto
    then have "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" by blast
    moreover have "fst`\<tau>=S"
    proof
      show "fst`\<tau>\<subseteq>S" using \<tau>_def by fastforce
      show "S\<subseteq>fst`\<tau>"
      proof
        fix \<sigma>
        assume asm: "\<sigma>\<in>S"
        moreover have "\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma>\<^sub>Q\<in>S\<^sub>Q. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(1-3) star_via_hAdd by fastforce
        ultimately obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q where \<sigma>\<^sub>P\<sigma>\<^sub>Q_def: "\<sigma>\<^sub>P\<in>S\<^sub>P" "\<sigma>\<^sub>Q\<in>S\<^sub>Q" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" by blast
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<in>fst`\<tau>" by force
      qed
    qed
    moreover have "fst`snd`\<tau>=S\<^sub>P"
    proof
      show "fst`snd`\<tau>\<subseteq>S\<^sub>P" using \<tau>_def by fastforce
      show "S\<^sub>P\<subseteq>fst`snd`\<tau>"
      proof
        fix \<sigma>\<^sub>P
        assume asm: "\<sigma>\<^sub>P\<in>S\<^sub>P"
        then obtain \<sigma> \<sigma>\<^sub>Q where \<sigma>\<sigma>\<^sub>Q_def: "\<sigma>\<in>S" "\<sigma>\<^sub>Q\<in>S\<^sub>Q" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(2-4) left_lives_def by auto
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>" by force
      qed
    qed
    then have "fst`snd`\<tau>\<in>P" using S\<^sub>PS\<^sub>Q_def(2) by blast
    moreover have "snd`snd`\<tau>=S\<^sub>Q"
    proof
      show "snd`snd`\<tau>\<subseteq>S\<^sub>Q" using \<tau>_def by fastforce
      show "S\<^sub>Q\<subseteq>snd`snd`\<tau>"
      proof
        fix \<sigma>\<^sub>Q
        assume asm: "\<sigma>\<^sub>Q\<in>S\<^sub>Q"
        then obtain \<sigma> \<sigma>\<^sub>P where \<sigma>\<sigma>\<^sub>P_def: "\<sigma>\<in>S" "\<sigma>\<^sub>P\<in>S\<^sub>P" "hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" using S\<^sub>PS\<^sub>Q_def(2,3,5) right_lives_equiv by auto
        then have "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" using \<tau>_def asm by blast
        then show "\<sigma>\<^sub>Q\<in>snd`snd`\<tau>" by force
      qed
    qed
    then have "snd`snd`\<tau>\<in>Q" using S\<^sub>PS\<^sub>Q_def(3) by blast
    ultimately show "S\<in>{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}" by blast
  qed
  show "{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q} \<subseteq> P\<star>Q"
  proof
    fix S
    assume "S\<in>{S. \<exists>\<tau>. (\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q}"
    then obtain \<tau> where \<tau>_def: "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=S" "fst`snd`\<tau>\<in>P" "snd`snd`\<tau>\<in>Q" by blast
    then obtain S\<^sub>P S\<^sub>Q where S\<^sub>PS\<^sub>Q_def: "S\<^sub>P=fst`snd`\<tau>" "S\<^sub>Q=snd`snd`\<tau>" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" by blast
    moreover have "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S"
      then have "\<sigma>\<in>fst`\<tau>" using \<tau>_def(2) by blast
      then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q where "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>" by force
      then have "\<sigma>\<^sub>P\<in>S\<^sub>P \<and> \<sigma>\<^sub>Q\<in>S\<^sub>Q \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" unfolding S\<^sub>PS\<^sub>Q_def using \<tau>_def(1) by force
      then show "\<sigma>\<in>S\<^sub>P\<^emph>S\<^sub>Q" unfolding star_via_hAdd by fast
    qed
    moreover have "left_lives S S\<^sub>P S\<^sub>Q" using \<tau>_def S\<^sub>PS\<^sub>Q_def left_lives_def by fastforce
    moreover have "right_lives S S\<^sub>P S\<^sub>Q" using \<tau>_def S\<^sub>PS\<^sub>Q_def right_lives_equiv by fastforce
    ultimately show "S\<in>P\<star>Q" unfolding hstar_def by blast
  qed
qed

lemma hstar_assoc_auxL:
  "(P\<star>Q)\<star>R = {S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}"
proof
  have "(P\<star>Q)\<star>R = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P\<star>Q \<and> snd`snd`\<tau>\<in>R}" using hstar_via_triples by presburger
  moreover have "... = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>{S. \<exists>\<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>\<^sub>P\<^sub>Q=S \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q} \<and> snd`snd`\<tau>\<in>R}" using hstar_via_triples by presburger
  moreover have "... = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> (\<exists>\<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q) \<and> snd`snd`\<tau>\<in>R}" by simp
  moreover have "... = {S. \<exists>\<tau> \<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q \<and> snd`snd`\<tau>\<in>R}" by auto
  ultimately have 0: "(P\<star>Q)\<star>R = {S. \<exists>\<tau> \<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q \<and> snd`snd`\<tau>\<in>R}" by argo

  have "\<And>S \<tau> \<tau>\<^sub>P\<^sub>Q. \<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<Longrightarrow> \<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q \<Longrightarrow> fst`\<tau>=S \<Longrightarrow> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<Longrightarrow> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<Longrightarrow> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q \<Longrightarrow> snd`snd`\<tau>\<in>R \<Longrightarrow>
                 \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R"
  proof(-)
    fix S \<tau> \<tau>\<^sub>P\<^sub>Q
    assume asm: "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" "\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=S" "fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau>" "fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P" "snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q" "snd`snd`\<tau>\<in>R"
    obtain \<T> where \<T>_def: "\<T> = {(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. \<exists>\<sigma>\<^sub>P\<^sub>Q. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau> \<and> (\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q}" by blast
    have "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1,2) unfolding \<T>_def by fast
    moreover have "fst`\<T>=S"
    proof(-)
      have "fst`\<T> = fst`\<tau>"
      proof
        show "fst`\<T> \<subseteq> fst`\<tau>" unfolding \<T>_def by force
        show "fst`\<tau> \<subseteq> fst`\<T>"
        proof
          fix \<sigma>\<^sub>P\<^sub>Q\<^sub>R
          assume "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<tau>"
          then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`snd`\<tau>" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`\<tau>\<^sub>P\<^sub>Q" using asm(4) by argo
          then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<close> by blast
          then show "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<T>" by force
        qed
      qed
      then show ?thesis using asm(3) by argo
    qed
    moreover have "fst`snd`\<T>\<in>P"
    proof(-)
      have "fst`snd`\<T> = fst`snd`\<tau>\<^sub>P\<^sub>Q"
      proof
        show "fst`snd`\<T> \<subseteq> fst`snd`\<tau>\<^sub>P\<^sub>Q" unfolding \<T>_def by force
        show "fst`snd`\<tau>\<^sub>P\<^sub>Q \<subseteq> fst`snd`\<T>"
        proof
          fix \<sigma>\<^sub>P
          assume "\<sigma>\<^sub>P\<in>fst`snd`\<tau>\<^sub>P\<^sub>Q"
          then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`\<tau>\<^sub>P\<^sub>Q" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`snd`\<tau>" using asm(4) by argo
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q\<close> by blast
          then show "\<sigma>\<^sub>P\<in>fst`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(5) by presburger
    qed
    moreover have "fst`snd`snd`\<T>\<in>Q"
    proof(-)
      have "fst`snd`snd`\<T> = snd`snd`\<tau>\<^sub>P\<^sub>Q"
      proof
        show "fst`snd`snd`\<T> \<subseteq> snd`snd`\<tau>\<^sub>P\<^sub>Q" unfolding \<T>_def by force
        show "snd`snd`\<tau>\<^sub>P\<^sub>Q \<subseteq> fst`snd`snd`\<T>"
        proof
          fix \<sigma>\<^sub>Q
          assume "\<sigma>\<^sub>Q\<in>snd`snd`\<tau>\<^sub>P\<^sub>Q"
          then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P where "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`\<tau>\<^sub>P\<^sub>Q" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`snd`\<tau>" using asm(4) by argo
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q\<close> by blast
          then show "\<sigma>\<^sub>Q\<in>fst`snd`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(6) by presburger
    qed
    moreover have "snd`snd`snd`\<T>\<in>R"
    proof(-)
      have "snd`snd`snd`\<T> = snd`snd`\<tau>"
      proof
        show "snd`snd`snd`\<T> \<subseteq> snd`snd`\<tau>" unfolding \<T>_def by force
        show "snd`snd`\<tau> \<subseteq> snd`snd`snd`\<T>"
        proof
          fix \<sigma>\<^sub>R
          assume "\<sigma>\<^sub>R\<in>snd`snd`\<tau>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`snd`\<tau>" by force
          then have "\<sigma>\<^sub>P\<^sub>Q\<in>fst`\<tau>\<^sub>P\<^sub>Q" using asm(4) by argo
          then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<close> by blast
          then show "\<sigma>\<^sub>R\<in>snd`snd`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(7) by presburger
    qed
    ultimately show "\<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R" by blast
  qed
  then show "(P\<star>Q)\<star>R \<subseteq> {S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}" unfolding "0" by force

  have "\<And>S \<T>. \<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q \<Longrightarrow> fst`\<T>=S \<Longrightarrow> fst`snd`\<T>\<in>P \<Longrightarrow> fst`snd`snd`\<T>\<in>Q \<Longrightarrow> snd`snd`snd`\<T>\<in>R \<Longrightarrow>
                 \<exists>\<tau> \<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q \<and> snd`snd`\<tau>\<in>R"
  proof(-)
    fix S \<T>
    assume asm: "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<T>=S" "fst`snd`\<T>\<in>P" "fst`snd`snd`\<T>\<in>Q" "snd`snd`snd`\<T>\<in>R"
    obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T> \<and> hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q}" by blast
    then have "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" using asm(1) by blast
    moreover obtain \<tau>\<^sub>P\<^sub>Q where \<tau>\<^sub>P\<^sub>Q_def: "\<tau>\<^sub>P\<^sub>Q={(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T> \<and> hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q}"by blast
    then have "\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1) by blast
    moreover have "fst`\<tau>=S"
    proof(-)
      have "fst`\<tau> = fst`\<T>"
      proof
        show "fst`\<tau> \<subseteq> fst`\<T>" unfolding \<tau>_def by force
        show "fst`\<T> \<subseteq> fst`\<tau>"
        proof
          fix \<sigma>\<^sub>P\<^sub>Q\<^sub>R
          assume "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<T>"
          then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>P\<^sub>Q where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" "hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>_def by blast
          then show "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<tau>" by force
        qed
      qed
      then show ?thesis using asm(2) by argo
    qed
    moreover have "fst`\<tau>\<^sub>P\<^sub>Q = fst`snd`\<tau>"
    proof
      show "fst`\<tau>\<^sub>P\<^sub>Q \<subseteq> fst`snd`\<tau>" unfolding \<tau>_def \<tau>\<^sub>P\<^sub>Q_def by force
      show "fst`snd`\<tau> \<subseteq> fst`\<tau>\<^sub>P\<^sub>Q" unfolding \<tau>_def \<tau>\<^sub>P\<^sub>Q_def by force
    qed
    moreover have "fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P"
    proof(-)
      have "fst`snd`\<tau>\<^sub>P\<^sub>Q = fst`snd`\<T>"
      proof
        show "fst`snd`\<tau>\<^sub>P\<^sub>Q \<subseteq> fst`snd`\<T>" unfolding \<tau>\<^sub>P\<^sub>Q_def by force
        show "fst`snd`\<T> \<subseteq>fst`snd`\<tau>\<^sub>P\<^sub>Q"
        proof
          fix \<sigma>\<^sub>P
          assume "\<sigma>\<^sub>P\<in>fst`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>P\<^sub>Q where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" "hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>\<^sub>P\<^sub>Q_def by blast
          then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>\<^sub>P\<^sub>Q" by force
        qed
      qed
      then show ?thesis using asm(3) by argo
    qed
    moreover have "snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q"
    proof(-)
      have "snd`snd`\<tau>\<^sub>P\<^sub>Q = fst`snd`snd`\<T>"
      proof
        show "snd`snd`\<tau>\<^sub>P\<^sub>Q \<subseteq> fst`snd`snd`\<T>" unfolding \<tau>\<^sub>P\<^sub>Q_def by force
        show "fst`snd`snd`\<T> \<subseteq>snd`snd`\<tau>\<^sub>P\<^sub>Q"
        proof
          fix \<sigma>\<^sub>Q
          assume "\<sigma>\<^sub>Q\<in>fst`snd`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>P\<^sub>Q where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" "hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>\<^sub>P\<^sub>Q_def by blast
          then show "\<sigma>\<^sub>Q\<in>snd`snd`\<tau>\<^sub>P\<^sub>Q" by force
        qed
      qed
      then show ?thesis using asm(4) by argo
    qed
    moreover have "snd`snd`\<tau>\<in>R"
    proof(-)
      have "snd`snd`\<tau> = snd`snd`snd`\<T>"
      proof
        show "snd`snd`\<tau> \<subseteq> snd`snd`snd`\<T>" unfolding \<tau>_def by force
        show "snd`snd`snd`\<T> \<subseteq>snd`snd`\<tau>"
        proof
          fix \<sigma>\<^sub>R
          assume "\<sigma>\<^sub>R\<in>snd`snd`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>P\<^sub>Q where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R" "hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>_def by blast
          then show "\<sigma>\<^sub>R\<in>snd`snd`\<tau>" by force
        qed
      qed
      then show ?thesis using asm(5) by argo
    qed
    ultimately show "\<exists>\<tau> \<tau>\<^sub>P\<^sub>Q. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>P\<^sub>Q=fst`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>P\<^sub>Q\<in>P \<and> snd`snd`\<tau>\<^sub>P\<^sub>Q\<in>Q \<and> snd`snd`\<tau>\<in>R" by blast
  qed
  then show "{S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R} \<subseteq> (P\<star>Q)\<star>R" unfolding "0" by force
qed

lemma hstar_assoc_auxR:
  "P\<star>(Q\<star>R) = {S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}"
proof
  have "P\<star>(Q\<star>R) = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>Q\<star>R}" using hstar_via_triples by presburger
  moreover have "... = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> snd`snd`\<tau>\<in>{S. \<exists>\<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>\<^sub>Q\<^sub>R=S \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R}}" using hstar_via_triples by presburger
  moreover have "... = {S. \<exists>\<tau>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> fst`\<tau>=S \<and> fst`snd`\<tau>\<in>P \<and> (\<exists>\<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R)}" by simp
  moreover have "... = {S. \<exists>\<tau> \<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<and> fst`snd`\<tau>\<in>P \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R}" by auto
  ultimately have 0: "P\<star>(Q\<star>R) = {S. \<exists>\<tau> \<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<and> fst`snd`\<tau>\<in>P \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R}" by argo

  have "\<And>S \<tau> \<tau>\<^sub>Q\<^sub>R. \<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<Longrightarrow> \<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R \<Longrightarrow> fst`\<tau>=S \<Longrightarrow> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<Longrightarrow> fst`snd`\<tau>\<in>P \<Longrightarrow> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<Longrightarrow> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R \<Longrightarrow>
                 \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R"
  proof(-)
    fix S \<tau> \<tau>\<^sub>Q\<^sub>R
    assume asm: "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" "\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" "fst`\<tau>=S" "fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau>" "fst`snd`\<tau>\<in>P" "fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q" "snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R"
    obtain \<T> where \<T>_def: "\<T> = {(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. \<exists>\<sigma>\<^sub>Q\<^sub>R. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau> \<and> (\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R}" by blast
    have "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1,2) unfolding \<T>_def by fast
    moreover have "fst`\<T>=S"
    proof(-)
      have "fst`\<T> = fst`\<tau>"
      proof
        show "fst`\<T> \<subseteq> fst`\<tau>" unfolding \<T>_def by force
        show "fst`\<tau> \<subseteq> fst`\<T>"
        proof
          fix \<sigma>\<^sub>P\<^sub>Q\<^sub>R
          assume "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<tau>"
          then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>snd`snd`\<tau>" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>fst`\<tau>\<^sub>Q\<^sub>R" using asm(4) by argo
          then obtain \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>\<close> by blast
          then show "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<T>" by force
        qed
      qed
      then show ?thesis using asm(3) by argo
    qed
    moreover have "fst`snd`\<T>\<in>P"
    proof(-)
      have "fst`snd`\<T> = fst`snd`\<tau>"
      proof
        show "fst`snd`\<T> \<subseteq> fst`snd`\<tau>" unfolding \<T>_def by force
        show "fst`snd`\<tau> \<subseteq> fst`snd`\<T>"
        proof
          fix \<sigma>\<^sub>P
          assume "\<sigma>\<^sub>P\<in>fst`snd`\<tau>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>Q\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>snd`snd`\<tau>" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>fst`\<tau>\<^sub>Q\<^sub>R" using asm(4) by argo
          then obtain \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>\<close> by blast
          then show "\<sigma>\<^sub>P\<in>fst`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(5) by presburger
    qed
    moreover have "fst`snd`snd`\<T>\<in>Q"
    proof(-)
      have "fst`snd`snd`\<T> = fst`snd`\<tau>\<^sub>Q\<^sub>R"
      proof
        show "fst`snd`snd`\<T> \<subseteq> fst`snd`\<tau>\<^sub>Q\<^sub>R" unfolding \<T>_def by force
        show "fst`snd`\<tau>\<^sub>Q\<^sub>R \<subseteq> fst`snd`snd`\<T>"
        proof
          fix \<sigma>\<^sub>Q
          assume "\<sigma>\<^sub>Q\<in>fst`snd`\<tau>\<^sub>Q\<^sub>R"
          then obtain \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>R where "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>fst`\<tau>\<^sub>Q\<^sub>R" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>snd`snd`\<tau>" using asm(4) by argo
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R\<close> by blast
          then show "\<sigma>\<^sub>Q\<in>fst`snd`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(6) by presburger
    qed
    moreover have "snd`snd`snd`\<T>\<in>R"
    proof(-)
      have "snd`snd`snd`\<T> = snd`snd`\<tau>\<^sub>Q\<^sub>R"
      proof
        show "snd`snd`snd`\<T> \<subseteq> snd`snd`\<tau>\<^sub>Q\<^sub>R" unfolding \<T>_def by force
        show "snd`snd`\<tau>\<^sub>Q\<^sub>R \<subseteq> snd`snd`snd`\<T>"
        proof
          fix \<sigma>\<^sub>R
          assume "\<sigma>\<^sub>R\<in>snd`snd`\<tau>\<^sub>Q\<^sub>R"
          then obtain \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q where "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>fst`\<tau>\<^sub>Q\<^sub>R" by force
          then have "\<sigma>\<^sub>Q\<^sub>R\<in>snd`snd`\<tau>" using asm(4) by argo
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" by force
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" using \<T>_def \<open>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R\<close> by blast
          then show "\<sigma>\<^sub>R\<in>snd`snd`snd`\<T>" by force
        qed
      qed
      then show ?thesis using asm(7) by presburger
    qed
    ultimately show "\<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R" by blast
  qed
  then show "P\<star>(Q\<star>R) \<subseteq> {S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}" unfolding "0" by force

  have "\<And>S \<T>. \<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R \<Longrightarrow> fst`\<T>=S \<Longrightarrow> fst`snd`\<T>\<in>P \<Longrightarrow> fst`snd`snd`\<T>\<in>Q \<Longrightarrow> snd`snd`snd`\<T>\<in>R \<Longrightarrow>
                 \<exists>\<tau> \<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<and> fst`snd`\<tau>\<in>P \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R"
  proof(-)
    fix S \<T>
    assume asm: "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" "fst`\<T>=S" "fst`snd`\<T>\<in>P" "fst`snd`snd`\<T>\<in>Q" "snd`snd`snd`\<T>\<in>R"
    obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T> \<and> hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R}" by blast
    then have "\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" using asm(1) by blast
    moreover obtain \<tau>\<^sub>Q\<^sub>R where \<tau>\<^sub>Q\<^sub>R_def: "\<tau>\<^sub>Q\<^sub>R={(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)| \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R. (\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T> \<and> hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R}"by blast
    then have "\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1) by blast
    moreover have "fst`\<tau>=S"
    proof(-)
      have "fst`\<tau> = fst`\<T>"
      proof
        show "fst`\<tau> \<subseteq> fst`\<T>" unfolding \<tau>_def by force
        show "fst`\<T> \<subseteq> fst`\<tau>"
        proof
          fix \<sigma>\<^sub>P\<^sub>Q\<^sub>R
          assume "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<T>"
          then obtain \<sigma>\<^sub>P \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>Q\<^sub>R where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" "hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>_def by blast
          then show "\<sigma>\<^sub>P\<^sub>Q\<^sub>R\<in>fst`\<tau>" by force
        qed
      qed
      then show ?thesis using asm(2) by argo
    qed
    moreover have "fst`\<tau>\<^sub>Q\<^sub>R = snd`snd`\<tau>"
    proof
      show "fst`\<tau>\<^sub>Q\<^sub>R \<subseteq> snd`snd`\<tau>" unfolding \<tau>_def \<tau>\<^sub>Q\<^sub>R_def by force
      show "snd`snd`\<tau> \<subseteq> fst`\<tau>\<^sub>Q\<^sub>R" unfolding \<tau>_def \<tau>\<^sub>Q\<^sub>R_def by force
    qed
    moreover have "fst`snd`\<tau>\<in>P"
    proof(-)
      have "fst`snd`\<tau> = fst`snd`\<T>"
      proof
        show "fst`snd`\<tau> \<subseteq> fst`snd`\<T>" unfolding \<tau>_def by force
        show "fst`snd`\<T> \<subseteq>fst`snd`\<tau>"
        proof
          fix \<sigma>\<^sub>P
          assume "\<sigma>\<^sub>P\<in>fst`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>Q\<^sub>R where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" "hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1) by fast
          then have "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>_def by blast
          then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>" by force
        qed
      qed
      then show ?thesis using asm(3) by argo
    qed
    moreover have "fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q"
    proof(-)
      have "fst`snd`\<tau>\<^sub>Q\<^sub>R = fst`snd`snd`\<T>"
      proof
        show "fst`snd`\<tau>\<^sub>Q\<^sub>R \<subseteq> fst`snd`snd`\<T>" unfolding \<tau>\<^sub>Q\<^sub>R_def by force
        show "fst`snd`snd`\<T> \<subseteq>fst`snd`\<tau>\<^sub>Q\<^sub>R"
        proof
          fix \<sigma>\<^sub>Q
          assume "\<sigma>\<^sub>Q\<in>fst`snd`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>R where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>Q\<^sub>R where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" "hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1) by fast
          then have "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>\<^sub>Q\<^sub>R_def by blast
          then show "\<sigma>\<^sub>Q\<in>fst`snd`\<tau>\<^sub>Q\<^sub>R" by force
        qed
      qed
      then show ?thesis using asm(4) by argo
    qed
    moreover have "snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R"
    proof(-)
      have "snd`snd`\<tau>\<^sub>Q\<^sub>R = snd`snd`snd`\<T>"
      proof
        show "snd`snd`\<tau>\<^sub>Q\<^sub>R \<subseteq> snd`snd`snd`\<T>" unfolding \<tau>\<^sub>Q\<^sub>R_def by force
        show "snd`snd`snd`\<T> \<subseteq>snd`snd`\<tau>\<^sub>Q\<^sub>R"
        proof
          fix \<sigma>\<^sub>R
          assume "\<sigma>\<^sub>R\<in>snd`snd`snd`\<T>"
          then obtain \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q where "(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>" by force
          then obtain \<sigma>\<^sub>Q\<^sub>R where "hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R" "hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R" using asm(1) by fast
          then have "(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R" using \<open>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>\<close> unfolding \<tau>\<^sub>Q\<^sub>R_def by blast
          then show "\<sigma>\<^sub>R\<in>snd`snd`\<tau>\<^sub>Q\<^sub>R" by force
        qed
      qed
      then show ?thesis using asm(5) by argo
    qed
    ultimately show " \<exists>\<tau> \<tau>\<^sub>Q\<^sub>R. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q\<^sub>R)\<in>\<tau>. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R) \<and> (\<forall>(\<sigma>\<^sub>Q\<^sub>R, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<tau>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<tau>=S \<and> fst`\<tau>\<^sub>Q\<^sub>R=snd`snd`\<tau> \<and> fst`snd`\<tau>\<in>P \<and> fst`snd`\<tau>\<^sub>Q\<^sub>R\<in>Q \<and> snd`snd`\<tau>\<^sub>Q\<^sub>R\<in>R" by blast
  qed
  then show "{S. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R} \<subseteq> P\<star>(Q\<star>R)" unfolding "0" by force
qed

lemma hstar_assoc:
  "(P\<star>Q)\<star>R = P\<star>(Q\<star>R)"
proof(-)
  have "\<And>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<longleftrightarrow> (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R)" using hAdd_assoc hAdd_assoc' by fast
  moreover have "(P\<star>Q)\<star>R = {S\<^sub>P\<^sub>Q\<^sub>R. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>P\<^sub>Q. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>R \<and> hAdd \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>P \<sigma>\<^sub>Q) \<and> fst`\<T>=S\<^sub>P\<^sub>Q\<^sub>R \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}" using hstar_assoc_auxL by presburger
  moreover have "P\<star>(Q\<star>R) = {S\<^sub>P\<^sub>Q\<^sub>R. \<exists>\<T>. (\<forall>(\<sigma>\<^sub>P\<^sub>Q\<^sub>R, \<sigma>\<^sub>P, \<sigma>\<^sub>Q, \<sigma>\<^sub>R)\<in>\<T>. \<exists>\<sigma>\<^sub>Q\<^sub>R. hAdd \<sigma>\<^sub>P\<^sub>Q\<^sub>R \<sigma>\<^sub>P \<sigma>\<^sub>Q\<^sub>R \<and> hAdd \<sigma>\<^sub>Q\<^sub>R \<sigma>\<^sub>Q \<sigma>\<^sub>R) \<and> fst`\<T>=S\<^sub>P\<^sub>Q\<^sub>R \<and> fst`snd`\<T>\<in>P \<and> fst`snd`snd`\<T>\<in>Q \<and> snd`snd`snd`\<T>\<in>R}" using hstar_assoc_auxR by presburger
  ultimately show ?thesis by presburger
qed

(*Property 4*)
lemma hstar_mono: "P\<subseteq>P' \<Longrightarrow> Q\<subseteq>Q' \<Longrightarrow> P\<star>Q\<subseteq>P'\<star>Q'"
  unfolding hstar_def by blast

(*Property 5*)
lemma hstar_distr_over_union: "(P\<union>P')\<star>Q = (P\<star>Q) \<union> (P'\<star>Q)"
  unfolding hstar_def by auto

(*Property 6*)
lemma hstar_distr_over_indexed_union: "(\<Union>P\<in>X. P)\<star>Q = (\<Union>P\<in>X. P\<star>Q)"
  unfolding hstar_def by auto

(*Property 7*)
lemma hstar_distr_over_join:
  assumes "\<And>S S'. S\<in>F \<Longrightarrow> S'\<in>F \<Longrightarrow> S\<union>S'\<in>F"
      and "\<And>S S'. S\<in>F \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>F"
    shows "(P\<otimes>Q)\<star>F = (P\<star>F)\<otimes>(Q\<star>F)"
proof
  show "(P\<star>F)\<otimes>(Q\<star>F) \<subseteq> (P\<otimes>Q)\<star>F"
  proof
    fix S\<^sub>i\<^sub>n
    assume "S\<^sub>i\<^sub>n\<in>(P\<star>F)\<otimes>(Q\<star>F)"
    then obtain S S' where SS'_def: "S\<^sub>i\<^sub>n=S\<union>S'" "S\<in>P\<star>F" "S'\<in>Q\<star>F" unfolding join_def by blast
    from SS'_def(2) obtain S\<^sub>P S\<^sub>F where S\<^sub>PS\<^sub>F_def: "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>F" "S\<^sub>P\<in>P" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P S\<^sub>F" "right_lives S S\<^sub>P S\<^sub>F" unfolding hstar_def by force
    from SS'_def(3) obtain S\<^sub>P' S\<^sub>F' where S\<^sub>P'S\<^sub>F'_def: "S'\<subseteq>S\<^sub>P'\<^emph>S\<^sub>F'" "S\<^sub>P'\<in>Q" "S\<^sub>F'\<in>F" "left_lives S' S\<^sub>P' S\<^sub>F'" "right_lives S' S\<^sub>P' S\<^sub>F'" unfolding hstar_def by force
    have "S\<^sub>P\<union>S\<^sub>P'\<in>P\<otimes>Q" using S\<^sub>PS\<^sub>F_def(2) S\<^sub>P'S\<^sub>F'_def(2) join_def by blast
    moreover have "S\<^sub>F\<union>S\<^sub>F'\<in>F" using S\<^sub>PS\<^sub>F_def(3) S\<^sub>P'S\<^sub>F'_def(3) assms(1) by blast
    moreover have "S\<union>S'\<subseteq>(S\<^sub>P\<union>S\<^sub>P')\<^emph>(S\<^sub>F\<union>S\<^sub>F')" using SS'_def(1) S\<^sub>PS\<^sub>F_def(1) S\<^sub>P'S\<^sub>F'_def(1) star_comm star_mono by (smt (verit, ccfv_SIG)  Un_subset_iff subset_trans sup.cobounded1 sup.cobounded2)
    moreover have "left_lives (S\<union>S') (S\<^sub>P\<union>S\<^sub>P') (S\<^sub>F\<union>S\<^sub>F')" using S\<^sub>PS\<^sub>F_def(4) S\<^sub>P'S\<^sub>F'_def(4) unfolding left_lives_def by fast
    moreover have "right_lives (S\<union>S') (S\<^sub>P\<union>S\<^sub>P') (S\<^sub>F\<union>S\<^sub>F')" using S\<^sub>PS\<^sub>F_def(5) S\<^sub>P'S\<^sub>F'_def(5) unfolding right_lives_equiv by fast
    ultimately show "S\<^sub>i\<^sub>n\<in>(P\<otimes>Q)\<star>F" using SS'_def(1) unfolding hstar_def by blast
  qed
  show "(P\<otimes>Q)\<star>F \<subseteq> (P\<star>F)\<otimes>(Q\<star>F)"
  proof
    fix S
    assume "S\<in>(P\<otimes>Q)\<star>F"
    then obtain S\<^sub>P\<^sub>Q S\<^sub>F where "S\<subseteq>S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F" "S\<^sub>P\<^sub>Q\<in>P\<otimes>Q" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P\<^sub>Q S\<^sub>F" unfolding hstar_def by blast
    then obtain S\<^sub>P S\<^sub>Q where "S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" unfolding join_def by blast
    obtain \<tau>\<^sub>P\<^sub>F where \<tau>\<^sub>P\<^sub>F_def: "\<tau>\<^sub>P\<^sub>F = {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>S\<^sub>P \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F}" by blast
    moreover have "left_lives S S\<^sub>P S\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>left_lives S S\<^sub>P\<^sub>Q S\<^sub>F\<close> left_lives_def by auto
    then have "\<forall>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using \<open>S\<^sub>F\<in>F\<close> unfolding left_lives_def by blast
    have "fst`snd`\<tau>\<^sub>P\<^sub>F=S\<^sub>P"
    proof
      show "fst`snd`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<^sub>P" unfolding \<tau>\<^sub>P\<^sub>F_def by fastforce
      show "S\<^sub>P\<subseteq>fst`snd`\<tau>\<^sub>P\<^sub>F"
      proof
        fix \<sigma>\<^sub>P
        assume "\<sigma>\<^sub>P\<in>S\<^sub>P"
        then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>F" using \<open>\<forall>\<sigma>\<^sub>P\<in>S\<^sub>P. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> \<tau>\<^sub>P\<^sub>F_def by fast
        then show "\<sigma>\<^sub>P\<in>fst`snd`\<tau>\<^sub>P\<^sub>F" by force
      qed
    qed
    have "fst`\<tau>\<^sub>P\<^sub>F\<subseteq>S" "snd`snd`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<^sub>F" using \<tau>\<^sub>P\<^sub>F_def by auto
    then have "snd`snd`\<tau>\<^sub>P\<^sub>F\<in>F" using \<open>S\<^sub>F \<in> F\<close> assms(2) by presburger
    moreover have "left_lives (fst`\<tau>\<^sub>P\<^sub>F) (fst`snd`\<tau>\<^sub>P\<^sub>F) (snd`snd`\<tau>\<^sub>P\<^sub>F)" using left_lives_def \<tau>\<^sub>P\<^sub>F_def apply simp by fast
    moreover have "right_lives (fst`\<tau>\<^sub>P\<^sub>F) (fst`snd`\<tau>\<^sub>P\<^sub>F) (snd`snd`\<tau>\<^sub>P\<^sub>F)" using right_lives_equiv \<tau>\<^sub>P\<^sub>F_def apply simp by fast
    moreover have "fst`\<tau>\<^sub>P\<^sub>F\<subseteq>(fst`snd`\<tau>\<^sub>P\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>P\<^sub>F)" unfolding star_via_hAdd \<tau>\<^sub>P\<^sub>F_def by fastforce
    ultimately have "fst`\<tau>\<^sub>P\<^sub>F\<in>P\<star>F" using hstarI \<open>S\<^sub>P\<in>P\<close> \<open>fst`snd`\<tau>\<^sub>P\<^sub>F=S\<^sub>P\<close> by force
  
    obtain \<tau>\<^sub>Q\<^sub>F where \<tau>\<^sub>Q\<^sub>F_def: "\<tau>\<^sub>Q\<^sub>F = {(\<sigma>, \<sigma>\<^sub>Q, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>Q\<in>S\<^sub>Q \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F}" by blast
    moreover have "left_lives S S\<^sub>Q S\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>left_lives S S\<^sub>P\<^sub>Q S\<^sub>F\<close> left_lives_def by auto
    then have "\<forall>\<sigma>\<^sub>Q\<in>S\<^sub>Q. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F" unfolding left_lives_def by blast
    have "fst`snd`\<tau>\<^sub>Q\<^sub>F=S\<^sub>Q"
    proof
      show "fst`snd`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<^sub>Q" unfolding \<tau>\<^sub>Q\<^sub>F_def by fastforce
      show "S\<^sub>Q\<subseteq>fst`snd`\<tau>\<^sub>Q\<^sub>F"
      proof
        fix \<sigma>\<^sub>Q
        assume "\<sigma>\<^sub>Q\<in>S\<^sub>Q"
        then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>Q\<^sub>F" using \<open>\<forall>\<sigma>\<^sub>Q\<in>S\<^sub>Q. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>Q \<sigma>\<^sub>F\<close> \<tau>\<^sub>Q\<^sub>F_def by fast
        then show "\<sigma>\<^sub>Q\<in>fst`snd`\<tau>\<^sub>Q\<^sub>F" by force
      qed
    qed
    have "fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>S" "snd`snd`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<^sub>F" using \<tau>\<^sub>Q\<^sub>F_def by auto
    then have "snd`snd`\<tau>\<^sub>Q\<^sub>F\<in>F" using \<open>S\<^sub>F \<in> F\<close> assms(2) by presburger
    moreover have "left_lives (fst`\<tau>\<^sub>Q\<^sub>F) (fst`snd`\<tau>\<^sub>Q\<^sub>F) (snd`snd`\<tau>\<^sub>Q\<^sub>F)" using left_lives_def \<tau>\<^sub>Q\<^sub>F_def apply simp by fast
    moreover have "right_lives (fst`\<tau>\<^sub>Q\<^sub>F) (fst`snd`\<tau>\<^sub>Q\<^sub>F) (snd`snd`\<tau>\<^sub>Q\<^sub>F)" using right_lives_equiv \<tau>\<^sub>Q\<^sub>F_def apply simp by fast
    moreover have "fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>(fst`snd`\<tau>\<^sub>Q\<^sub>F)\<^emph>(snd`snd`\<tau>\<^sub>Q\<^sub>F)" unfolding star_via_hAdd \<tau>\<^sub>Q\<^sub>F_def by fastforce
    ultimately have "fst`\<tau>\<^sub>Q\<^sub>F\<in>Q\<star>F" using hstarI \<open>S\<^sub>Q\<in>Q\<close> \<open>fst`snd`\<tau>\<^sub>Q\<^sub>F=S\<^sub>Q\<close> by force
  
    moreover have "(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)=S" 
    proof
      show "(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)\<subseteq>S" using \<open>fst`\<tau>\<^sub>P\<^sub>F\<subseteq>S\<close> \<open>fst`\<tau>\<^sub>Q\<^sub>F\<subseteq>S\<close> by auto
      show "S\<subseteq>(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)"
      proof
        fix \<sigma>
        assume "\<sigma>\<in>S"
        then have "\<sigma>\<in>S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F" using \<open>S\<subseteq>S\<^sub>P\<^sub>Q\<^emph>S\<^sub>F\<close> by fast
        then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<^sub>Q\<in>S\<^sub>P\<^sub>Q" "\<sigma>\<^sub>F\<in>S\<^sub>F" "hAdd \<sigma> \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F" unfolding star_via_hAdd by blast
        then have "(\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>F \<or> (\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>Q\<^sub>F" using \<open>S\<^sub>P\<^sub>Q=S\<^sub>P\<union>S\<^sub>Q\<close> \<open>\<sigma>\<in>S\<close> \<tau>\<^sub>P\<^sub>F_def \<tau>\<^sub>Q\<^sub>F_def by blast
        then show "\<sigma>\<in>(fst`\<tau>\<^sub>P\<^sub>F)\<union>(fst`\<tau>\<^sub>Q\<^sub>F)" by force
      qed
    qed
    ultimately show "S\<in>(P\<star>F)\<otimes>(Q\<star>F)" using join_def \<open>fst`\<tau>\<^sub>P\<^sub>F\<in>P\<star>F\<close> by blast
  qed
qed

corollary hstar_distr_over_join_powerset:
  "(P\<otimes>Q)\<star>{S. S\<subseteq>f} = (P\<star>{S. S\<subseteq>f})\<otimes>(Q\<star>{S. S\<subseteq>f})"
  using hstar_distr_over_join[of "{S. S\<subseteq>f}" P Q] by blast

(*lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<supseteq>S \<Longrightarrow> S'\<in>Q"
    shows "(P\<union>Q)\<otimes>(P'\<union>Q) \<subseteq> (P\<otimes>P')\<union>Q"
(*using assms unfolding join_def by fastforce*)
proof
  fix S\<^sub>i\<^sub>n
  assume "S\<^sub>i\<^sub>n\<in>(P\<union>Q)\<otimes>(P'\<union>Q)"
  then obtain S S' where SS'_def: "S\<^sub>i\<^sub>n=S\<union>S'" "S\<in>P\<union>Q" "S'\<in>P'\<union>Q" unfolding join_def by blast
  moreover have "S\<in>P \<Longrightarrow> S'\<in>P' \<Longrightarrow> S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" using \<open>S\<^sub>i\<^sub>n=S\<union>S'\<close> unfolding join_def by blast
  moreover have "S\<notin>P \<or> S'\<notin>P' \<Longrightarrow> S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" using \<open>S\<^sub>i\<^sub>n=S\<union>S'\<close> assms SS'_def(2,3) by blast
  ultimately show "S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<union>Q" by blast
qed

lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<in>Q \<Longrightarrow> S\<union>S'\<in>Q"
    shows "(P\<inter>Q)\<otimes>(P'\<inter>Q) \<subseteq> (P\<otimes>P')\<inter>Q"
proof
  fix S\<^sub>i\<^sub>n
  assume "S\<^sub>i\<^sub>n\<in>(P\<inter>Q)\<otimes>(P'\<inter>Q)"
  then obtain S S' where SS'_def: "S\<^sub>i\<^sub>n=S\<union>S'" "S\<in>P\<inter>Q" "S'\<in>P'\<inter>Q" unfolding join_def by blast
  then show "S\<^sub>i\<^sub>n\<in>(P\<otimes>P')\<inter>Q" using assms(1) unfolding join_def by blast
qed

lemma
  assumes "\<And>S S'. S\<in>Q \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>Q"
    shows "(P\<otimes>P')\<inter>Q \<subseteq> (P\<inter>Q)\<otimes>(P'\<inter>Q)"
  using assms unfolding join_def by blast*)

(*Property 8*)
lemma hstar_distr_over_indexed_join:
  assumes "\<And>Ss. Ss\<subseteq>F \<Longrightarrow> \<Union>Ss\<in>F"
      and "\<And>S S'. S\<in>F \<Longrightarrow> S'\<subseteq>S \<Longrightarrow> S'\<in>F"
    shows "(\<Otimes>\<^sub>I Ps)\<star>F = \<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)"
proof
  show "\<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F) \<subseteq> (\<Otimes>\<^sub>I Ps)\<star>F"
  proof
    fix S
    assume "S\<in>\<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)"
    then obtain g where f_def: "S=(\<Union>i\<in>I. g i)" "\<forall>i\<in>I. g i\<in>Ps i\<star>F" unfolding join_indexed_def by blast
    then have "\<forall>i\<in>I. \<exists>S\<^sub>P S\<^sub>F. g i\<subseteq>S\<^sub>P\<^emph>S\<^sub>F \<and> S\<^sub>P\<in>Ps i \<and> S\<^sub>F\<in>F \<and> left_lives (g i) S\<^sub>P S\<^sub>F \<and> right_lives (g i) S\<^sub>P S\<^sub>F" unfolding hstar_def by fast
    then obtain S\<^sub>Ps S\<^sub>Fs where S\<^sub>PsS\<^sub>Fs_def: "\<forall>i\<in>I. g i\<subseteq>S\<^sub>Ps i\<^emph>S\<^sub>Fs i \<and> S\<^sub>Ps i\<in>Ps i \<and> S\<^sub>Fs i\<in>F \<and> left_lives (g i) (S\<^sub>Ps i) (S\<^sub>Fs i) \<and> right_lives (g i) (S\<^sub>Ps i) (S\<^sub>Fs i)" by metis
    then have "(\<Union>i\<in>I. S\<^sub>Ps i)\<in>\<Otimes>\<^sub>I Ps" using join_indexed_def by blast
    moreover have "(\<Union>i\<in>I. S\<^sub>Fs i)\<in>F" using assms(1) S\<^sub>PsS\<^sub>Fs_def by blast
    moreover have "(\<Union>i\<in>I. g i)\<subseteq>(\<Union>i\<in>I. S\<^sub>Ps i)\<^emph>(\<Union>i\<in>I. S\<^sub>Fs i)" using S\<^sub>PsS\<^sub>Fs_def unfolding star_def by fast
    moreover have "left_lives (\<Union>i\<in>I. g i) (\<Union>i\<in>I. S\<^sub>Ps i) (\<Union>i\<in>I. S\<^sub>Fs i)" using left_lives_def S\<^sub>PsS\<^sub>Fs_def by fastforce
    moreover have "right_lives (\<Union>i\<in>I. g i) (\<Union>i\<in>I. S\<^sub>Ps i) (\<Union>i\<in>I. S\<^sub>Fs i)" using right_lives_equiv S\<^sub>PsS\<^sub>Fs_def by fastforce
    ultimately have "(\<Union>i\<in>I. g i)\<in>(\<Otimes>\<^sub>I Ps)\<star>F" unfolding hstar_def by blast
    then show "S\<in>(\<Otimes>\<^sub>I Ps)\<star>F" using f_def(1) by blast
  qed
  show "(\<Otimes>\<^sub>I Ps)\<star>F \<subseteq> \<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)"
  proof
    fix S
    assume "S\<in>(\<Otimes>\<^sub>I Ps)\<star>F"
    then obtain S\<^sub>P\<^sub>s S\<^sub>F where "S\<subseteq>S\<^sub>P\<^sub>s\<^emph>S\<^sub>F" "S\<^sub>P\<^sub>s\<in>\<Otimes>\<^sub>I Ps" "S\<^sub>F\<in>F" "left_lives S S\<^sub>P\<^sub>s S\<^sub>F" unfolding hstar_def by blast
    then obtain f where f_def: "S\<^sub>P\<^sub>s=(\<Union>i\<in>I. f i)" "\<forall>i\<in>I. f i\<in>Ps i" unfolding join_indexed_def by blast
    obtain \<tau>\<^sub>P\<^sub>s where \<tau>\<^sub>P\<^sub>s_def: "\<tau>\<^sub>P\<^sub>s = (\<lambda>i. {(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)| \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>P\<in>f i \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F})" by blast
    moreover have "\<And>i. i\<in>I \<Longrightarrow> left_lives S (f i) S\<^sub>F" using \<open>left_lives S S\<^sub>P\<^sub>s S\<^sub>F\<close> f_def(1) left_lives_mono by blast
    then have "\<And>i. i\<in>I \<Longrightarrow> \<forall>\<sigma>\<^sub>P\<in>(f i). \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F" using \<open>S\<^sub>F\<in>F\<close> unfolding left_lives_def by blast
    have "\<And>i. i\<in>I \<Longrightarrow> fst`snd`(\<tau>\<^sub>P\<^sub>s i)=(f i)"
    proof
      fix i
      assume "i\<in>I"
      show "fst`snd`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>f i" unfolding \<tau>\<^sub>P\<^sub>s_def by fastforce
      moreover show "f i\<subseteq>fst`snd`(\<tau>\<^sub>P\<^sub>s i)"
      proof
        fix \<sigma>\<^sub>P
        assume "\<sigma>\<^sub>P\<in>f i"
        then obtain \<sigma> \<sigma>\<^sub>F where "(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>F)\<in>\<tau>\<^sub>P\<^sub>s i" using \<open>\<And>i. i\<in>I \<Longrightarrow> \<forall>\<sigma>\<^sub>P\<in>f i. \<exists>\<sigma> \<sigma>\<^sub>F. \<sigma>\<in>S \<and> \<sigma>\<^sub>F\<in>S\<^sub>F \<and> hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>F\<close> \<open>i\<in>I\<close> unfolding \<tau>\<^sub>P\<^sub>s_def by (smt (verit, best) mem_Collect_eq)
        then show "\<sigma>\<^sub>P\<in>fst`snd`(\<tau>\<^sub>P\<^sub>s i)" by force
      qed
    qed
    have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S" "\<And>i. i\<in>I \<Longrightarrow> snd`snd`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S\<^sub>F" using \<tau>\<^sub>P\<^sub>s_def by auto
    then have "\<And>i. i\<in>I \<Longrightarrow> snd`snd`(\<tau>\<^sub>P\<^sub>s i)\<in>F" using \<open>S\<^sub>F\<in>F\<close> assms(2) by meson
    moreover have "\<And>i. i\<in>I \<Longrightarrow> left_lives (fst`(\<tau>\<^sub>P\<^sub>s i)) (fst`snd`(\<tau>\<^sub>P\<^sub>s i)) (snd`snd`(\<tau>\<^sub>P\<^sub>s i))" using left_lives_def \<tau>\<^sub>P\<^sub>s_def apply simp by fast
    moreover have "\<And>i. i\<in>I \<Longrightarrow> right_lives (fst`(\<tau>\<^sub>P\<^sub>s i)) (fst`snd`(\<tau>\<^sub>P\<^sub>s i)) (snd`snd`(\<tau>\<^sub>P\<^sub>s i))" using right_lives_equiv \<tau>\<^sub>P\<^sub>s_def apply simp by fast
    moreover have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>(fst`snd`(\<tau>\<^sub>P\<^sub>s i))\<^emph>(snd`snd`(\<tau>\<^sub>P\<^sub>s i))" unfolding star_via_hAdd \<tau>\<^sub>P\<^sub>s_def by fastforce
    ultimately have "\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<in>Ps i\<star>F" using f_def(2) \<open>\<And>i. i\<in>I \<Longrightarrow> fst`snd`\<tau>\<^sub>P\<^sub>s i=f i\<close> hstarI[where ?Q=F] by fastforce
  
    moreover have "(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))=S" 
    proof
      show "(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))\<subseteq>S" using \<open>\<And>i. i\<in>I \<Longrightarrow> fst`(\<tau>\<^sub>P\<^sub>s i)\<subseteq>S\<close> by blast
      show "S\<subseteq>(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))"
      proof
        fix \<sigma>
        assume "\<sigma>\<in>S"
        then have "\<sigma>\<in>S\<^sub>P\<^sub>s\<^emph>S\<^sub>F" using \<open>S\<subseteq>S\<^sub>P\<^sub>s\<^emph>S\<^sub>F\<close> by fast
        then obtain \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F where "\<sigma>\<^sub>P\<^sub>Q\<in>S\<^sub>P\<^sub>s" "\<sigma>\<^sub>F\<in>S\<^sub>F" "hAdd \<sigma> \<sigma>\<^sub>P\<^sub>Q \<sigma>\<^sub>F" unfolding star_via_hAdd by blast
        then have "\<exists>i\<in>I. (\<sigma>, \<sigma>\<^sub>P\<^sub>Q, \<sigma>\<^sub>F)\<in>(\<tau>\<^sub>P\<^sub>s i)" using f_def(1) \<open>\<sigma>\<in>S\<close> \<tau>\<^sub>P\<^sub>s_def by blast
        then show "\<sigma>\<in>(\<Union>i\<in>I. fst`(\<tau>\<^sub>P\<^sub>s i))" by force
      qed
    qed
  
    ultimately show "S\<in>\<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>F)" unfolding join_indexed_def by blast
  qed
qed

corollary hstar_distr_over_indexed_join_powerset:
  "(\<Otimes>\<^sub>I Ps)\<star>{S. S\<subseteq>f} = \<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>{S. S\<subseteq>f})"
  using hstar_distr_over_indexed_join[of "{S. S\<subseteq>f}" I Ps] by blast

lemma downwards_and_infinite_union_closed:
  "(\<forall>Ss\<subseteq>F. \<Union>Ss\<in>F) \<and> (\<forall>S\<in>F. \<forall>S'\<subseteq>S. S'\<in>F) \<longleftrightarrow> F={S. S\<subseteq>\<Union>F}"
proof(-)
  have  "\<forall>Ss\<subseteq>F. \<Union>Ss\<in>F \<Longrightarrow> \<forall>S\<in>F. \<forall>S'\<subseteq>S. S'\<in>F \<Longrightarrow> \<exists>f. F={S. S\<subseteq>f}"
  proof(-)
    assume asm: "\<forall>Ss\<subseteq>F. \<Union>Ss\<in>F" "\<forall>S\<in>F. \<forall>S'\<subseteq>S. S'\<in>F"
    have "\<Union>F\<in>F" using asm(1) by simp
    then have "F={S. S\<subseteq>(\<Union>F)}" using asm(2) by auto
    then show "\<exists>f. F={S. S\<subseteq>f}" by blast
  qed
  then show ?thesis by auto
qed

(*Property 9*)
lemma hstar_sub_inter:
  assumes "Intu P"
      and "Intu Q"
    shows "P\<star>Q \<subseteq> P\<inter>Q"
proof
  fix S
  assume "S\<in>P\<star>Q"
  then obtain S\<^sub>P S\<^sub>Q where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" unfolding hstar_def by fast
  then have "\<forall>(s, h)\<in>S\<^sub>P. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" unfolding left_lives_def compat_def hAdd_def using fmap_add_comm by fastforce
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>P" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def using fmap_add_comm by force
  ultimately have "S\<in>P" using assms(1) \<open>S\<^sub>P\<in>P\<close> unfolding Intu_def by blast
  have "\<forall>(s, h)\<in>S\<^sub>Q. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" using \<open>right_lives S S\<^sub>P S\<^sub>Q\<close> unfolding right_lives_equiv compat_def hAdd_def by fastforce
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>Q" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def by force
  ultimately have "S\<in>Q" using assms(2) \<open>S\<^sub>Q\<in>Q\<close> Intu_def by blast
  then show "S\<in>P\<inter>Q" using \<open>S\<in>P\<close> by blast
qed

lemma hstar_sup_inter:
  assumes "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
   shows "P\<inter>Q \<subseteq> P\<star>Q"
proof
  fix S
  assume "S\<in>P\<inter>Q"
  then have "S\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S}=S" "S\<in>P" "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" unfolding star_def compat_def using assms by auto
  moreover have "left_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding left_lives_def compat_def hAdd_def by force
  moreover have "right_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding right_lives_equiv compat_def hAdd_def by force
  ultimately show "S\<in>P\<star>Q" unfolding hstar_def by blast
qed

lemma hstar_coincides_inter:
  assumes "Intu P"
      and "Pure Q"
    shows "P\<star>Q = P\<inter>Q"
proof
  have "Intu Q" using assms(2) Pure_implies_Intu by force
  then show "P\<star>Q \<subseteq> P\<inter>Q" using assms(1) hstar_sub_inter by presburger
  have "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
  proof(-)
    have 0: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Pure_def by blast
    fix S
    assume "S\<in>Q"
    then show "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" using "0"[of S "{(s, fmap_empty)| s h. (s, h)\<in>S}"] by blast
  qed
  then show "P\<inter>Q \<subseteq> P\<star>Q" using hstar_sup_inter by blast
qed



lemma hstar_sub_inter':
  assumes "Intu' P"
      and "Intu' Q"
    shows "P\<star>Q \<subseteq> P\<inter>Q"
proof
  fix S
  assume "S\<in>P\<star>Q"
  then obtain S\<^sub>P S\<^sub>Q where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" unfolding hstar_def by fast
  then have "\<forall>(s, h)\<in>S\<^sub>P. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" unfolding left_lives_def compat_def hAdd_def using fmap_add_comm by fastforce
  then have "\<forall>(s, h)\<in>S\<^sub>P. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S" using fmap_le_implies_smaller by fast
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>P" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def using fmap_add_comm by force
  then have "\<forall>(s, h')\<in>S. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S\<^sub>P" using fmap_le_implies_smaller by fast
  ultimately have "S\<in>P" using assms(1) \<open>S\<^sub>P\<in>P\<close> unfolding Intu'_def by blast
  have "\<forall>(s, h)\<in>S\<^sub>Q. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S" using \<open>right_lives S S\<^sub>P S\<^sub>Q\<close> unfolding right_lives_equiv compat_def hAdd_def by fastforce
  then have "\<forall>(s, h)\<in>S\<^sub>Q. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S" using fmap_le_implies_smaller by fast
  moreover have "\<forall>(s, h')\<in>S. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S\<^sub>Q" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def compat_def by force
  then have "\<forall>(s, h')\<in>S. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S\<^sub>Q" using fmap_le_implies_smaller by fast
  ultimately have "S\<in>Q" using assms(2) \<open>S\<^sub>Q\<in>Q\<close> Intu'_def by blast
  then show "S\<in>P\<inter>Q" using \<open>S\<in>P\<close> by blast
qed

lemma hstar_sup_inter':
  assumes "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
   shows "P\<inter>Q \<subseteq> P\<star>Q"
proof
  fix S
  assume "S\<in>P\<inter>Q"
  then have "S\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S}=S" "S\<in>P" "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" unfolding star_def compat_def using assms by auto
  moreover have "left_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding left_lives_def compat_def hAdd_def by force
  moreover have "right_lives S S {(s, fmap_empty)| s h. (s, h)\<in>S}" unfolding right_lives_equiv compat_def hAdd_def by force
  ultimately show "S\<in>P\<star>Q" unfolding hstar_def by blast
qed

lemma hstar_coincides_inter':
  assumes "Intu' P"
      and "Pure Q"
    shows "P\<star>Q = P\<inter>Q"
proof
  have "Intu' Q" using assms(2) Pure_implies_Intu' by force
  then show "P\<star>Q \<subseteq> P\<inter>Q" using assms(1) hstar_sub_inter' by presburger
  have "\<And>S. S\<in>Q \<Longrightarrow> {(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q"
  proof(-)
    have 0: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Pure_def by blast
    fix S
    assume "S\<in>Q"
    then show "{(s, fmap_empty)| s h. (s, h)\<in>S}\<in>Q" using "0"[of S "{(s, fmap_empty)| s h. (s, h)\<in>S}"] by blast
  qed
  then show "P\<inter>Q \<subseteq> P\<star>Q" using hstar_sup_inter' by blast
qed

(*Property 10*)
lemma hstar_preserves_Intu:
  assumes "Intu P"
      and "Intu Q"
    shows "Intu (P\<star>Q)"
proof(rule IntuI)
  have a1: "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P" using assms(1) unfolding Intu_def by blast
  have a2: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Intu_def by blast
  
  fix S S'
  assume asm: "S\<in>P\<star>Q" "\<forall>(s, h)\<in>S. \<exists>h'. h\<subseteq>\<^sub>fh' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<subseteq>\<^sub>fh' \<and> (s, h)\<in>S"
  then obtain \<tau> where \<tau>_def: "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=S" "fst`snd`\<tau>\<in>P" "snd`snd`\<tau>\<in>Q" unfolding hstar_via_triples by blast
  then have samestore: "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau> \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" unfolding hAdd_def by fastforce

  obtain \<tau>' where \<tau>'_def: "\<tau>' = {((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))| s h h\<^sub>P h\<^sub>Q h'. (s, h')\<in>S' \<and> h\<subseteq>\<^sub>fh' \<and> ((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>}" by blast
  then have samestore': "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau>' \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" by blast
  have coord2: "\<And>h h\<^sub>P h\<^sub>Q h'. h\<subseteq>\<^sub>fh' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>P\<bottom>h\<^sub>Q \<Longrightarrow> h\<^sub>P\<subseteq>\<^sub>f(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" unfolding compat_def apply simp by (smt (verit, ccfv_SIG) Int_iff disjoint_eq_subset_Compl inf.absorb_iff2 map_add_comm map_le_def map_le_iff_map_add_commute map_le_trans restrict_in)
  have coord3:"\<And>h h\<^sub>P h\<^sub>Q h'. h\<subseteq>\<^sub>fh' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>Q\<subseteq>\<^sub>f(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" unfolding compat_def apply simp by (metis (full_types) map_add_le_mapE map_le_def restrict_in)

  have "fst`\<tau>' = S'"
  proof
    show "fst`\<tau>' \<subseteq> S'" unfolding \<tau>'_def by force
    have "\<And>s h'. (s, h')\<in>S' \<Longrightarrow> (s, h')\<in>fst`\<tau>'"
    proof(-)
      fix s h'
      assume asm': "(s, h')\<in>S'"
      then obtain h where "h\<subseteq>\<^sub>fh'" "(s, h)\<in>S" using asm(3) by fast
      then obtain h\<^sub>P h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using \<open>fst`\<tau> = S\<close> samestore by fastforce
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>h\<subseteq>\<^sub>fh'\<close> asm' unfolding \<tau>'_def by blast
      then show "(s, h')\<in>fst`\<tau>'" by force
    qed
    then show "S' \<subseteq> fst`\<tau>'" by fast
  qed
  moreover have "fst`snd`\<tau>'\<in>P"
  proof(-)
    have "\<And>s h\<^sub>P. (s, h\<^sub>P)\<in>fst`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>P'. h\<^sub>P\<subseteq>\<^sub>fh\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>P
      assume "(s, h\<^sub>P)\<in>fst`snd`\<tau>"
      then obtain h h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<subseteq>\<^sub>fh'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close>  \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q))\<in>fst`snd`\<tau>'" by (metis fst_conv rev_image_eqI snd_conv)
      moreover have "h\<^sub>P\<subseteq>\<^sub>f(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<subseteq>\<^sub>fh'\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> coord2 by blast
      ultimately show "\<exists>h\<^sub>P'. h\<^sub>P\<subseteq>\<^sub>fh\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>P. h\<^sub>P\<subseteq>\<^sub>fh\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<subseteq>\<^sub>fh'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>P\<subseteq>\<^sub>fh\<^sub>P'" using \<tau>_def coord2 hAdd_prop by fast
      then show "\<exists>h\<^sub>P. h\<^sub>P\<subseteq>\<^sub>fh\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis fst_conv image_eqI snd_conv)
    qed
    ultimately show "fst`snd`\<tau>'\<in>P" using \<tau>_def(3) a1[of "fst`snd`\<tau>" "fst`snd`\<tau>'"] by fast
  qed
  moreover have "snd`snd`\<tau>'\<in>Q"
  proof(-)
    have "\<And>s h\<^sub>Q. (s, h\<^sub>Q)\<in>snd`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>Q'. h\<^sub>Q\<subseteq>\<^sub>fh\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>Q
      assume "(s, h\<^sub>Q)\<in>snd`snd`\<tau>"
      then obtain h h\<^sub>P where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<subseteq>\<^sub>fh'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close> \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(fmap_dom h\<^sub>Q))\<in>snd`snd`\<tau>'" by force
      moreover have "h\<^sub>Q\<subseteq>\<^sub>f(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<subseteq>\<^sub>fh'\<close> coord3 by blast
      ultimately show "\<exists>h\<^sub>Q'. h\<^sub>Q\<subseteq>\<^sub>fh\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>Q. h\<^sub>Q\<subseteq>\<^sub>fh\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<subseteq>\<^sub>fh'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>Q\<subseteq>\<^sub>fh\<^sub>Q'" using \<tau>_def coord3 hAdd_prop by fast
      then show "\<exists>h\<^sub>Q. h\<^sub>Q\<subseteq>\<^sub>fh\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis image_eqI snd_conv)
    qed
    ultimately show "snd`snd`\<tau>'\<in>Q" using \<tau>_def(4) a2[of "snd`snd`\<tau>" "snd`snd`\<tau>'"] by fast
  qed
  moreover have "fst`\<tau>'\<subseteq>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h'. (s, h')\<in>fst`\<tau>' \<Longrightarrow> (s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
    proof(-)
      fix s h'
      assume "(s, h')\<in>fst`\<tau>'"
      then obtain h\<^sub>P' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<subseteq>\<^sub>fh'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "(s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')" unfolding star_def by blast
    qed
    then show ?thesis by fast
  qed
  moreover have "left_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<subseteq>\<^sub>fh'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding left_lives_def hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  moreover have "right_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<subseteq>\<^sub>fh'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding right_lives_equiv hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  ultimately show "S'\<in>P\<star>Q" unfolding hstar_def by blast
qed

lemma hstar_preserves_Intu':
  assumes "Intu' P"
      and "Intu' Q"
    shows "Intu' (P\<star>Q)"
proof(rule Intu'I)
  have a1: "\<And>S S'. S\<in>P \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>P" using assms(1) unfolding Intu'_def by blast
  have a2: "\<And>S S'. S\<in>Q \<Longrightarrow> \<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S' \<Longrightarrow> \<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S \<Longrightarrow> S'\<in>Q" using assms(2) unfolding Intu'_def by blast
  
  fix S S'
  assume asm: "S\<in>P\<star>Q" "\<forall>(s, h)\<in>S. \<exists>h'. h\<sqsubseteq>h' \<and> (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. h\<sqsubseteq>h' \<and> (s, h)\<in>S"
  then obtain \<tau> where \<tau>_def: "\<forall>(\<sigma>, \<sigma>\<^sub>P, \<sigma>\<^sub>Q)\<in>\<tau>. hAdd \<sigma> \<sigma>\<^sub>P \<sigma>\<^sub>Q" "fst`\<tau>=S" "fst`snd`\<tau>\<in>P" "snd`snd`\<tau>\<in>Q" unfolding hstar_via_triples by blast
  then have samestore: "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau> \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" unfolding hAdd_def by fastforce

  obtain \<tau>' where \<tau>'_def: "\<tau>' = {((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))| s h h\<^sub>P h\<^sub>Q h'. (s, h')\<in>S' \<and> h\<sqsubseteq>h' \<and> ((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>}" by blast
(*then have \<tau>'_alt: "\<tau>' = {((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))| s h h\<^sub>P h\<^sub>Q h'. (s, h')\<in>S' \<and> h\<sqsubseteq>h' \<and> (s, h)\<in>S \<and> (s, h\<^sub>P)\<in>S\<^sub>P \<and> (s, h\<^sub>Q)\<in>S\<^sub>Q \<and> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<and> h\<^sub>P\<bottom>h\<^sub>Q}" unfolding \<tau>_def by simp*)
  then have samestore': "\<And>s h s\<^sub>P h\<^sub>P s\<^sub>Q h\<^sub>Q. ((s, h), (s\<^sub>P, h\<^sub>P), (s\<^sub>Q, h\<^sub>Q))\<in>\<tau>' \<Longrightarrow> s=s\<^sub>P \<and> s=s\<^sub>Q" by blast
  have coord2: "\<And>h h\<^sub>P h\<^sub>Q h'. h\<sqsubseteq>h' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>P\<bottom>h\<^sub>Q \<Longrightarrow> h\<^sub>P\<sqsubseteq>(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" unfolding compat_def larger_def by (smt (verit, best) IntI disjoint_eq_subset_Compl dual_order.trans emptyE fmap_add_comm fmap_add_dom_app_simps(3) fmap_dom_restrict fmap_le_iff_fmap_add_commute fmap_le_implies_dom_le fmap_restrict_in inf_idem inf_mono subset_Compl_singleton)
  have coord3:"\<And>h h\<^sub>P h\<^sub>Q h'. h\<sqsubseteq>h' \<Longrightarrow> h=h\<^sub>P++\<^sub>fh\<^sub>Q \<Longrightarrow> h\<^sub>Q\<sqsubseteq>(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" unfolding larger_def by auto

  have "fst`\<tau>' = S'"
  proof
    show "fst`\<tau>' \<subseteq> S'" unfolding \<tau>'_def by force
    have "\<And>s h'. (s, h')\<in>S' \<Longrightarrow> (s, h')\<in>fst`\<tau>'"
    proof(-)
      fix s h'
      assume asm': "(s, h')\<in>S'"
      then obtain h where "h\<sqsubseteq>h'" "(s, h)\<in>S" using asm(3) by fast
      then obtain h\<^sub>P h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using \<open>fst`\<tau> = S\<close> samestore by fastforce
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>h\<sqsubseteq>h'\<close> asm' unfolding \<tau>'_def by blast
      then show "(s, h')\<in>fst`\<tau>'" by force
    qed
    then show "S' \<subseteq> fst`\<tau>'" by fast
  qed
  moreover have "fst`snd`\<tau>'\<in>P"
  proof(-)
    have "\<And>s h\<^sub>P. (s, h\<^sub>P)\<in>fst`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>P'. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>P
      assume "(s, h\<^sub>P)\<in>fst`snd`\<tau>"
      then obtain h h\<^sub>Q where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<sqsubseteq>h'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close>  \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q))\<in>fst`snd`\<tau>'" by (metis fst_conv rev_image_eqI snd_conv)
      moreover have "h\<^sub>P\<sqsubseteq>(h'|`\<^sub>f(-fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<sqsubseteq>h'\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> coord2 by blast
      ultimately show "\<exists>h\<^sub>P'. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>P. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>P\<sqsubseteq>h\<^sub>P'" using \<tau>_def coord2 hAdd_prop by fastforce
      then show "\<exists>h\<^sub>P. h\<^sub>P\<sqsubseteq>h\<^sub>P' \<and> (s, h\<^sub>P)\<in>fst`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis fst_conv image_eqI snd_conv)
    qed
    ultimately show "fst`snd`\<tau>'\<in>P" using \<tau>_def(3) a1[of "fst`snd`\<tau>" "fst`snd`\<tau>'"] by fast
  qed
  moreover have "snd`snd`\<tau>'\<in>Q"
  proof(-)
    have "\<And>s h\<^sub>Q. (s, h\<^sub>Q)\<in>snd`snd`\<tau> \<Longrightarrow> \<exists>h\<^sub>Q'. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
    proof(-)
      fix s h\<^sub>Q
      assume "(s, h\<^sub>Q)\<in>snd`snd`\<tau>"
      then obtain h h\<^sub>P where "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" using samestore by fastforce
      then have "(s, h)\<in>S" "h=h\<^sub>P++\<^sub>fh\<^sub>Q" "h\<^sub>P\<bottom>h\<^sub>Q" using \<tau>_def(2) apply simp apply force using \<tau>_def(1) \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> unfolding hAdd_def by auto
      then obtain h' where "h\<sqsubseteq>h'" "(s, h')\<in>S'" using asm(2) by fast
      then have "((s, h'), (s, h'|`\<^sub>f(-fmap_dom h\<^sub>Q)), (s, h'|`\<^sub>f(fmap_dom h\<^sub>Q)))\<in>\<tau>'" using \<open>(s, h)\<in>S\<close> \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<^sub>P\<bottom>h\<^sub>Q\<close> unfolding \<tau>'_def using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q)) \<in> \<tau>\<close> by blast
      then have "(s, h'|`\<^sub>f(fmap_dom h\<^sub>Q))\<in>snd`snd`\<tau>'" by force
      moreover have "h\<^sub>Q\<sqsubseteq>(h'|`\<^sub>f(fmap_dom h\<^sub>Q))" using \<open>h=h\<^sub>P++\<^sub>fh\<^sub>Q\<close> \<open>h\<sqsubseteq>h'\<close> coord3 by blast
      ultimately show "\<exists>h\<^sub>Q'. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>'" by blast
    qed
    moreover have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h\<^sub>Q. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h\<^sub>Q\<sqsubseteq>h\<^sub>Q'" using \<tau>_def coord3 hAdd_def by fastforce
      then show "\<exists>h\<^sub>Q. h\<^sub>Q\<sqsubseteq>h\<^sub>Q' \<and> (s, h\<^sub>Q)\<in>snd`snd`\<tau>" using \<open>((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>\<close> \<tau>_def by (metis image_eqI snd_conv)
    qed
    ultimately show "snd`snd`\<tau>'\<in>Q" using \<tau>_def(4) a2[of "snd`snd`\<tau>" "snd`snd`\<tau>'"] by fast
  qed
  moreover have "fst`\<tau>'\<subseteq>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h'. (s, h')\<in>fst`\<tau>' \<Longrightarrow> (s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')"
    proof(-)
      fix s h'
      assume "(s, h')\<in>fst`\<tau>'"
      then obtain h\<^sub>P' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "(s, h')\<in>(fst`snd`\<tau>')\<^emph>(snd`snd`\<tau>')" unfolding star_def by blast
    qed
    then show ?thesis by fast
  qed
  moreover have "left_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>P'. (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>P'
      assume "(s, h\<^sub>P')\<in>fst`snd`\<tau>'"
      then obtain h' h\<^sub>Q' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>Q'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding left_lives_def hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  moreover have "right_lives (fst`\<tau>') (fst`snd`\<tau>') (snd`snd`\<tau>')"
  proof(-)
    have "\<And>s h\<^sub>Q'. (s, h\<^sub>Q')\<in>snd`snd`\<tau>' \<Longrightarrow> \<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'"
    proof(-)
      fix s h\<^sub>Q'
      assume "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'"
      then obtain h' h\<^sub>P' where "((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'" using samestore' by fastforce
      then obtain h h\<^sub>P h\<^sub>Q where "(s, h')\<in>S'" "h\<sqsubseteq>h'" "((s, h), (s, h\<^sub>P), (s, h\<^sub>Q))\<in>\<tau>" "h\<^sub>P'= h'|`\<^sub>f(-fmap_dom h\<^sub>Q)" "h\<^sub>Q'=h'|`\<^sub>f(fmap_dom h\<^sub>Q)" unfolding \<tau>'_def by blast
      then have "h'=h\<^sub>P'++\<^sub>fh\<^sub>Q'" "h\<^sub>P'\<bottom>h\<^sub>Q'" using split_fmap unfolding compat_def by auto
      moreover have "(s, h\<^sub>P')\<in>fst`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      moreover have "(s, h\<^sub>Q')\<in>snd`snd`\<tau>'" using \<open>((s, h'), (s, h\<^sub>P'), (s, h\<^sub>Q'))\<in>\<tau>'\<close> by force
      ultimately show "\<exists>h' h\<^sub>P'. (s, h')\<in>fst`\<tau>' \<and> (s, h\<^sub>P')\<in>fst`snd`\<tau>' \<and> h'=h\<^sub>P'++\<^sub>fh\<^sub>Q' \<and> h\<^sub>P'\<bottom>h\<^sub>Q'" using \<open>(s, h')\<in>S'\<close> \<open>fst`\<tau>' = S'\<close> by blast
    qed
    then show ?thesis unfolding right_lives_equiv hAdd_def by (metis old.prod.inject prod.collapse)
  qed
  ultimately show "S'\<in>P\<star>Q" unfolding hstar_def by blast
qed

(*Property 11*)
lemma hstar_preserves_Pure:
  assumes "Pure P"
      and "Pure Q"
    shows "Pure (P\<star>Q)"
proof(rule PureI)
  fix S S' :: "((nat \<Rightarrow> nat) \<times> (nat \<rightharpoonup>\<^sub>f nat + unit)) set"
  assume asm: "S\<in>P\<star>Q" "\<forall>(s, h)\<in>S. \<exists>h'. (s, h')\<in>S'" "\<forall>(s, h')\<in>S'. \<exists>h. (s, h)\<in>S"
  then obtain S\<^sub>P S\<^sub>Q where "S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q" "S\<^sub>P\<in>P" "S\<^sub>Q\<in>Q" "left_lives S S\<^sub>P S\<^sub>Q" "right_lives S S\<^sub>P S\<^sub>Q" unfolding hstar_def by blast
  then have "\<forall>(s, h\<^sub>P)\<in>S\<^sub>P. \<exists>h. (s, h)\<in>S" unfolding left_lives_def hAdd_def by fastforce
  then have "\<forall>(s, h\<^sub>P)\<in>S\<^sub>P. \<exists>h. (s, h)\<in>S'" using asm(2) by fast
  moreover have "\<forall>(s, h)\<in>S. \<exists>h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def by blast
  then have "\<forall>(s, h)\<in>S'. \<exists>h\<^sub>P. (s, h\<^sub>P)\<in>S\<^sub>P" using asm(3) by fast
  ultimately have "S'\<in>P" using assms(1) \<open>S\<^sub>P\<in>P\<close> unfolding Pure_def by blast

  have "\<forall>(s, h\<^sub>Q)\<in>S\<^sub>Q. \<exists>h. (s, h)\<in>S" using \<open>right_lives S S\<^sub>P S\<^sub>Q\<close> unfolding right_lives_equiv hAdd_def by fastforce
  then have "\<forall>(s, h\<^sub>Q)\<in>S\<^sub>Q. \<exists>h. (s, h)\<in>S'" using asm(2) by fast
  moreover have "\<forall>(s, h)\<in>S. \<exists>h\<^sub>Q. (s, h\<^sub>Q)\<in>S\<^sub>Q" using \<open>S\<subseteq>S\<^sub>P\<^emph>S\<^sub>Q\<close> unfolding star_def by blast
  then have "\<forall>(s, h)\<in>S'. \<exists>h\<^sub>Q. (s, h\<^sub>Q)\<in>S\<^sub>Q" using asm(3) by fast
  ultimately have "S'\<in>Q" using assms(2) \<open>S\<^sub>Q\<in>Q\<close> unfolding Pure_def by blast
  moreover have "\<forall>(s, h)\<in>S'. \<exists>h'. (s, h')\<in>{(s, fmap_empty)| s h. (s, h)\<in>S'}" by fast
  moreover have "\<forall>(s, h')\<in>{(s, fmap_empty)| s h. (s, h)\<in>S'}. \<exists>h. (s, h)\<in>S'" by blast
  ultimately have "{(s, fmap_empty)| s h. (s, h)\<in>S'}\<in>Q" using assms(2) unfolding Pure_def by blast

  moreover have "S'\<subseteq>S'\<^emph>{(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding star_def hAdd_def compat_def by auto
  moreover have "left_lives S' S' {(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding left_lives_def hAdd_def compat_def by force
  moreover have "right_lives S' S' {(s, fmap_empty)| s h. (s, h)\<in>S'}" unfolding right_lives_equiv hAdd_def compat_def by force
  ultimately show "S'\<in>P\<star>Q" using \<open>S'\<in>P\<close> unfolding hstar_def by blast
qed

(*Property 13*)
lemma hstar_expresses_SL_star:
  "{S. S\<subseteq>p}\<star>{S. S\<subseteq>q}={S. S\<subseteq>(p\<^emph>q)}" (is "?A = ?B") 
proof
  show "?A \<subseteq> ?B" unfolding hstar_def star_def by blast
  show "?B \<subseteq> ?A"
  proof
    fix S
    assume "S\<in>?B"
    then have "\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" unfolding star_via_hAdd by blast
    moreover obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)| \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<in>S \<and> \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q}" by blast
    ultimately have "(fst`\<tau>)\<subseteq>(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" unfolding star_via_hAdd by fastforce
    moreover have "(fst`snd`\<tau>)\<in>{S. S\<subseteq>p}" "(snd`snd`\<tau>)\<in>{S. S\<subseteq>q}" using \<tau>_def by auto
    moreover have "left_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def unfolding left_lives_def by fastforce
    moreover have "right_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def unfolding right_lives_equiv by fastforce
    moreover have "S=(fst`\<tau>)"
    proof
      show "(fst`\<tau>)\<subseteq>S" using \<tau>_def by fastforce
      show "S\<subseteq>(fst`\<tau>)"
      proof
        fix \<sigma>
        assume "\<sigma>\<in>S"
        then obtain \<sigma>\<^sub>p \<sigma>\<^sub>q where "\<sigma>\<^sub>p\<in>p" "\<sigma>\<^sub>q\<in>q" "hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" using \<open>\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q\<close> by fast
        then have "(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)\<in>\<tau>" using \<tau>_def \<open>\<sigma>\<in>S\<close> by blast
        then show "\<sigma>\<in>fst`\<tau>" by force
      qed
    qed
    ultimately show "S\<in>?A" using hstarI by presburger
  qed
qed

(*Property 14*)
lemma hstar_expresses_SSIL_star:
  "{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}\<subseteq>{S. S\<inter>(p\<^emph>q)\<noteq>{}}"
proof
  fix S
  assume "S\<in>{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}"
  then obtain S\<^sub>p S\<^sub>q where "S\<subseteq>S\<^sub>p\<^emph>S\<^sub>q" "S\<^sub>p\<in>{S. S\<inter>p\<noteq>{}}" "S\<^sub>q\<in>{S. S\<subseteq>q}" "left_lives S S\<^sub>p S\<^sub>q" "right_lives S S\<^sub>p S\<^sub>q" unfolding hstar_def by force
  then obtain s h\<^sub>p where "(s, h\<^sub>p)\<in>S\<^sub>p" "(s, h\<^sub>p)\<in>p" by fast
  then obtain h h\<^sub>q where "(s, h)\<in>S" "(s, h\<^sub>q)\<in>S\<^sub>q" "h=h\<^sub>p++\<^sub>fh\<^sub>q" "h\<^sub>p\<bottom>h\<^sub>q" using \<open>left_lives S S\<^sub>p S\<^sub>q\<close> unfolding left_lives_def hAdd_def by auto
  then have "(s, h\<^sub>q)\<in>q" using \<open>S\<^sub>q\<in>{S. S\<subseteq>q}\<close> by blast
  then have "(s, h)\<in>p\<^emph>q" unfolding star_def using \<open>(s, h\<^sub>p)\<in>p\<close> \<open>h=h\<^sub>p++\<^sub>fh\<^sub>q\<close> \<open>h\<^sub>p\<bottom>h\<^sub>q\<close> by blast
  then show "S\<in>{S. S\<inter>(p\<^emph>q)\<noteq>{}}" using \<open>(s, h)\<in>S\<close> by blast
qed

lemma add_unconstrained: "({S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q})\<otimes>UNIV={S. S\<inter>(p\<^emph>q)\<noteq>{}}"
proof
  show "({S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q})\<otimes>UNIV\<subseteq>{S. S\<inter>(p\<^emph>q)\<noteq>{}}" using hstar_expresses_SSIL_star unfolding join_def by auto
  show "{S. S\<inter>(p\<^emph>q)\<noteq>{}}\<subseteq>({S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q})\<otimes>UNIV"
  proof
    fix S
    assume "S\<in>{S. S\<inter>(p\<^emph>q)\<noteq>{}}"
    then obtain \<sigma> where "\<sigma>\<in>S" "\<sigma>\<in>p\<^emph>q" by blast
    then obtain s h where "\<sigma>=(s, h)" "(s, h)\<in>S" "(s, h)\<in>p\<^emph>q" by (metis old.prod.exhaust)
    then obtain h\<^sub>p h\<^sub>q where "(s, h\<^sub>p)\<in>p" "(s, h\<^sub>q)\<in>q" "h=h\<^sub>p++\<^sub>fh\<^sub>q" "h\<^sub>p\<bottom>h\<^sub>q" unfolding star_def by blast
    then have "{(s, h)}={(s, h\<^sub>p)}\<^emph>{(s, h\<^sub>q)}" "{(s, h\<^sub>p)}\<in>{S. S\<inter>p\<noteq>{}}" "{(s, h\<^sub>q)}\<in>{S. S\<subseteq>q}" "left_lives {(s, h)} {(s, h\<^sub>p)} {(s, h\<^sub>q)}" "right_lives {(s, h)} {(s, h\<^sub>p)} {(s, h\<^sub>q)}" unfolding star_def left_lives_def right_lives_equiv hAdd_def by auto
    then have "{\<sigma>}\<in>{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}" using \<open>\<sigma>=(s, h)\<close> unfolding hstar_def by auto
    moreover have "S\<in>UNIV" by blast
    moreover have "S={\<sigma>}\<union>S" using \<open>\<sigma>\<in>S\<close> by fastforce
    ultimately show "S\<in>({S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q})\<otimes>UNIV" unfolding join_def by blast
  qed
qed

(*Property 15*)
lemma hstar_expresses_OSL_star:
  "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>q}={S. S\<subseteq>(p\<^emph>q) \<and> S\<inter>(p\<^emph>q)\<noteq>{}}" (is "?A = ?B")
proof
  show "?A \<subseteq> ?B"
  proof
    fix S
    assume "S\<in>?A"
    then obtain S\<^sub>p S\<^sub>q where S\<^sub>pS\<^sub>q_def: "S\<subseteq>S\<^sub>p\<^emph>S\<^sub>q" "S\<^sub>p\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}" "S\<^sub>q\<in>{S. S\<subseteq>q}" "left_lives S S\<^sub>p S\<^sub>q" "right_lives S S\<^sub>p S\<^sub>q" unfolding hstar_def by force
    then have "S\<in>{S. S\<subseteq>p\<^emph>q}" using star_mono by (smt (verit, del_insts) dual_order.trans mem_Collect_eq star_comm)
    moreover have "S\<inter>(p\<^emph>q)\<noteq>{}" using S\<^sub>pS\<^sub>q_def(2) S\<^sub>pS\<^sub>q_def(3) S\<^sub>pS\<^sub>q_def(4) calculation unfolding left_lives_def by fast
    ultimately show "S\<in>?B" by blast
  qed
  show "?B \<subseteq> ?A"
  proof
    fix S
    assume "S\<in>?B"
    then have "\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" using star_via_hAdd by auto
    moreover obtain \<tau> where \<tau>_def: "\<tau> = {(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)| \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<in>S \<and> \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q}" by blast
    ultimately have "(fst`\<tau>)\<subseteq>(fst`snd`\<tau>)\<^emph>(snd`snd`\<tau>)" unfolding star_via_hAdd by fastforce
    moreover have "(snd`snd`\<tau>)\<in>{S. S\<subseteq>q}" using \<tau>_def by auto
    moreover have "left_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def left_lives_def by fastforce
    moreover have "right_lives (fst`\<tau>) (fst`snd`\<tau>) (snd`snd`\<tau>)" using \<tau>_def right_lives_equiv by fastforce
    moreover have "S=(fst`\<tau>)"
    proof
      show "(fst`\<tau>)\<subseteq>S" using \<tau>_def by fastforce
      show "S\<subseteq>(fst`\<tau>)"
      proof
        fix \<sigma>
        assume "\<sigma>\<in>S"
        then obtain \<sigma>\<^sub>p \<sigma>\<^sub>q where "\<sigma>\<^sub>p\<in>p" "\<sigma>\<^sub>q\<in>q" "hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q" using \<open>\<forall>\<sigma>\<in>S. \<exists>\<sigma>\<^sub>p \<sigma>\<^sub>q. \<sigma>\<^sub>p\<in>p \<and> \<sigma>\<^sub>q\<in>q \<and> hAdd \<sigma> \<sigma>\<^sub>p \<sigma>\<^sub>q\<close> by fast
        then have "(\<sigma>, \<sigma>\<^sub>p, \<sigma>\<^sub>q)\<in>\<tau>" using \<tau>_def \<open>\<sigma>\<in>S\<close> by blast
        then show "\<sigma>\<in>fst`\<tau>" by force
      qed
    qed
    moreover have "(fst`snd`\<tau>)\<noteq>{}" using \<open>S=fst`\<tau>\<close> \<open>S\<in>{S. S\<subseteq>p\<^emph>q \<and> S\<inter>(p\<^emph>q)\<noteq>{}}\<close> by auto
    then have "(fst`snd`\<tau>)\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}" using \<tau>_def by fastforce
    ultimately show "S\<in>?A" using hstarI by presburger
  qed
qed

(*Property 16*)
lemma join_OSL_encs: "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}={S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}"
proof
  show "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}\<subseteq>{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}" unfolding join_def by auto
  show "{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<subseteq>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}"
  proof
    fix S
    assume asm: "S\<in>{S. S\<subseteq>p\<union>q \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}"
    then obtain S\<^sub>p S\<^sub>q where "S\<^sub>p=S\<inter>p" "S\<^sub>q=S\<inter>q" by presburger
    then have "S\<^sub>p\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}" "S\<^sub>q\<in>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}" "S=S\<^sub>p\<union>S\<^sub>q" using asm by auto
    then show "S\<in>{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}" unfolding join_def by blast
  qed
qed

lemma hstar_expresses_OSL_star_2:
  "{S. S\<subseteq>(p\<union>q) \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f}={S. S\<subseteq>((p\<union>q)\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}"
proof(-)
  have "{S. S\<subseteq>(p\<union>q) \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f}=({S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<otimes>{S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}})\<star>{S. S\<subseteq>f}" using join_OSL_encs by auto
  moreover have "... = ({S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>f})\<otimes>({S. S\<subseteq>q \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f})" using hstar_distr_over_join_powerset by simp
  moreover have "... = {S. S\<subseteq>(p\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{}}\<otimes>{S. S\<subseteq>(q\<^emph>f) \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using hstar_expresses_OSL_star by presburger
  moreover have "... = {S. S\<subseteq>((p\<^emph>f)\<union>(q\<^emph>f)) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using join_OSL_encs by auto
  moreover have "... = {S. S\<subseteq>((p\<union>q)\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}" using star_distr_over_union by blast
  ultimately show ?thesis by argo
qed

(*Property 17*)
lemma partition_star:
  assumes "v\<^sub>1\<noteq>v\<^sub>2"
  shows "S\<^sub>A\<^emph>S\<^sub>B=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>2})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" 
proof(-)
  have "S\<^sub>A\<^emph>S\<^sub>B=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})"
  proof
    show "({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})\<subseteq>S\<^sub>A\<^emph>S\<^sub>B" unfolding star_def by blast
    show "S\<^sub>A\<^emph>S\<^sub>B\<subseteq>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>S\<^sub>A\<^emph>S\<^sub>B"
      then obtain \<sigma>\<^sub>A \<sigma>\<^sub>B where "\<sigma>\<^sub>A\<in>S\<^sub>A" "\<sigma>\<^sub>B\<in>S\<^sub>B" "hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B" unfolding star_via_hAdd by blast
      then have "fst \<sigma>\<^sub>A = fst \<sigma>\<^sub>B" unfolding hAdd_def by fastforce
      then have "(\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1}) \<or> (\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})" using \<open>\<sigma>\<^sub>A\<in>S\<^sub>A\<close> \<open>\<sigma>\<^sub>B\<in>S\<^sub>B\<close> by auto
      then show "\<sigma>\<in>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>1})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1})" unfolding star_via_hAdd using \<open>hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B\<close> by blast
    qed
  qed
  moreover have "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}=({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})"
  proof
    show "({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}) \<subseteq> {\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}" unfolding star_def by blast
    show "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1} \<subseteq> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})"
    proof
      fix \<sigma>
      assume "\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}"
      then obtain \<sigma>\<^sub>A \<sigma>\<^sub>B where "\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}" "\<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}" "hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B" unfolding star_via_hAdd by blast
      then have "fst \<sigma>\<^sub>A = fst \<sigma>\<^sub>B" "fst \<sigma> = fst \<sigma>\<^sub>A" "fst \<sigma> = fst \<sigma>\<^sub>B" unfolding hAdd_def hAdd_def by auto
      then have "(\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t=v\<^sub>2} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t=v\<^sub>2}) \<or> (\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2} \<and> \<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" using \<open>\<sigma>\<^sub>A\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<close> \<open>\<sigma>\<^sub>B\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}\<close> by auto
      then show "\<sigma>\<in>({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t=v\<^sub>2}) \<union> ({\<sigma>\<in>{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}. fst \<sigma> t\<noteq>v\<^sub>2})" unfolding star_via_hAdd using \<open>hAdd \<sigma> \<sigma>\<^sub>A \<sigma>\<^sub>B\<close> by blast
    qed
  qed
  then have "{\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1}=({\<sigma>\<in>S\<^sub>A. fst \<sigma> t=v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t=v\<^sub>2})\<union>({\<sigma>\<in>S\<^sub>A. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2}\<^emph>{\<sigma>\<in>S\<^sub>B. fst \<sigma> t\<noteq>v\<^sub>1 \<and> fst \<sigma> t\<noteq>v\<^sub>2})" by (smt (verit) Collect_cong assms mem_Collect_eq)
  ultimately show ?thesis by blast
qed

lemma hstar_expresses_RSL_star:
  "{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a}\<star>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>b}\<subseteq>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a\<^emph>\<^sub>rb}" (is "?X\<star>?Y \<subseteq> ?Z")
proof
  fix S
  assume "S\<in>?X\<star>?Y"
  then obtain S\<^sub>a S\<^sub>b where S\<^sub>aS\<^sub>b_def: "S\<subseteq>S\<^sub>a\<^emph>S\<^sub>b" "S\<^sub>a\<in>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a}" "S\<^sub>b\<in>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>b}" "left_lives S S\<^sub>a S\<^sub>b" "right_lives S S\<^sub>a S\<^sub>b" unfolding hstar_def by auto
  then obtain S\<^sub>a\<^sub>1 S\<^sub>a\<^sub>2 S\<^sub>a\<^sub>o S\<^sub>b\<^sub>1 S\<^sub>b\<^sub>2 S\<^sub>b\<^sub>o where "S\<^sub>a\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>a. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>a\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>a. fst \<sigma>\<^sub>2 t = 2}" "S\<^sub>a\<^sub>1\<times>S\<^sub>a\<^sub>2\<subseteq>a"
                                         "S\<^sub>b\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>b\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}" "S\<^sub>b\<^sub>1\<times>S\<^sub>b\<^sub>2\<subseteq>b"
                                         "S\<^sub>a\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>a. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}" "S\<^sub>b\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>b. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}" by force
  moreover have "S\<^sub>a\<^emph>S\<^sub>b = ({\<sigma>\<in>S\<^sub>a. fst \<sigma> t=1}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t=1})\<union>({\<sigma>\<in>S\<^sub>a. fst \<sigma> t=2}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t=2})\<union>({\<sigma>\<in>S\<^sub>a. fst \<sigma> t\<noteq>1 \<and> fst \<sigma> t\<noteq>2}\<^emph>{\<sigma>\<in>S\<^sub>b. fst \<sigma> t\<noteq>1 \<and> fst \<sigma> t\<noteq>2})" using partition_star by simp
  ultimately have splt: "S\<^sub>a\<^emph>S\<^sub>b = (S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1) \<union> (S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2) \<union> (S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o)" by fast
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. fst \<sigma> t = 1" unfolding \<open>S\<^sub>a\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>a. fst \<sigma>\<^sub>1 t = 1}\<close> \<open>S\<^sub>b\<^sub>1={\<sigma>\<^sub>1\<in>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}\<close> star_def by fastforce
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. fst \<sigma> t = 2" unfolding \<open>S\<^sub>a\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>a. fst \<sigma>\<^sub>2 t = 2}\<close> \<open>S\<^sub>b\<^sub>2={\<sigma>\<^sub>2\<in>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}\<close> star_def by fastforce
  have "\<forall>\<sigma>\<in>S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o. fst \<sigma> t \<noteq>1 \<and> fst \<sigma> t \<noteq> 2" unfolding \<open>S\<^sub>a\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>a. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}\<close> \<open>S\<^sub>b\<^sub>o={\<sigma>\<^sub>o\<in>S\<^sub>b. fst \<sigma>\<^sub>o t \<noteq> 1 \<and> fst \<sigma>\<^sub>o t \<noteq> 2}\<close> star_def by fastforce

  have "(\<forall>\<sigma>\<^sub>1\<in>S\<^sub>a\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>a\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>a) \<and> (\<forall>\<sigma>\<^sub>1\<in>S\<^sub>b\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>b\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>b)" using \<open>S\<^sub>a\<^sub>1\<times>S\<^sub>a\<^sub>2\<subseteq>a\<close> \<open>S\<^sub>b\<^sub>1\<times>S\<^sub>b\<^sub>2\<subseteq>b\<close> by auto
  then have "\<forall>\<sigma>\<^sub>1\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. \<forall>\<sigma>\<^sub>2\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. (\<sigma>\<^sub>1,\<sigma>\<^sub>2)\<in>(a\<^emph>\<^sub>rb)" unfolding rstar_def star_via_hAdd by fast
  then have "(S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1)\<times>(S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2)\<subseteq>a\<^emph>\<^sub>rb" by fastforce     

  obtain S\<^sub>1 S\<^sub>2 where S\<^sub>1S\<^sub>2_def: "S\<^sub>1={\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>2={\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}" by auto
  moreover have "S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1 = {\<sigma>\<^sub>1\<in>S\<^sub>a\<^emph>S\<^sub>b. fst \<sigma>\<^sub>1 t = 1}" "S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2 = {\<sigma>\<^sub>2\<in>S\<^sub>a\<^emph>S\<^sub>b. fst \<sigma>\<^sub>2 t = 2}" using splt \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1. fst \<sigma> t = 1\<close> \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2. fst \<sigma> t = 2\<close> \<open>\<forall>\<sigma>\<in>S\<^sub>a\<^sub>o\<^emph>S\<^sub>b\<^sub>o. fst \<sigma> t \<noteq>1 \<and> fst \<sigma> t \<noteq> 2\<close> by auto
  ultimately have "S\<^sub>1\<subseteq>S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1" "S\<^sub>2\<subseteq>S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2" using S\<^sub>aS\<^sub>b_def(1) by auto 
  then have "S\<^sub>1\<times>S\<^sub>2\<subseteq>a\<^emph>\<^sub>rb" using \<open>(S\<^sub>a\<^sub>1\<^emph>S\<^sub>b\<^sub>1)\<times>(S\<^sub>a\<^sub>2\<^emph>S\<^sub>b\<^sub>2)\<subseteq>a\<^emph>\<^sub>rb\<close> by auto
  then show "S\<in>?Z" using S\<^sub>1S\<^sub>2_def(1,2) by auto
qed

(*Overview*)
theorem hstar_properties:
  "P\<star>{S. S\<subseteq>{(s, fmap_empty)| s. True}}=P"
  "P\<star>Q=Q\<star>P"
  "(P\<star>Q)\<star>R = P\<star>(Q\<star>R)"
  "P\<subseteq>P' \<Longrightarrow> Q\<subseteq>Q' \<Longrightarrow> P\<star>Q\<subseteq>P'\<star>Q'"
  "(P\<union>P')\<star>Q = (P\<star>Q) \<union> (P'\<star>Q)"
  "(\<Union>P\<in>X. P)\<star>Q = (\<Union>P\<in>X. P\<star>Q)"
  "(\<forall>S\<in>F. \<forall>S'\<in>F. S\<union>S'\<in>F) \<and> (\<forall>S\<in>F. \<forall>S'\<subseteq>S. S'\<in>F) \<longrightarrow> (P\<otimes>Q)\<star>F = (P\<star>F)\<otimes>(Q\<star>F)"
  "(\<Otimes>\<^sub>I Ps)\<star>{S. S\<subseteq>f} = \<Otimes>\<^sub>I (\<lambda>i. Ps i\<star>{S. S\<subseteq>f})"
  "Intu P \<Longrightarrow> Pure Q \<Longrightarrow> P\<star>Q=P\<inter>Q"
  "Intu P \<Longrightarrow> Intu Q \<Longrightarrow> Intu (P\<star>Q)"
  "Pure P \<Longrightarrow> Pure Q \<Longrightarrow> Pure (P\<star>Q)"
  "{S. S\<subseteq>p}\<star>{S. S\<subseteq>f}={S. S\<subseteq>(p\<^emph>f)}"
  "{S. S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>f}\<subseteq>{S. S\<inter>(p\<^emph>f)\<noteq>{}}"
  "{S. S\<subseteq>p \<and> S\<inter>p\<noteq>{}}\<star>{S. S\<subseteq>f}={S. S\<subseteq>(p\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{}}"
  "{S. S\<subseteq>(p\<union>q) \<and> S\<inter>p\<noteq>{} \<and> S\<inter>q\<noteq>{}}\<star>{S. S\<subseteq>f}={S. S\<subseteq>((p\<union>q)\<^emph>f) \<and> S\<inter>(p\<^emph>f)\<noteq>{} \<and> S\<inter>(q\<^emph>f)\<noteq>{}}"
  "{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a}\<star>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>b}\<subseteq>{S. {\<sigma>\<^sub>1\<in>S. fst \<sigma>\<^sub>1 t = 1}\<times>{\<sigma>\<^sub>2\<in>S. fst \<sigma>\<^sub>2 t = 2}\<subseteq>a\<^emph>\<^sub>rb}"
                 using hstar_unit apply auto[1]
                using hstar_comm apply auto[1]
               using hstar_assoc apply auto[1]
              using hstar_mono apply auto[1]
             using hstar_distr_over_union apply auto[1]
            using hstar_distr_over_indexed_union apply auto[1]
           using hstar_distr_over_join apply auto[1]
          using hstar_distr_over_indexed_join_powerset apply auto[1]
         using hstar_coincides_inter apply auto[1]
        using hstar_preserves_Intu apply auto[1]
       using hstar_preserves_Pure apply auto[1]
      using hstar_expresses_SL_star apply auto[1]
     using hstar_expresses_SSIL_star apply auto[1]
    using hstar_expresses_OSL_star apply auto[1]
   using hstar_expresses_OSL_star_2 apply auto[1]
  using hstar_expresses_RSL_star by auto

definition hstar_naive :: "hassertion \<Rightarrow> hassertion \<Rightarrow> hassertion" (infix "\<star>\<^sub>n\<^sub>a\<^sub>i\<^sub>v\<^sub>e" 52) where
 "P \<star>\<^sub>n\<^sub>a\<^sub>i\<^sub>v\<^sub>e Q = {S\<^sub>P\<^emph>S\<^sub>Q| S\<^sub>P S\<^sub>Q. S\<^sub>P\<in>P \<and> S\<^sub>Q\<in>Q}"

lemma "{S. S\<subseteq>p}\<star>\<^sub>n\<^sub>a\<^sub>i\<^sub>v\<^sub>e{S. S\<subseteq>q} \<subseteq> {S. S\<subseteq>p\<^emph>q}"
proof
  fix S
  assume "S\<in>{S. S\<subseteq>p}\<star>\<^sub>n\<^sub>a\<^sub>i\<^sub>v\<^sub>e{S. S\<subseteq>q}"
  then obtain S\<^sub>p S\<^sub>q where "S=S\<^sub>p\<^emph>S\<^sub>q" "S\<^sub>p\<in>{S. S\<subseteq>p}" "S\<^sub>q\<in>{S. S\<subseteq>q}" unfolding hstar_naive_def by blast
  then have "S\<^sub>p\<subseteq>p" "S\<^sub>q\<subseteq>q" by auto
  then have "S\<^sub>p\<^emph>S\<^sub>q\<subseteq>p\<^emph>q" using star_mono by simp
  then show "S\<in>{S. S\<subseteq>p\<^emph>q}" using \<open>S=S\<^sub>p\<^emph>S\<^sub>q\<close> by blast
qed

lemma "\<lbrakk>If Skip (Free x)\<rbrakk> = {(\<sigma>, \<sigma>)| \<sigma>. True}\<union>{((s, h), (s, fmap_update h (s x) hFrd))| s h n. fmap_lookup h (s x)=hOcc n \<and> s x\<noteq>0}"
  by (simp add: dsem_if dsem_free dsem_skip)

lemma "{(1, 2), (1, 3), (2, 4)}``{1::nat}={2,3}" by fastforce

lemma "{(s, h)::nstate| s h. s x=5}\<noteq>{}" by fast

lemma "{{\<sigma>\<^sub>1, \<sigma>\<^sub>2}}\<otimes>{{\<sigma>\<^sub>1, \<sigma>\<^sub>2'}}={{\<sigma>\<^sub>1, \<sigma>\<^sub>2, \<sigma>\<^sub>2'}}" unfolding join_def by force

end